{ͻ
                              UNIT MRE_MAIN                                 
 ͹
  Unit rsultant du fractionnement du programme principal de manire       
   ce que MRE ait la taille la plus petite possible durant un DOS Shell.   
 ͹
  Coded by Zuul as BouFFtou as Cheveau Frdric.                            
  Programm  Toulouse COG (Gendarmerie) sur Turbo Pascal v7.00.            
  Contact us on the NET : ZuulCoder@Hotmail.Com or Sybaris@Multimania.Com   
 ͼ}

UNIT MRE_MAIN;                           {*Nom de l'unit*}

{$Mode Objfpc}

Interface

Uses Dos,
     MosGraph,
     MosCrt,                            {*Unit CRT pour MOS*}
     MosStrings,
     MosCPUInstructions,
     MosDisks,
     MosConfig,
     MosBase,
     MosMouse,                            {*Gestion de la Souris*}
     MosGraphics,                            {*Gestion des Gfx*}
     MosTools,                            {*Gestion des Tools et Box*}
     MosImages,                            {*Gestion des BMPs*}
     MosGadgets,                            {*Gestion des Gadgets*}
     MosRequests,                            {*Gestion des Requesters*}
     MosDialogs,
     MosMenu,                            {*Gestion des Menus*}
     MosWindows,                            {*Gestion des Fentres*}
     MosDirectory,                            {*Gestion du Directory*}
     MosSystem,                            {*Gestion du Systme*}
     MosColors,
     MosTasks,
     MosSound,                            {*Gestion des Sons*}
     MosFiles,
     MosText,
     MosTime,
     MosColorDialogs,
     MosExecute,
     MRE_ITEMS,                          {*Gestion des Outils de MOS*}
     MRE_ACTS,                           {*Gestion Action des Boutons*}
     MRE_MENU;                           {*Gestion Cration des Menus*}

{************************ DEFINITION DES PROCEDURES *************************}

Procedure INIT_WINDOW0;
Procedure INIT_TABLEAUX_MENU(Var M:TMenu);
Function  ASKTOSAVE_CURRENT_PROJECT(Var M:TMenu):Boolean;
Procedure REINIT_ALL_WINDOW(Var M:TMenu);
Function  ADD_PROJECT(Var M:TMenu; Name:String):Byte;
Procedure MODIF_PROJECT(Var M:TMenu; Name:String);
Function  GET_PROJECT_NAME(Var M:TMenu; Num:Byte):String;
Function  LOAD_PROJECT(Var M:TMenu; Mode:Byte):Byte;
Procedure GENERATE_SOURCE;
Procedure DELETE_ITEMS(Var M:TMenu);
Procedure GET_ITEMS_INFO;
Procedure UNDO_ACTION(Var M:TMenu);     {*Undo Action*}
Procedure KILL_UNDO;
Procedure EDIT_IDCMP(Var M:TMenu);
Procedure EDIT_IDRES(Var M:TMenu);
Procedure EDIT_MISCELLANEOUS(Var M:TMenu);
Procedure SET_GRID(Var M:TMenu);
Procedure DEFINE_MAIN_PREFS;
Procedure DEFINE_SOURCE_PREFS;
Procedure TEST_ITEMS_WINDOW(Var M:TMenu);
Procedure INIT_MRE;                     {*Initialise MRE Constants*}
Procedure EXECUTE_PROGRAM;              {*Execute un Programme Externe*}
Procedure UPDATE_MENU_CENTER(Var M:TMenu);
Procedure ABOUT;
Procedure CENTER_GADGET(Dir:Byte; Var M:TMenu); {*Centrer Gadget en X*}
Procedure EDIT_LC;                      {*Edit Grid Line Columns*}
Procedure MRE_WELCOME;

Implementation

Uses
     SysUtils,
     MosErrors;

{ͻ
                             PROCEDURE WELCOME                              
 ͼ}

Procedure MRE_WELCOME;
Var W1            :TWindow;                 {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    But1          :TButton;             {*Buttons Structure*}
    Time          :TClock;              {*Timer*}
{SR}Ts            :String;              {*Array Strings*}
    Res           :Boolean;             {*Rsultat Chargement Config....*}
    V             :Byte;
    Path          :String;              {*Rpertoire o se trouve MRE.BMP*}
    D             :DirStr;              {*Pour FSplit*}
    N             :NameStr;
    E             :ExtStr;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Path:=FExpand(ParamStr(0));
FSplit(Path,D,N,E);                     {*Get Directory Programme Apellant*}

Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel   (004,005,264,189, CLBlack,BLLoweredLine,BLRaisedLine,Yes);
BMP_Show(009,007,264,188,0,0,Sys.GetPath(SP_IMAGES)+'CATBLACK.BMP',$0080);

Font_Set('ITAL.CHR',4);
Ts:=Language.Loc(598);
Display ( LaF*4,HaF*17,V+11,Str_Get(Ts,V,'|'));
Font_Set(Sys.FontMain,Sys.FontMainSize);
Button (LaF*37,164, LaF*13,-1, CLTextButton,CLBgButton,$0110,But1,'_OK');
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
//Res:=LOAD_MRE_CONFIG(M);                {*Load and Init MRE Constants*}
Res := TRUE;
If Res Then V:=1 Else V:=2;             {*1er ou 2eme Label...*}

If Not Win_Init(184,142,184+LaF*54,142+HaF*19+6,$5541,'',W1) Then Exit;
Win_Sup(100,50,250,200,79,60,639,479,0,CLLightGrey,$0877,W1);{*Supplement*}
Win_Draw(W1);                        {*Display Window*}

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No;                           {*Init Exit Flag*}
Time.Show:=No;                          {*Init Timer*}

Repeat
try
;
If Win_Ready(W1) Then                {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Exit_Flg:=Time_TestTimer(300,Time);  {*Exit After 5 Seconds...*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                {*Get Windows Evens*}
If Even=CMClosed Then Exit_Flg:=Yes;           {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=Yes;                     {*Exit Flag*}

Win_Done(W1);                        {*Close Window if Needs*}
End;

{ͻ
                         ABOUT AND REGISTERING INFO                         
 ͼ}

Procedure ABOUT;
Var NUM:Integer;
Begin
Num:=4;                                 {*Icne Information*}
Req_Dialog(Language.Loc(590),Language.Loc(591),Language.Loc(469),NUM);
MRE_WELCOME;
End;

{ͻ
                         UPDATE DU MENU CENTER X,Y                          
 ͼ}

Procedure UPDATE_MENU_CENTER(Var M:TMenu);
Var S1,S2:String[10];
Begin
Str(CGC_Pos,S1); Str(CGC_Qtt,S2);
Menu_Add(M,2,6,Language.Loc(886)+'  ('+S1+'/'+S2+')');
Str(CGL_Pos,S1); Str(CGL_Qtt,S2);
Menu_Add(M,2,7,Language.Loc(887)+'  ('+S1+'/'+S2+')'); {*Affiche Values in Menu...*}
End;

{ͻ
                    CENTRE EN X OU EN Y LE GADGET COURRANT                  
 ͼ}

Procedure CENTER_GADGET(Dir:Byte; Var M:TMenu); {*Centrer Gadget en X*}
Var I,Sm:Integer;
    WSx,WSy:Integer;
    WXm,WYm:Integer;                    {*Coord Milieu Segment*}
    CGC_Qtt2,CGL_Qtt2:Integer;

Begin
If Item=14 Then Exit;                   {*Pas en Mode Edition...*}
I:=Pos_ITM[NType];                      {*Indice du Gadget en Question...*}
If I<=0 Then Exit;                      {*Pas de Gadget Slectionn...*}

CREATE_UNDO(M);                         {*Cr un Fichier UNDO*}

CGC_Qtt2:=CGC_Qtt+1;
CGL_Qtt2:=CGL_Qtt+1;
WSx:=(W.X2-W.X1) Div CGC_Qtt2;          {*Partie du Segment...*}
WSy:=(W.Y2-W.Y1) Div CGL_Qtt2;
WXm:=WSx*CGC_Pos;
WYm:=WSy*CGL_Pos;

If (CGL_Inc) And (Dir=1) Then Inc(CGL_Pos); {*Borne les "Pos"...*}
If CGL_Pos>=CGL_Qtt2 Then CGL_Pos:=1;
If (CGC_Inc) And (Dir=0) Then Inc(CGC_Pos);
If CGC_Pos>=CGC_Qtt2 Then CGC_Pos:=1;

UPDATE_MENU_CENTER(M);                  {*Update les Menus Centrer X,Y*}

TOGGLE_ITEM(NType);                     {*Dsentoure l'Item*}

If Dir=0 Then                           {*Centrer en X...*}
   Case NType of                        {*Dtermine le Type du Gadget...*}
      1: Begin
         Sm:=TBU[I].SX Div 2;
         TBU[I].X1:=WXm-Sm;
         End;
      2: Begin
         Sm:=(TCY[I].B.B.X2-TCY[I].B.B.X1) Div 2;
         TCY[I].X1:=WXm-Sm;
         End;
      3: Begin
         Sm:=10;
         TRB[I].X1:=WXm-Sm;
         End;
      4: Begin
{         Sm:=(TSL[I].S.X2-TSL[I].S.X1) Div 2;}
         TSL[I].X1:=WXm-Sm-20; TSL[I].X2:=WXm+Sm-20;
         End;
      5: Begin
         Sm:=TCO[I].T.Siz Div 2;
         TCO[I].X1:=WXm-Sm;
         End;
      6: Begin
         Sm:=(TBB[I].X2-TBB[I].X1) Div 2;
         TBB[I].X1:=WXm-Sm; TBB[I].X2:=WXm+Sm;
         End;
      7: Begin
         Sm:=(TSB[I].X2-TSB[I].X1) Div 2;
         TSB[I].X1:=WXm-Sm; TSB[I].X2:=WXm+Sm;
         End;
      8: Begin
         Sm:=(2+VESA_TextWidth(TXT[I].Cin)) Div 2;
         TXT[I].X1:=WXm-Sm;
         End;
      9: Begin
         Sm:=(IMG[I].X2-IMG[I].X1) Div 2;
         IMG[I].X1:=WXm-Sm; IMG[I].X2:=WXm+Sm;
         End;
      End;

If Dir=1 Then                           {*Centrer en Y...*}
   Case NType of                        {*Dtermine le Type du Gadget...*}
      1: Begin
         Sm:=TBU[I].SY Div 2;
         TBU[I].Y1:=WYm-Sm;
         End;
      2: Begin
         Sm:=(TCY[I].B.B.Y2-TCY[I].B.B.Y1) Div 2;
         TCY[I].Y1:=WYm-Sm;
         End;
      3: Begin
         Sm:=(HaF+4) Div 2;
         TRB[I].Y1:=WYm-Sm;
         End;
      4: Begin
{         Sm:=(TSL[I].S.Y2-TSL[I].S.Y1) Div 2;}
         TSL[I].Y1:=WYm-Sm; TSL[I].Y2:=WYm+Sm;
         End;
      5: Begin
         Sm:=(HaF+4) Div 2;
         TCO[I].Y1:=WYm-Sm;
         End;
      6: Begin
         Sm:=(TBB[I].Y2-TBB[I].Y1) Div 2;
         TBB[I].Y1:=WYm-Sm; TBB[I].Y2:=WYm+Sm;
         End;
      7: Begin
         Sm:=(TSB[I].Y2-TSB[I].Y1) Div 2;
         TSB[I].Y1:=WYm-Sm; TSB[I].Y2:=WYm+Sm;
         End;
      8: Begin
         Sm:=(2+HaF) Div 2;
         TXT[I].Y1:=WYm-Sm;
         End;
      9: Begin
         Sm:=(IMG[I].Y2-IMG[I].Y1) Div 2;
         IMG[I].Y1:=WYm-Sm; IMG[I].Y2:=WYm+Sm;
         End;
      End;

REDRAW_WINDOW(M);                       {*Raffiche le Contenu de Window*}
TOGGLE_ITEM(NType);                     {*Rentoure l'Item*}
End;

{ͻ
                       EXECUTE UN PROGRAMME EXTERNE                         
 ͼ}

Procedure EXECUTE_PROGRAM;              {*Execute un Programme Externe*}
Var Cin:String;
    Num:Integer;
    FilSel,DirSel:String;
    Size:Longint;
Begin
Cin:=''; FilSel:=''; DirSel:='';
Num:=5;
Req_String(Language.Loc(461),Language.Loc(752),Language.Loc(753),256,350,Cin,Num);
If Num=1 Then Execute(Cin,'',$41FF);     {*Excute un Prog Standard*}
If Num=2 Then Execute_MOS(Cin,'');       {*Excute un Prog MOS*}
If Num=3 Then                            {*Browse*}
   Begin
   Req_FileManager(150,50,300,Language.Loc(855),'_OK','*.EXE',0,DirSel,FilSel,Size);
   If FilSel<>'' Then Execute_MOS(DirSel+FilSel,'');
   End;
End;

{ͻ
                        PROCEDURE INIT_TABLEAUX_MENU                        
 ͼ}

Procedure INIT_TABLEAUX_MENU(Var M:TMenu);
Const TL:Array[1..7] of Byte=(15,12,12,6,4,11,1);        {*Nb de Points de Menus*}
Const TP:Array[1..7] of Integer=(399,880,422,434,442,446,753);{*Num des LOC*}
Var A,B:Integer;                         {*For Loops*}

Begin
Menu_Clear(M);                           {*Clear Tableaux*}
For B:=1 to 7 do
   For A:=1 to TL[B] do Menu_Add(M,B,A,Language.Loc(TP[B]+A));

For A:=13 to 16 do Menu_Add(M,3,A,Language.Loc(1595+A));
Menu_Add(M,8,1,Language.Loc(458));                {*Initialise les Structures Menus*}
End;

{ͻ
                                ENLEVE LE "_"                               
  Enlve le "_" dans le 2eme nom quand le 1er en contient un.               
 ͼ}

Function GET_EPURED_STRING(N1,N2:String):String;
Begin
If (Pos('_',N1)>0) And (Pos('_',N2)>0) Then
   Delete(N2,Pos('_',N2),1);
GET_EPURED_STRING:=N2;
End;

{ͻ
                   AJOUTE UN PROJET DANS LE MENU "PROJET"                   
  Renvois le numro du projet dans la liste.                                
 ͼ}

Function ADD_PROJECT(Var M:TMenu; Name:String):Byte;
Var St,St1:String;
Var FD:DirStr;
    FN:NameStr;
    FE:ExtStr;
    A :Integer;

Begin
ADD_PROJECT:=Num_Pro;                   {*De Base pas dfinit*}
If Qtt_Pro=Max_Menu_Points-1 Then Exit; {*Max de Projets Atteints*}
FSplit(Name,FD,FN,FE);
St:=FN+' - '+GET_EPURED_STRING(Name,Name_Proc);
St1:=St;
For A:=2 to Max_Menu_Points do
   If St1=M.TbMen[7,A] Then Begin
      ADD_PROJECT:=A-1;                 {*Send Numro du Projet*}
      Exit;                             {*Point de Menu Existe dja*}
      End;
Inc(Qtt_Pro);
ADD_PROJECT:=Qtt_Pro-1;                 {*Send Numro du Projet*}
Menu_Add(M,7,Qtt_Pro,'00 '+St);         {*1 Projet de plus ds Fentre*}
End;

{ͻ
               MODIFIE LE NOM D'UN PROJET DANS LE MENU "PROJET"             
 ͼ}

Procedure MODIF_PROJECT(Var M:TMenu; Name:String);
Var St:String;
    FD:DirStr;
    FN:NameStr;
    FE:ExtStr;
    ONf,NN:String;                       {*Old and New File Name...*}
    Fil1:Text;

Begin
If Qtt_Pro<=1 Then Exit;                {*Pas Encore de Projets...*}
ONf:=GET_PROJECT_NAME(M,Num_Pro)+'.TMP';
FSplit(Name,FD,FN,FE);
NN:=FN+'.TMP';
St:=FN+' - '+GET_EPURED_STRING(Name,Name_Proc);

If ONf<>NN Then                         {*Rename Old Project TMP to New Name*}
   Begin
   Assign(Fil1,ONf);
   Rename(Fil1,NN);
   End;

Menu_Add(M,7,Num_Pro+1,'00 '+St);       {*New Name for Project*}
End;

{ͻ
                    EXTRACT PROJECT NAME in menu "PROJET"                   
 ͼ}

Function GET_PROJECT_NAME(Var M:TMenu; Num:Byte):String;
Var St:String;
    P1,P2:Integer;
Begin
Inc(Num);                               {*Car 1 = Title Menu*}
GET_PROJECT_NAME:='';
If (Num<2) Or (Num>Qtt_Pro) Then Exit;  {*En Dehors du Menu*}
St:=M.TbMen[7,Num];                     {*Get Label Project Name*}

P1:=Pos(' - ',St);
If P1>0 Then Begin
   St:=Copy(St,1,P1-1);
   P2:=M.TbKey[7,Num];                  {*Insert Underscore ?*}
   If (P2>0) And (P2<=Length(St)) Then Insert('_',St,P2);
   GET_PROJECT_NAME:=St;                {*Send Result*}
   End;
End;

{ͻ
                     INITIALISE MRE ET LOAD MRE CONFIG                      
 ͼ}

Procedure INIT_MRE;                     {*Initialise MRE Constants*}
Var A:Integer;
    P1:String;
Begin
Name_Prog:='TEST_NUMERO_1';             {*Dnominations de Bases*}
Name_Proc:='REQUESTER_001';
Gen_Prog:=Yes;                           {*Gnration Programme Entier*}
Gen_Rem:=Yes;                            {*Gnration Remarques*}
Gen_Menu:=No;                          {*Gnration Menu*}
Opt_Source:=True;                       {*Optimize Source*}
Rel_PWin:=Yes;                          {*Window In Relative Pos*}
Rel_Px:=30;                             {*Relative PX*}
Rel_Py:=20;                             {*Relative Py*}
Perso_Init:=No;                         {*Pas d'Init Personelles*}
Perso_Done:=No;                         {*Pas de Done Personnelles*}
Gen_Forp:=1;                            {*Generate Procedure=1*}
Gen_Cancel:=No;                         {*Generate Source "Cancel" No*}
Max_Lines:=8;                           {*Nb Max de Lignes d'Init et Done de Code*}
For A:=1 to Max_Lines do                {*Init and Done Code*}
   Begin
   Init_Code[A]:='';
   Done_Code[A]:='';
   End;
CGL_Qtt:=1;                             {*Qtt de Lignes pour Split*}
CGL_Pos:=1;                             {*Pos Actuelle dans Lignes*}
CGL_Inc:=No;                            {*Incrments des Lignes ? 1=Yes*}
CGC_Qtt:=1;                             {*Qtt de Colonnes pour Split*}
CGC_Pos:=1;                             {*Pos Actuelle dans Colonnes*}
CGC_Inc:=Yes;                           {*Incrments des Colonnes ? 1=Yes*}

Func_Type:=9;                           {*Type Renvoy par Fonction = String*}
Show_Report:=True;                      {*Show Report when save Source*}
Full_Simul:=True;                       {*Full Simulation when Message*}
Conf_Del:=True;                         {*Confirm Item Deletion*}
Item:=15;                               {*Gadget 15 = Window Tested Now*}
Has_Changed:=$0;                        {*Pas de Changements de Base*}
Gad_Exist:=Yes;                         {*Gadgets Affichs de Base*}
Disp_Beep:=Yes;                         {*No Display Beep onBeep_Modulosages*}
Show_MCoo:=No;                          {*Display Mouse Position*}
Sys.SetGrid:=False;                            {*Pas de Grille Gnrale*}
My_Grid:=True;                          {*Grille Personnelle On*}
Sys.GridStepX:=10; Sys.GridStepY:=5;                  {*Offsets Grid*}
NUndo:=1;                               {*Numro de l'Undo*}
Qtt_Pro:=1;                             {*Quantit de Projets ds la Fentre*}
Num_Pro:=1;                             {*Numro du Projet Actuel*}

Load_External:=False;
P1:='-LOAD';
If (ParameterMOS(P1)>0) Then               {*Get nom du Projet en Externe*}
   If P1<>'' Then
      Begin
      Nom_Undo:=P1;
      Load_External:=True;
      End;

Proc_Name:='PROC_001;';                 {*Name of the Procdure to Call*}

QTT_TO_0;                               {*Quantit de Chaque Outils*}
POS_TO_0;                               {*Positions de Chaque Outils*}

For A:=1 to Max_Menu-3 do               {*Nombre de Menus et Labels ds Menu*}
   Qtt_MenuP[A]:=1;
Qtt_Menu:=1;
Menu_Clear(Menu);                       {*Nettoie le menu de Test*}
End;

{ͻ
                        SUPRESSION DU FICHIER UNDO                          
 ͼ}

Procedure KILL_UNDO;
Var Fil:Text;                           {*Fichier UNDO*}
Begin
Assign(Fil,'MRE.U00');
If File_TestExist('MRE.U00') Then Erase(Fil);   {*Vire File UNDO*}
End;

{ͻ
                      GENERATION DE LA SOURCE POUR TP7                      
 ͼ}

Procedure GENERATE_SOURCE;
Var DirSel,FilSel:String;
    Size         :Longint;
    F,F1         :Text;
    S1,S2,S3,                           {*Pour String Gestion*}
    S5,S6,S7,S8,
    SB           :String;
    NUM,A,B      :Integer;
    Offset       :String[10];           {*Pour Completter Ligne*}
    InRem        :Boolean;              {*On est  l'Interieur d'un Rem*}
    X1,Y1        :String[16];           {*Pour Rajouter W.X1, etc*}
    Ind          :String[16];           {*Pour Rajouter Indentation if TWindow Exist*}
    VarDef       :Word;                 {*Bits Variables Dfinis*}
    DF           :DirStr;               {*Pour FSplit Generate PROG.INI*}
    NF           :NameStr;
    EF           :ExtStr;
    Tit          :Integer;              {*Si Title Absent*}
{SR}Ast          :String;               {*Split a String into Components*}
    St_GMB       :String;               {*Optimisations*}

{********************** WRITE GADGET InputText DEFINITION *********************}

Procedure WRITE_GADGET_COMMAND(Pos:Integer);
Begin
S6:='$'+Str_L2H(TCO[Pos].T.Id,4);
Writeln(F,'InputText(',X1,TCO[Pos].X1 Div LaF,'+',TCO[Pos].X1 Mod LaF,
                 ',',Y1,(TCO[Pos].Y1-Tit) Div HaF,'+',(TCO[Pos].Y1-Tit) Mod HaF,
                 ',LaF*',TCO[Pos].T.Siz Div LaF,'+',TCO[Pos].T.Siz Mod LaF,
                 ',',TCO[Pos].T.Len,',',TCO[Pos].T.CoB,',',TCO[Pos].T.Co2,
                 ',',TCO[Pos].T.Sty,',',S6,',Com',Pos,',Cin',Pos,');');
End;

{***************** OBTENTION DU STRING DE TEST DU BOUTON ********************}

Procedure GET_BUTTON_ACTION(Pos:Integer);
Var Up,Stx,StB:String;
Begin
Str(Pos,Stx);
Str(TBU[Pos].MoA,StB);
St_GMB:='If Button_GetMsg(But'+Stx+','+StB+')=CMSelected Then '; {*Optimisations*}

Case TBU[Pos].Action of                      {*What Action to do ?*}
     0 : S1:=';';
     1 : S1:='XOk:=Yes;';
     2 : S1:='XCancel:=Yes;';
     4 : S1:=Proc_Name;
     30: Begin
         If REzV.BCenter=Yes Then Up:='#0' Else Up:='';
         Writeln(F,Ind,St_GMB,'Begin');
         Writeln(F,'      Num:=',REzV.NumIco,';');
         Writeln(F,'      Req_Dialog(''',REzV.Title,''',''',Up+REzV.Phrase,''',''',REzV.Gadget,''',Num);');
         If REzV.TestRes=Yes Then Writeln(F,'      If Num=1 Then Else;');
         Writeln(F,'      End;');
         End;
     31: Begin
         Writeln(F,Ind,St_GMB,Chr(13),
         '      Req_Font(',RFntV.X1,',',RFntV.Y1,',''',RFntV.Name,''',FontT,FontS);');
         End;
     32: Begin
         If RStV.BCenter=Yes Then Up:='#0' Else Up:='';
         Writeln(F,Ind,St_GMB,'Begin');
         Writeln(F,'      Num:=',RStV.NumIco,';');
         Writeln(F,'      Req_String(''',RStV.Name,''',''',Up+RStV.Txt,''',''',
                RStV.Gad,''',',RStV.NbChar,',',RStV.Size,',Str1,Num);');
         If RStV.TestRes=True Then Writeln(F,'      If Num=1 Then Else;');
         Writeln(F,'      End;');
         End;
     33: Begin
         If RVaV.BCenter=Yes Then Up:='#0' Else Up:='';
         Writeln(F,Ind,St_GMB,'Begin');
         Writeln(F,'      Num:=',RVaV.NumIco,';');
         Writeln(F,'      Req_Value(''',RVaV.Name,''',''',Up+RVaV.Txt,''',''',
                RVaV.Gad,''',',RVaV.BMin,',',RVaV.BMax,',Val1,Num);');
         If RVaV.TestRes=True Then Writeln(F,'      If Num=1 Then Else;');
         Writeln(F,'      End;');
         End;
     34: Begin
         Writeln(F,Ind,St_GMB,Chr(13),
         '      Req_Palette(',RPalV.X1,',',RPalV.Y1,',''',RPalV.Name,''',0,Num);');
         End;
     35: Begin
         Writeln(F,Ind,St_GMB,Chr(13),
         '      Req_Memory(',RMemV.X1,',',RMemV.Y1,',''',RMemV.Name,''');');
         End;
     36: Begin
         Writeln(F,Ind,St_GMB,Chr(13),
         '      Req_Hardware(',RHardV.X1,',',RHardV.Y1,',''',RHardV.Name,''');');
         End;
     37: Begin
         Writeln(F,Ind,St_GMB,'Begin');
         Writeln(F,'      CountP:=0;');
         Writeln(F,'      Repeat');
         Writeln(F,'      Str(CountP,CountS);');
         Writeln(F,'      Req_Progress(''',RProV.Name,''',''',RProV.Explain,' ''+CountS,CountP,',RProV.Cob,',Pro1);');
         Writeln(F,'      Delay(15); Inc(CountP);');
         Writeln(F,'      Until (Pro1.Abort) Or (CountP>100);');
         Writeln(F,'      End;');
         End;

     38: Begin
         Writeln(F,Ind,St_GMB,'Begin',Chr(13),
         '      DirSel:=''''; FilSel:='''';',Chr(13),'      Req_FileManager(',
         RFileV.X1,',',RFileV.Y1,',',RFileV.Sv,',''',RFileV.Name,''',''',RFileV.OkBut,
         ''',''',RFileV.Mask,''',',RFileV.Style,',DirSel,FilSel,Size);');

         If RFileV.SendToCom=True Then Begin {*Send Results to Commands*}
            If (RFileV.FPath=RFileV.FName) And (RFileV.FName>0) Then Begin
               Write(F,'      Cin',RFileV.FPath,':=DirSel+FilSel; ');
               WRITE_GADGET_COMMAND(RFileV.FPath);
               End Else
               Begin
               If RFileV.FPath>0 Then Begin
                  Write(F,'      Cin',RFileV.FPath,':=DirSel; ');
                  WRITE_GADGET_COMMAND(RFileV.FPath); End;
               If RFileV.FName>0 Then Begin
                  Write(F,'      Cin',RFileV.FName,':=FilSel; ');
                  WRITE_GADGET_COMMAND(RFileV.FName); End;
               If RFileV.FSize>0 Then Begin
                  Write(F,'      Str(Size,Cin',RFileV.FSize,'); ');
                  WRITE_GADGET_COMMAND(RFileV.FSize); End;
               End;
            End;
         Writeln(F,'      End;');
         End;
     39: Begin
         Writeln(F,Ind,St_GMB,Chr(13)+
         '      Req_Attrib(',RAttrV.X1,',',RAttrV.Y1,',''',RAttrV.Name,''');');
         End;
     40: Begin
         Writeln(F,Ind,St_GMB,Chr(13)+'      Req_Register;');
         End;
     60: Begin
         Writeln(F,Ind,St_GMB,Chr(13)+
         '      Sys_Request(',RSysV.X1,',',RSysV.Y1,',''',RSysV.Name,''');');
         End;
     61..96: Begin
         Writeln(F,Ind,St_GMB,Chr(13)+'      Call_System(''-MSA=',TBU[Pos].Action,
                                      ' -WPX=',RExt[Pos].X1,' -WPY=',RExt[Pos].Y1,''');');
         End;
     Else S1:=';';                           {*Si Error...*}
   End;

If TBU[Pos].Action<=5                        {*Write Button Test*}
   Then Writeln(F,Ind,St_GMB,S1);
End;

{***************************** CODE PRINCIPAL *******************************}

Begin
DirSel:='';                             {*Directory Courrant*}
FilSel:=Copy(Save_FileName,1,Length(Save_FileName)-3)+'PAS';
Req_FileManager(50,32,282,Language.Loc(459),Language.Loc(460),'*.PAS',0,DirSel,FilSel,Size);

If File_TestExist(DirSel+FilSel) Then Begin
   Num:=3;                              {*Icne Question*}
   Req_Dialog(Language.Loc(461),Language.Loc(462),Language.Loc(463),Num);
   If Num<>1 Then Exit;                 {*Fichier dja Existant !!!*}
   End;

If FilSel<>'' Then Begin
   Assign(F,DirSel+FilSel);
   {$I-}
   Rewrite(F);                          {*Crate File*}
   {$I+}
   If IOResult=0 Then Begin             {*No Errors ? => Ok !*}
      Mse_SetPointer(MPBusy);           {*TPointer Occup*}
      FSplit(DirSel+FilSel,DF,NF,EF);   {*Gnrate .INI*}
      If Gen_Prog Then Save_Config(DF+NF+'.INI');

      {==== WRITE PROG ENTETE ====}

      X1:=' LaF*'; Y1:=' HaF*';{ X2:=' LaF*'; Y2:=' HaF*'; }Ind:='   ';

      Tit:=-4;                          {*Pas de Titre => Dcalage...*}
      If W.IDCMP And $80=$80 Then Tit:=HaF1;

{      If Win_Exist Then Begin X1:=' W1.X1+LaF*'; Y1:=' W1.Y1+HaF1+HaF*';X2:=' W1.X2+LaF*';Y2:=' W1.Y2+HaF*'; Ind:='   '; End
                   Else Begin X1:=''; Y1:='';X2:='';Y2:=''; Ind:=''; End;}

      If Gen_Prog=True Then Begin       {*Dbut Gnration Program*}
      If Odd(Length(Name_Prog))=False Then Offset:=' ' Else Offset:='';
      Writeln(F,Language.Loc(774));
      Writeln(F,' ',Copy(Esp,1,36-Length(Name_Prog) Div 2),Name_Prog,Copy(Esp,1,38-Length(Name_Prog) Div 2),Offset,'');
      For A:=1 to 2 do Writeln(F,Language.Loc(774+A));
      Writeln(F,Language.Loc(775));
      For A:=1 to 4 do Writeln(F,Language.Loc(776+A));
      Writeln(F);
      Writeln(F,Language.Loc(781));
      Writeln(F);
      Writeln(F,'Program ',Name_Prog,';',Copy(Esp,1,31-Length(Name_Prog)),Language.Loc(782));
      Writeln(F);

      {==== Gnration des USES ====}

      For A:=1 to 10 do Writeln(F,Language.Loc(782+A));
      Writeln(F);
      End;                              {*Fin Gnration Program*}

      {==== WRITE PROCEDURE ====}

      If Odd(Length(Name_Proc))=False Then Offset:=' ' Else Offset:='';
      Writeln(F,Language.Loc(774));
      Writeln(F,' ',Copy(Esp,1,36-(Length(Name_Proc)+10) Div 2),'PROCEDURE ',Name_Proc,
                     Copy(Esp,1,38-(Length(Name_Proc)+10) Div 2),Offset,'');
      Writeln(F,Language.Loc(780));
      Writeln(F);

      If Rel_PWin Then S1:='(Px,Py:Integer)'    {*Fentre En Pos Relative*}
                  Else S1:='';

{SR}{ Str_Split(Language.Loc(854),'|',Ast);}           {*Split Language.Loc(854) for Function*}
      Ast:=Language.Loc(854);
      If Gen_Forp=1
         Then Begin S2:='Procedure '; S3:=''; End {*Generate Procedure / Function*}
         Else Begin S2:='Function '; S3:=':'+Midder(Str_Get(Ast,Func_Type,'|')); End;
      Writeln(F,S2,Name_Proc,S1,S3,';');
      For A:= 1 to 3 do Writeln(F,Language.Loc(795+A));

      If Gen_Menu=TRUE Then Writeln(F,Language.Loc(800));
      If Qtt_ITM[1]>0 Then Write(F,'    ');     {*Write Buttons Var*}

      For A:=1 to Qtt_ITM[1] do Begin
         Write(F,'But',A); If A<Qtt_ITM[1] Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_ITM[1]) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_ITM[1]>0 Then Begin
         If Qtt_ITM[1] Mod 3=0 Then S1:=''
                            Else S1:=Copy(ESP,1,5*(3-Qtt_ITM[1] Mod 3));
         Writeln(F,S1,Language.Loc(801));
         End;

      If Qtt_ITM[2]>0 Then Write(F,'    ');     {*Write Cyclers Var*}
      For A:=1 to Qtt_ITM[2] do Begin
         Write(F,'Cyc',A); If A<Qtt_ITM[2] Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_ITM[2]) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_ITM[2]>0 Then Begin
         If Qtt_ITM[2] Mod 3=0 Then S1:=''
                            Else S1:=Copy(ESP,1,5*(3-Qtt_ITM[2] Mod 3));
         Writeln(F,S1,Language.Loc(802));
         End;

      If Qtt_ITM[3]>0 Then Write(F,'    ');     {*Write Radios Var*}
      For A:=1 to Qtt_ITM[3] do Begin
         Write(F,'Rad',A); If A<Qtt_ITM[3] Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_ITM[3]) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_ITM[3]>0 Then Begin
         If Qtt_ITM[3] Mod 3=0 Then S1:=''
                            Else S1:=Copy(ESP,1,5*(3-Qtt_ITM[3] Mod 3));
         Writeln(F,S1,Language.Loc(803));
         End;

      If Qtt_ITM[4]>0 Then Write(F,'    ');     {*Write Sliders Var*}
      For A:=1 to Qtt_ITM[4] do Begin
         Write(F,'Sld',A); If A<Qtt_ITM[4] Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_ITM[4]) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_ITM[4]>0 Then Begin
         If Qtt_ITM[4] Mod 3=0 Then S1:=''
                            Else S1:=Copy(ESP,1,5*(3-Qtt_ITM[4] Mod 3));
         Writeln(F,S1,Language.Loc(804));
         End;

      If Qtt_ITM[5]>0 Then Write(F,'    ');     {*Write Commands Var*}
      For A:=1 to Qtt_ITM[5] do Begin
         Write(F,'Com',A); If A<Qtt_ITM[5] Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_ITM[5]) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_ITM[5]>0 Then Begin
         If Qtt_ITM[5] Mod 3=0 Then S1:=''
                            Else S1:=Copy(ESP,1,5*(3-Qtt_ITM[5] Mod 3));
         Writeln(F,S1,Language.Loc(805));
         End;

      If Qtt_ITM[5]>0 Then Write(F,'    ');     {*Write Commands Strings*}
      For A:=1 to Qtt_ITM[5] do Begin
         Write(F,'Cin',A); If A<Qtt_ITM[5] Then Write(F,',');
         If (A Mod 3=0) And (A<Qtt_ITM[5]) Then Begin
            Writeln(F); Write(F,'    ');
            End;
         End;
      If Qtt_ITM[5]>0 Then Begin
         If Qtt_ITM[5] Mod 3=0 Then S1:=''
                            Else S1:=Copy(ESP,1,5*(3-Qtt_ITM[5] Mod 3));
         Writeln(F,S1,Language.Loc(806));
         End;

      {==== WRITE VAR REQUESTERS SPE ====}

      VarDef:=0;
      For A:=1 to Qtt_ITM[1] do Begin    {*Dfinition Var Req Called par Button*}
{      If (TBU[A].Action=11) And (VarDef And $800<>$800) Then Syb debugguage}
      If (TBU[A].Action=38) And (VarDef And $800<>$800) Then
         Begin
         Writeln(F,Language.Loc(807));
         Writeln(F,'    Size          :Longint;');
         VarDef:=VarDef Or $800;
         End;
      If ((TBU[A].Action=30) Or (TBU[A].Action=32) Or (TBU[A].Action=33) Or (TBU[A].Action=34))
         And (VarDef And $80<>$80) Then Begin
         Writeln(F,Language.Loc(808));
         VarDef:=VarDef Or $80; End;
      If (TBU[A].Action=4) And (VarDef And $100<>$100) Then Begin
         Writeln(F,Language.Loc(809));
         VarDef:=VarDef Or $100; End;
      If (TBU[A].Action=5) Then Writeln(F,Language.Loc(810));
      If (TBU[A].Action=6) Then Writeln(F,Language.Loc(811));
      If (TBU[A].Action=10) Then Begin
         Writeln(F,Language.Loc(812));
         Writeln(F,'    CountP        :Byte;');
         Writeln(F,'    CountS        :String[10];');
         End;
      End;
      If Gen_Menu Then
         Writeln(F,Language.Loc(813));

      {==== Genration de l'initialisation des Menus ====}

      If Gen_Menu Then Begin
      Writeln(F);
      Writeln(F,Language.Loc(814));
      Writeln(F);
      Writeln(F,'Procedure DECLARE_MENU;');
      Writeln(F,'Begin');
      Writeln(F,Language.Loc(815));
      Writeln(F,'');
      For A:=1 to Qtt_Menu do
         For B:=1 to Qtt_MenuP[A]+1 do
            Writeln(F,'Menu_Add(Menu,',A,',',B,',''00 ',Menu.TbMen[A,B],''');');
      Writeln(F,'End;');
      End;

      {==== Write Perso Initialisations ====}

      If Perso_Init Then
         Begin
         Writeln(F);
         Writeln(F,Language.Loc(793));
         Writeln(F);
         Writeln(F,'Procedure ',Name_Proc,'_INIT;');
         For A:=1 to Max_Lines do
            If Init_Code[A]<>'' Then Writeln(F,Init_Code[A]);
         End;

      {==== Write Perso Terminaisons ====}

      If Perso_Done Then
         Begin
         Writeln(F);
         Writeln(F,Language.Loc(794));
         Writeln(F);
         Writeln(F,'Procedure ',Name_Proc,'_DONE;');
         For A:=1 to Max_Lines do
            If Done_Code[A]<>'' Then Writeln(F,Done_Code[A]);
         End;

      {==== Write REDRAW_FRAME ====}

      Writeln(F);
      Writeln(F,Language.Loc(816));
      Writeln(F);
      Writeln(F,Language.Loc(817));
      Writeln(F,'Begin');
      Writeln(F,Language.Loc(818));
      For A:=1 to Qtt_ITM[7] do Begin            {*Write String Boxes*}
         If TSB[A].Cave=True Then S7:='Yes' Else S7:='No';
         Writeln(F,'Bevel (',X1,TSB[A].X1 Div LaF,'+',TSB[A].X1 Mod LaF,
                             ',',Y1,(TSB[A].Y1-Tit) Div HaF,'+',(TSB[A].Y1-Tit) Mod HaF,
                             ',',X1,TSB[A].X2 Div LaF,'+',TSB[A].X2 Mod LaF,
                             ',',Y1,(TSB[A].Y2-Tit) Div HaF,'+',(TSB[A].Y2-Tit) Mod HaF,
                             ',',TSB[A].Co,', BLLoweredLine,BLRaisedLine,Yes);');
         End;
      For A:=1 to Qtt_ITM[6] do Begin            {*Write Bevel component*}
         If TBB[A].Cave=True Then S7:='Yes' Else S7:='No';
         If TBB[A].Fill=True Then S8:='Yes' Else S8:='No';
         Writeln(F,'Bevel (',X1,TBB[A].X1 Div LaF,'+',TBB[A].X1 Mod LaF,
                        ',',Y1,(TBB[A].Y1-Tit) Div HaF,'+',(TBB[A].Y1-Tit) Mod HaF,
                        ',',X1,TBB[A].X2 Div LaF,'+',TBB[A].X2 Mod LaF,
                        ',',Y1,(TBB[A].Y2-Tit) Div HaF,'+',(TBB[A].Y2-Tit) Mod HaF,
                        ',',{TBB[A].Style,',',}TBB[A].Co,',',BLRaisedLine,BLNoLine,Yes,{S7,',',S8,}');');
         End;
      For A:=1 to Qtt_ITM[9] do Begin            {*Write Icon / Images*}
         If IMG[A].IType=0 Then Begin            {*C'est une Icne*}
            Writeln(F,'Show_Icon(',X1,IMG[A].X1 Div LaF,'+',IMG[A].X1 Mod LaF,','
                                  ,Y1,(IMG[A].Y1-Tit) Div HaF,'+',(IMG[A].Y1-Tit) Mod HaF,',''',IMG[A].FName,''');');
            End Else Begin                       {*C'est une BMP*}
            If IMG[A].Use_Pal Then S7:='$A0' Else S7:='$80';
            Writeln(F,'BMP_Show(',X1,IMG[A].X1 Div LaF,'+',IMG[A].X1 Mod LaF,','
                                 ,Y1,(IMG[A].Y1-Tit) Div HaF,'+',(IMG[A].Y1-Tit) Mod HaF,','
                                 ,X1,IMG[A].X2 Div LaF,'+',IMG[A].X2 Mod LaF,','
                                 ,Y1,(IMG[A].Y2-Tit) Div HaF,'+',(IMG[A].Y2-Tit) Mod HaF,','
                                 ,X1,IMG[A].Ox Div LaF,'+',IMG[A].Ox Mod LaF,','
                                 ,Y1,IMG[A].Oy Div LaF,'+',IMG[A].Oy Mod LaF,','''
                                 ,IMG[A].FName,''',',S7,');');
            End;
         End;
      For A:=1 to Qtt_ITM[8] do Begin            {*Write Texts*}
         Writeln(F,'Text(',X1,TXT[A].X1 Div LaF,'+',TXT[A].X1 Mod LaF,
                        ',',Y1,(TXT[A].Y1-Tit) Div HaF,'+',(TXT[A].Y1-Tit) Mod HaF,
                        ',',TXT[A].CB,',',TXT[A].CP,',''',TXT[A].Cin,''');');
         End;
      Writeln(F);                                {*Saut de Ligne*}

      For A:=1 to Qtt_ITM[1] do Begin            {*Write Buttons*}
         S6:='$'+Copy(Str_L2H(TBU[A].B.Id,4),3,2);
         S7:=TBU[A].B.TCT[1];
         If TBU[A].VanillaKey<>0 Then Insert('_',S7,TBU[A].VanillaKey);
         Write(F,'Button(',X1,TBU[A].X1 Div LaF,'+',TBU[A].X1 Mod LaF,
                       ',',Y1,(TBU[A].Y1-Tit) Div HaF,'+',(TBU[A].Y1-Tit) Mod HaF,
                       ', LaF*',TBU[A].SX Div LaF,'+',TBU[A].SX Mod LaF);
         If TBU[A].Sy=Syb Then Write(F,',-1, ')
                          Else Write(F,', HaF*',TBU[A].Sy Div HaF,'+',TBU[A].Sy Mod HaF,', ');
                      Writeln(F, TBU[A].B.Font.PenColor,',',TBU[A].B.Font.BgColor,',',S6,',But',A,',''',S7,''');');
         End;
      For A:=1 to Qtt_ITM[2] do Begin           {*Write Cyclers*}
         S8:='$'+Copy(Str_L2H(TCY[A].B.Id,4),3,2);
         Writeln(F,'Cycler(',X1,TCY[A].X1 Div LaF,'+',TCY[A].X1 Mod LaF,
                         ',',Y1,(TCY[A].Y1-Tit) Div HaF,'+',(TCY[A].Y1-Tit) Mod HaF,
                        ',LaF*',TCY[A].SX Div LaF,'+',TCY[A].SX Mod LaF,',Cyc',A,'.CyclVal,',
                        TCY[A].B.B.Font.PenColor,',',TCY[A].B.B.Font.BgColor,',',S8,',Cyc',A,',''',TCY[A].Cin,''');');
         End;
      For A:=1 to Qtt_ITM[3] do Begin           {*Write Radios*}
         S8:='$'+Copy(Str_L2H(TRB[A].R.IDCMP,4),3,2);
         Writeln(F,'RadioBox(',X1,TRB[A].X1 Div LaF,'+',TRB[A].X1 Mod LaF,
                            ',',Y1,(TRB[A].Y1-Tit) Div HaF,'+',(TRB[A].Y1-Tit) Mod HaF,
                            ',',TRB[A].R.Style,',',S8,',',TRB[A].R.Group,
                            ',',TRB[A].R.PLab,',Rad',A,'.Status,Rad',A,',''',TRB[A].R.Cin,''');');
         End;
      For A:=1 to Qtt_ITM[4] do Begin           {*Write Sliders*}
{         If TSL[A].S.GDep=True Then S8:='Yes' Else S8:='No';
         Writeln(F,'Slider(',X1,TSL[A].X1 Div LaF,'+',TSL[A].X1 Mod LaF,
                         ',',Y1,(TSL[A].Y1-Tit) Div HaF,'+',(TSL[A].Y1-Tit) Mod HaF,
                         ',',X1,TSL[A].X2 Div LaF,'+',TSL[A].X2 Mod LaF,
                         ',',Y1,(TSL[A].Y2-Tit) Div HaF,'+',(TSL[A].Y2-Tit) Mod HaF,
                         ',',TSL[A].S.Qtt,',',TSL[A].S.Aff,',',TSL[A].S.Typ,',',S8,',Sld',A,',Sld',A,'.Psl);');}
         End;
      For A:=1 to Qtt_ITM[5] do WRITE_GADGET_COMMAND(A);    {*Write Commands*}

      Writeln(F,Language.Loc(819));
      Writeln(F,'End;');                        {*Fin Procdure Init*}
      Writeln(F);

      Writeln(F,Language.Loc(820));
      Writeln(F);
      Writeln(F,'Begin');
                                                {*Init Window*}
      S5:='$'+Str_L2H(W.IDCMP,4);

      If Rel_PWin                               {*Fentre En Pos Relative*}
         Then Writeln(F,'Win_Init(Px,Py,Px+LaF*',(W.X2-W.X1) Div LaF,'+',
                (W.X2-W.X1) Mod LaF,',Py+HaF1+HaF*',(W.Y2-W.Y1-HaF1) Div HaF,'+',
                (W.Y2-W.Y1-HaF1) Mod HaF,',',S5,',',Chr(39),W.Name,Chr(39),',W1);')
         Else Writeln(F,'Win_Init(',W.X1,',',W.Y1,',',W.X1,'+LaF*',(W.X2-W.X1) Div LaF,'+',
                (W.X2-W.X1) Mod LaF,',',W.Y1,'+HaF1+HaF*',(W.Y2-W.Y1-HaF1) Div HaF,'+',
                (W.Y2-W.Y1-HaF1) Mod HaF,',',S5,',',Chr(39),W.Name,Chr(39),',W1);');

      SB:='$'+Str_L2H(W.IDRES,4);
      Writeln(F,'Win_Sup(',W.Xu,',',W.Yu,',',W.Xv,',',W.Yv,',',
              W.XMin,',',W.YMin,',',W.XMax,',',W.YMax,',',W.BarSld,',',W.Coul,',',SB,Language.Loc(821));
      For A:=1 to 2 do Writeln(F,Language.Loc(821+A));
      Writeln(F);

      VarDef:=0;
      For A:=1 to Qtt_ITM[1] do Begin                  {*Init String Requester*}
         If (TBU[A].Action=5) And (VarDef And $100<>$100) Then Begin
            Writeln(F,'Str1:=''',RStV.Str,''';');
            VarDef:=VarDef Or $100; End;            {*Init Value Requester*}
         If (TBU[A].Action=6) And (VarDef And $200<>$200) Then Begin
            Writeln(F,'Val1:=',RVaV.Vai,';');
            VarDef:=VarDef Or $200; End;
         End;
      For A:=1 to Qtt_ITM[2] do                        {*Init Cyclers Positions*}
         Writeln(F,'Cyc',A,'.CyclVal:=',{TCY[A].B.CyclVal}'1',';');
      For A:=1 to Qtt_ITM[3] do                        {*Init Radios Positions*}
         Writeln(F,'Rad',A,'.Status:=',TRB[A].R.Status,';');
(*      For A:=1 to Qtt_ITM[4] do                        {*Init Sliders Positions*}
         Writeln(F,'Sld',A,'.Psl:=',TSL[A].S.Psl,';');*)
      For A:=1 to Qtt_ITM[5] do                        {*Init Commands Labels*}
         Writeln(F,'Cin',A,':=''',TCO[A].T.Cin,''';');
      If (Qtt_ITM[2]>0) Or (Qtt_ITM[3]>0) Or (Qtt_ITM[4]>0) Or (Qtt_ITM[5]>0) Then Writeln(F);{*Saute Ligne*}

      If Perso_Init Then Writeln(F,Name_Proc,'_INIT;');
      If Gen_Menu Then Writeln(F,Language.Loc(824));         {*Pour Initialiser le Menu*}
      For A:=1 to 2 do Writeln(F,Language.Loc(824+A));
      Writeln(F);
      Writeln(F,'Repeat');
{      Writeln(F,Language.Loc(827));                     Main_Task Useless}
      For A:=1 to 3 do Writeln(F,Language.Loc(827+A));

      For A:=1 to Qtt_ITM[1] do GET_BUTTON_ACTION(A);  {*Write Button Test*}

      For A:=1 to Qtt_ITM[2] do                        {*Write Cycler Test*}
         Writeln(F,Ind,'Cycler_GetMsg(Cyc',A,',',TCY[A].MoA,');');
      For A:=1 to Qtt_ITM[3] do                        {*Write Radio Test*}
         Writeln(F,Ind,'RadioBox_GetMsg(Rad',A,',',TRB[A].MoA,');');
      For A:=1 to Qtt_ITM[5] do                        {*Write InputText Test*}
         If Not BTST(TCO[A].T.Id,6) Then Writeln(F,Ind,'InputText_GetMsg(Com',A,',Cin',A,');');
      For A:=1 to Qtt_ITM[4] do Begin                  {*Write Slider Test*}
         If RSldV[A].ComNum=0 Then Writeln(F,Ind,'Slider_GetMsg(Sld',A,',',TSL[A].MoA,');')
            Else Begin
            Writeln(F,Ind,'If Slider_GetMsg(Sld',A,',',TSL[A].MoA,')=CMModified Then Begin');
            Write(F,Ind,'   Str(Sld',A,'.Psl,Cin',RSldV[A].ComNum,'); ');
            WRITE_GADGET_COMMAND(RSldV[A].ComNum);  {*Reinit Command*}
            Writeln(F,Ind,'   End;');
            End;
         End;
      Writeln(F,Language.Loc(831));                          {*Gre Window if Exist*}
      Writeln(F,'   End;');

      If Gen_Menu Then Begin                        {*Gneration code test Menu*}
         Writeln(F);
         Writeln(F,Language.Loc(832));
         Writeln(F,'Case MS of');
         For A:=1 to Qtt_Menu do Begin
         Writeln(F,'   ',A,Language.Loc(833),A,'*}');
            For B:=1 to Qtt_MenuP[A] do Begin
               Writeln(F,'      ',B,': ;');
               End;
            Writeln(F,'      End;');
            End;
         Writeln(F,'   End;');
         End;

         Writeln(F);
         Writeln(F,Language.Loc(834));
         Writeln(F,Language.Loc(835));
         If W.IDCMP And $2=$2 Then Writeln(F,Language.Loc(836));
         If W.IDCMP And $4=$4 Then Writeln(F,Language.Loc(837));
         Writeln(F,Language.Loc(838));
      Writeln(F,Language.Loc(839));
      Writeln(F);
      Writeln(F,Language.Loc(840));
      If Perso_Done Then Writeln(F,Name_Proc,'_DONE;');
      Writeln(F,'End;');
      Writeln(F);

      {==== WRITE PROG PRINCIPAL ====}

      If Gen_Prog=True Then Begin
      Writeln(F,Language.Loc(774));
      Writeln(F,Language.Loc(841));
      Writeln(F,Language.Loc(780));
      Writeln(F);
      Writeln(F,'Begin');
{      For A:=1 to 3 do Writeln(F,Language.Loc(842+A));}
      Writeln(F,Language.Loc(843));
{      Writeln(F,Language.Loc(846));}
{      Writeln(F,'SetJump(MyAddr);');
      Writeln(F,'ExitProc:=@ENTRY_INT24;');}
      Writeln(F);

      S1:=Name_Proc;
      Str(Rel_Px,S2); Str(Rel_Py,S3);   {*Fentre En Pos Relative*}
      If Rel_PWin Then S1:=S1+'('+S2+','+S3+')';
      Writeln(F,S1,';',Copy(Esp,1,39-Length(S1)),Language.Loc(847));

      Writeln(F);
{      For A:=1 to 3 do Writeln(F,Language.Loc(847+A));}
      Writeln(F,Language.Loc(848));
      Writeln(F,'End.');
      End;
      Close(F);                         {*Ferme le Fichier*}

      {==== DELETE COMMENTS IF NEEDS ====}

      If Gen_Rem=No Then Begin         {*Sucre Comments ?*}
         InRem:=No;                    {*Init Bool Interieur d'un Rem*}
         Assign(F,DirSel+FilSel);
         Assign(F1,DirSel+'MRE.TMP');
         {$I-}
         Reset(F);                      {*Rouvre le Fichier*}
         Rewrite(F1);                   {*Crer Fichier Temporaire*}
         {$I+}
         If IOResult=0 Then             {*No Errors ? => Ok !*}
            Begin
            While Not Eof(F) do Begin
               Readln(F,S1); A:=Pos('{',S1);{*Search Begin Comments*}
               If Copy(S1,A,2)='{$' Then A:=0;{*Ce n'est pas un Comment*}
               If A>0 Then Begin InRem:=Yes;{*Write First Line With Rem*}
                  If A-1>0 Then Writeln(F1,Copy(S1,1,A-1));
                  End;
               If InRem=No Then Writeln(F1,S1);
               A:=Pos('}',S1);          {*Search End Comments*}
               If A>0 Then InRem:=No;  {*Fin des Commentaires*}
               End;
            Close(F);                   {*Ferme Fichier Source - Lecture*}
            Close(F1);                  {*Ferme Fichier Temporaire*}
            Erase(F);                   {*Sucre Old File With Comments*}
            Rename(F1,DirSel+FilSel);   {*Rename New File*}
            End;
         End;

      {==== OPTIMIZE SOURCE IF NEEDS ====}

      If Opt_Source=Yes Then Begin       {*Optimize Source ?*}
         Assign(F,DirSel+FilSel);
         Assign(F1,DirSel+'MRE.TMP');
         {$I-}
         Reset(F); S3:='';              {*Rouvre le Fichier*}
         Rewrite(F1);                   {*Crer Fichier Temporaire*}
         {$I+}
         If IOResult=0 Then             {*No Errors ? => Ok !*}
            Begin
            While Not Eof(F) do Begin
               Readln(F,S1);
               A:=Pos('+0',S1); If A>0 Then Delete(S1,A,2);{*Sucre "+0"*}
               A:=Pos('+0',S1); If A>0 Then Delete(S1,A,2);{*Sucre "+0" en plus*}
               A:=Pos('+0',S1); If A>0 Then Delete(S1,A,2);{*Sucre "+0" en plus*}
               A:=Pos('VESA_SetColor(',S1); B:=Pos(');',S1);
               If A>0 Then Begin
                  S2:=S3; A:=0;
                  If S2=Copy(S1,A+10,2) Then Begin  {*Sucre VESA_SetColor Useless*}
                     S3:=Copy(S1,A+10,2); Delete(S1,A,B-A+3); A:=1;
                     End Else S3:=Copy(S1,A+10,2);  {*Lecture Num Couleur*}
                  End;
               If A=0 Then Writeln(F1,S1);          {*Write New Line Epured*}
               End;
            Close(F);                   {*Ferme Fichier Source - Lecture*}
            Close(F1);                  {*Ferme Fichier Temporaire*}
            Erase(F);                   {*Sucre Old File*}
            Rename(F1,DirSel+FilSel);   {*Rename New File*}
            End;
         End;

      {==== SHO REPORT IF NEEDS ====}

      If Show_Report=Yes Then Begin       {*Show Report ?*}
         S1:=''; S2:=''; S3:='';
         If Opt_Source Then S1:=Language.Loc(464);
         If Gen_Rem=Yes Then S2:=Language.Loc(465);
         If Gen_Prog   Then S3:=Language.Loc(466);
         Num:=4;                         {*Icne Information*}
         Req_Dialog(Language.Loc(461),Language.Loc(467)+S2+S1+S3,Language.Loc(24),NUM);
         End;

      Mse_SetPointer(P_Current);         {*Normal Pointer*}
      End
      Else Begin
      Num:=1;                            {*Icne Warning*}
      Req_Dialog(Language.Loc(461),Language.Loc(468),Language.Loc(469),NUM);
      End;
   End;
End;

{ͻ
                         CHARGEMENT PROJET EN DATAS                         
  OUT.....: 0 = Ok, 1 = Annulation.                                         
  MODE....: 0 = Normal (Demande de nom), 1 = Load Undo.                     
 ͼ}

Function LOAD_PROJECT(Var M:TMenu; Mode:Byte):Byte;
Var DirSel,FilSel:String;
    Size         :Longint;
    F            :File;
    St           :String;               {*Pour Lecture*}
    NUM,A,B      :Integer;
    DelY         :Word;                 {*Taille Y Fonte en Pixels*}
    WT           :TWindow;              {*TWindow Temporaire to Rebuild TWindow...*}
    OldItem      :Byte;                 {*Ancien Numro d'Item*}
    SR           :Array[1..Max_ITM] of Integer;{*Taille des Records*}

Begin
If (Qtt_Pro=Max_Menu_Points-1) And (Mode=0) Then Begin{*Trop de Projets Chargs*}
   Num:=1;                              {*Icne Warning*}
   Req_Dialog(Language.Loc(461),Language.Loc(470),Language.Loc(472),NUM);
   Exit;                                {*Ne peut pas Charger le Projet !*}
   End;

OldItem:=Item;                          {*Get Type d'dition*}
DirSel:='';
If Mode=0 Then Begin
   FilSel:='';                          {*Directory Courant*}
   Req_FileManager(50,32,282,Language.Loc(473),Language.Loc(474),'*.MRE',0,DirSel,FilSel,Size);
   If FilSel='' Then Begin              {*Annulation...*}
      LOAD_PROJECT:=1; Exit; End;
   End Else FilSel:=Nom_Undo;           {*Load Undo = Nom du Fichier pour Undo*}

If FilSel<>'' Then Begin
   Assign(F,DirSel+FilSel);
   {$I-}
   Reset(F,1);                          {*Open File*}
   {$I+}
   If IOResult=0 Then Begin             {*No Errors ? => Ok !*}
      LOAD_PROJECT:=0;                  {*No Error...*}
      Save_FileName:=FilSel;            {*Keep Save FileName*}
      BlockRead(F,St,21);
      If Pos('MRE v2.8',St)>0 Then Begin
         Win_Done(W);                {*Sucre Fentre Prcdente*}
         Mse_SetPointer(MPBusy);
         BlockRead(F,St,35);
         BlockRead(F,St,43);
         Gad_Exist:=True;               {*Gadgets Existent*}
         SET_PNAME_IN_MENU(M,FilSel);   {*Update Title Menu Current Projet*}

         QTT_TO_0;                      {*Rinit Quantit de Chaque Outils*}

         BlockRead(F,Name_Prog,30);     {*Lecture Source Prefs*}
         BlockRead(F,Name_Proc,30);
         BlockRead(F,Gen_Prog,1);
         BlockRead(F,Gen_Rem,1);
         BlockRead(F,Opt_Source,1);
         BlockRead(F,Rel_PWin,1);
         BlockRead(F,Perso_Init,1);
         BlockRead(F,Perso_Done,1);
         BlockRead(F,Gen_Forp,1);
         BlockRead(F,Func_Type,1);
         BlockRead(F,Rel_Px,2);
         BlockRead(F,Rel_Py,2);
         BlockRead(F,Show_Report,1);
         BlockRead(F,Full_Simul,1);
         BlockRead(F,CGL_Qtt,1);
         BlockRead(F,CGL_Pos,1);
         BlockRead(F,CGL_Inc,1);
         BlockRead(F,CGC_Qtt,1);
         BlockRead(F,CGC_Pos,1);
         BlockRead(F,CGC_Inc,1);
         BlockRead(F,DelY,2);           {*Write Hauteur Fonte pour Update*}
         DelY:=HaF1-DelY;               {*Calcule Delta Y pour Pos Y Gadgets*}

         BlockRead(F,W,Sizeof(W));      {*Read Window Parameters*}
         WT:=W;                         {*Stoke Param Temporaires*}
         Win_Init(W.X1,W.Y1,W.X2,W.Y2,W.IDCMP,W.Name,W);
         Win_Sup(WT.Xu,WT.Yu,WT.Xv,WT.Yv,WT.Xmin,WT.YMin,WT.XMax,WT.YMax,WT.BarSld,WT.Coul,WT.IDRES,W);

         BlockRead(F,Max_Lines,1);
         For Num:=1 to Max_Lines do     {*Load Init & Done Code Arrays...*}
            Begin
            BlockRead(F,Init_Code[Num],Sizeof(Init_Code[Num]));
            BlockRead(F,Done_Code[Num],Sizeof(Init_Code[Num]));
            End;

         For B:=1 to Max_ITM do Begin   {*Read Main Gadgets*}
            BlockRead(F,Qtt_ITM[B],1);  {*Qtt of Gadgets*}
            BlockRead(F,SR[B],2);       {*Next Record Size*}
            For A:=1 to Qtt_ITM[B] do
               Case B of
                  1: BlockRead(F,TBU[A],SR[B]); {*Read Buttons Parameters*}
                  2: BlockRead(F,TCY[A],SR[B]); {*Read Cyclers Parameters*}
                  3: BlockRead(F,TRB[A],SR[B]); {*Read Radios Parameters*}
                  4: BlockRead(F,TSL[A],SR[B]); {*Read Sliders Parameters*}
                  5: BlockRead(F,TCO[A],SR[B]); {*Read Commands Parameters*}
                  6: BlockRead(F,TBB[A],SR[B]); {*Read Bevel Parameters*}
                  7: BlockRead(F,TSB[A],SR[B]); {*Read String Boxes Parameters*}
                  8: BlockRead(F,TXT[A],SR[B]); {*Read Texts Parameters*}
                  9: BlockRead(F,IMG[A],SR[B]); {*Read Images Parameters*}
                 10: BlockRead(F,ONG[A],SR[B]); {*Read Tabss Parameters*}
                  End;
            End;

         BlockRead(F,B,1);                      {*Qtt=0 Trash*}
         BlockRead(F,B,2);                      {*Size=0*}

         {============================================================}

         BlockRead(F,Proc_Name,256);      {*Read Nom Proc  Appeller*}

         BlockRead(F,RFileV,Sizeof(RFileV));{*Read File Requester Values*}
         BlockRead(F,RPalV,Sizeof(RPalV));{*Read Palette Requester Values*}
         BlockRead(F,RMemV,Sizeof(RMemV));{*Read Memory Requester Values*}
         BlockRead(F,RHardV,Sizeof(RHardV));{*Read Hardware Requester Values*}
         BlockRead(F,RSysV,Sizeof(RSysV));{*Read System Requester Values*}
         BlockRead(F,REzV,Sizeof(REzV));  {*Read EZ Requester Values*}
         BlockRead(F,RFntV,Sizeof(RFntV));{*Read Font Requester Values*}
         BlockRead(F,RAttrV,Sizeof(RAttrV));{*Read Attrib Requester Values*}
         BlockRead(F,RStV,Sizeof(RStV));  {*Read String Requester Values*}
         BlockRead(F,RVaV,Sizeof(RVaV));  {*Read Value Requester Values*}
         BlockRead(F,RProV,Sizeof(RProV));{*Read Progress Requester Values*}

         For A:=1 to Max_TSL do BlockRead(F,RSldV[A].ComNum,1);{*Read InputText to Slider*}

         {============================================================}

         BlockRead(F,Gen_Menu,1);         {*Lecture des Paramtres du Menu*}
         BlockRead(F,Qtt_Menu,1);         {*Read Qtt Menus*}

         For A:=1 to Qtt_Menu do Begin
            BlockRead(F,Qtt_MenuP[A],1);  {*Read Qtt Menu Labels*}
            For B:=1 to Qtt_MenuP[A]+1 do
               BlockRead(F,Menu.TbMen[A,B],Max_Length_Points); {*Read Labels*}
            End;

         {============================================================}

         POS_TO_0;                      {*Rinit Positions Chaque Outils*}

         WSizeX:=W.X2-W.X1; WSizeY:=W.Y2-W.Y1;
         Item:=OldItem;                 {*Correct Bug...*}
         REDRAW_WINDOW(M);              {*Raffiche le Contenu de Window*}
         UPDATE_MENU_CENTER(M);         {*Update les Lignes Colonnes*}
         Mse_SetPointer(P_Current);
         End
         Else Begin
         Num:=2;                        {*Icne Warning*}
         Req_Dialog(Language.Loc(461),Language.Loc(475),Language.Loc(476),NUM);
         End;
      Close(F);                         {*Ferme le Fichier*}
      End
      Else Begin
      Num:=4;                           {*Icne Information*}
      Req_Dialog(Language.Loc(461),Language.Loc(477),Language.Loc(476),NUM);
      End;
   End;
End;

{ͻ
                           PROCEDURE UNDO_ACTION                            
 ͼ}

Procedure UNDO_ACTION(Var M:TMenu);     {*Undo Action*}
Var Num:Integer;
    PName:String;                       {*Sauvegarde nom du Projet*}
    Px:Integer;
Begin
{gotoxy(1,3); writeln('*',M.TbMen[8,1]); Readln;}
PName:=Save_FileName;                   {*Backup of Project Name*}
Nom_Undo:='MRE.U00';                    {*Nom du Fichier Undo*}
If Not (File_TestExist(Nom_Undo)) Then Begin
   Num:=1;                              {*Icne Warning*}
   Req_Dialog(Language.Loc(461),Language.Loc(478),Language.Loc(24),Num);
   Exit; End;
LOAD_PROJECT(M,1);                      {*Reload Previous Datas*}
Save_FileName:=PName;                   {*Restaure Nom Projet*}
Px:=Pos('.TMP',PName);
If Px>0 Then PName:=Copy(PName,1,Px)+'MRE';
M.TbMen[8,1]:='Project: '''+PName+'''';
{gotoxy(1,4); writeln('*',M.TbMen[8,1]);}
End;

{ͻ
                             PROCEDURE EDIT_LC                              
 ͼ}

Procedure EDIT_LC;
Var W1            :TWindow;                 {*Window Structure*}
    Even          :Byte;                    {*Get Windows Evens*}
    Exit_Flg      :Boolean;                 {*Exit Flag*}
    Cancel        :Boolean;
    But1,But2     :TButton;                 {*Buttons Structure*}
    Rad1,Rad2     :TRadioBox;               {*Radios Structure*}
    Com1,Com2,Com3,
    Com4          :TInputText;              {*Commands Structure*}
    Cin1,Cin2,Cin3,
    Cin4          :String;                  {*Strings for Commands*}
    Code          :Integer;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_EXAMPLE;               {*Define Example...*}
Var A,B,StepX,StepY,X,Y:Integer;
    CGL_Qtt2,CGC_Qtt2:Integer;
Begin
Val(Cin1,CGL_Qtt2,Code);
Val(Cin2,CGC_Qtt2,Code);

Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*43,HaF*4,LaF*71,HaF*14+6, CLPaper,BLRaisedLine,BLNoLine,Yes);
VESA_SetColor(CLLineDown);

Mse_Hide;
StepX:=(LaF*28) Div (CGC_Qtt2+1);
For A:=1 to CGC_Qtt2 do VESA_Line(LaF*43+StepX*A, HaF*4-5, LaF*43+StepX*A, HaF*14-1);
StepY:=(HaF*10+6) Div (CGL_Qtt2+1);
For A:=1 to CGL_Qtt2 do VESA_Line(LaF*43, HaF*4-5+StepY*A, LaF*71-2, HaF*4-5+StepY*A);
Mse_Show;

For A:=1 to CGL_Qtt2 do                 {*Dessine un Carr  chaque Intersections*}
   For B:=1 to CGC_Qtt2 do
      Begin
      X:=LaF*43+StepX*B;
      Y:=HaF*4-5+StepY*A;
      Bevel(X-3+1,Y-3+6,X+3+1,Y+3+6, CLRed);
      End;

Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*4, HaF*3+3, LaF*40, HaF*14+6,CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*11,HaF*2+6, LaF*32, HaF*4+1, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Display (LaF*16,  HaF*2+8,CLWhite,Language.Loc(694));
Display (LaF*20,  HaF*5+7,CLText, Language.Loc(521));
Display (LaF*6+6, HaF*7+8,CLText, Language.Loc(522));
Display (LaF*6+6, HaF*9+7,CLText, Language.Loc(523));
Display (LaF*52,  HaF*2,  CLText, Language.Loc(524));
RadioBox( LaF*20, HaF*11+6,1,$0,1,5,Rad1.Status,Rad1,Language.Loc(525));
RadioBox( LaF*30, HaF*11+6,1,$0,1,0,Rad2.Status,Rad2,'');

Button( LaF*14, HaF*16+6, LaF*16,-1, CLTextButton,CLBgButton,$00,But1,'_OK');
Button( LaF*46, HaF*16+6, LaF*16,-1, CLTextButton,CLBgButton,$00,But2,Language.Loc(13));
InputText(LaF*20, HaF*7+7,LaF*6,1,CLBlue,CLLightBlue,0,$0127,Com1,Cin1);
InputText(LaF*30, HaF*7+7,LaF*6,1,CLBlue,CLLightBlue,0,$0126,Com2,Cin2);
InputText(LaF*20, HaF*9+7,LaF*6,1,CLSky,CLLightBlue,0,$0126,Com3,Cin3);
InputText(LaF*30, HaF*9+7,LaF*6,1,CLSky,CLLightBlue,0,$0126,Com4,Cin4);
Win_Clip(No,W1);                    {*Restore Normal Clipping*}

REDRAW_EXAMPLE;                         {*Define Example...*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(80,120,80+LaF*76,120+HaF1+HaF*18+6,$51D9,Language.Loc(526),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}

Win_Draw(W1);                        {*Display Window*}

Rad1.Status:=CGL_Inc;                   {*Init Values....*}
Rad2.Status:=CGC_Inc;
Str(CGL_Qtt,Cin1);
Str(CGC_Qtt,Cin2);
Str(CGL_Pos,Cin3);
Str(CGC_Pos,Cin4);

REDRAW_FRAME;                           {*Display Window Content*}
Cancel:=No; Exit_Flg:=No;               {*Init Exit Flag*}

Repeat
try
;
If Win_Ready(W1) Then                {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;
   RadioBox_GetMsg(Rad1,1);
   RadioBox_GetMsg(Rad2,1);
   If InputText_GetMsg(Com1,Cin1)=CMModified Then REDRAW_EXAMPLE;
   If InputText_GetMsg(Com2,Cin2)=CMModified Then REDRAW_EXAMPLE;
   InputText_GetMsg(Com3,Cin3);
   InputText_GetMsg(Com4,Cin4);
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                {*Get Windows W1 Evens*}
If Even=CMClosed Then Cancel:=Yes;             {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}

Win_Done(W1);                        {*Close Window W1 if Needs*}
If Not Cancel Then Begin
   CGL_Inc:=Rad1.Status;                {*Save Values....*}
   CGC_Inc:=Rad2.Status;
   Val(Cin1,CGL_Qtt,Code);
   Val(Cin2,CGC_Qtt,Code);
   Val(Cin3,CGL_Pos,Code);
   Val(Cin4,CGC_Pos,Code);
   If CGL_Qtt<=0 Then CGL_Qtt:=1;       {*Vrifie Bornes...*}
   If CGC_Qtt<=0 Then CGC_Qtt:=1;
   If CGL_Pos<=0 Then CGL_Pos:=1;
   If CGC_Pos<=0 Then CGC_Pos:=1;
   If CGL_Pos>CGL_Qtt Then CGL_Pos:=CGL_Qtt;
   If CGC_Pos>CGC_Qtt Then CGC_Pos:=CGC_Qtt;
   End;
End;

{ͻ
                            PROCEDURE SET_GRID                              
 ͼ}

Procedure SET_GRID(Var M:TMenu);
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;                {*Structure Boutons*}
    Rad1          :TRadioBox;                 {*Structure Radios*}
    Com1,Com2     :TInputText;              {*Structure Commands*}
    Cin1,Cin2     :String;              {*Strings pour Commands*}
    Code          :Integer;             {*Pour Tranformer avec Val*}
    Cancel        :Boolean;             {*Annulation Modifications*}
    ValTemp       :Shortint;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4,  HaF*2+6, LaF*46,  HaF*10, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*12, HaF*1+6, LaF*38,  HaF*3+1,CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Display(LaF*17,  HaF*1+8,CLWhite,Language.Loc(128));
Display(LaF*12-1,HaF*6+2,CLText, Language.Loc(480));
Display(LaF*12-1,HaF*8+2,CLText, Language.Loc(481));

Button( LaF*8, HaF*11+6,LaF*14,-1,  CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*28,HaF*11+6,LaF*14,-1,  CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
InputText(LaF*34,HaF*6+2, LaF*6,10, CLGreen,CLGrey,0,$127,Com1,Cin1);
InputText(LaF*34,HaF*8+2, LaF*6,10, CLGreen,CLGrey,0,$126,Com2,Cin2);
RadioBox(LaF*34, HaF*4+1,1,$00,0,8,Rad1.Status,Rad1,Language.Loc(479));
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(100,50,100+LaF*50,50+HaF1+HaF*13+6,$51D9,Language.Loc(483),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Rad1.Status:=My_Grid;                   {*Status Grille*}
Str(Sys.GridStepX,Cin1); Str(Sys.GridStepY,Cin2);

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}

Mse_SetPointer(P_Current);              {*TPointer Souris Normal*}
Exit_Flg:=No; Cancel:=No;             {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;
   RadioBox_GetMsg(Rad1,1);
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin                {*Save Values dans Paramtres*}
   CREATE_UNDO(M);                      {*Crer un Fichier UNDO*}
   My_Grid:=Rad1.Status;
   Val(Cin1, ValTemp, Code); Sys.GridStepX := ValTemp;
   Val(Cin2, ValTemp, Code); Sys.GridStepY := ValTemp;
   If Sys.GridStepX<=0 Then Sys.GridStepX:=1;         {*Minimum Autoris...*}
   If Sys.GridStepY<=0 Then Sys.GridStepY:=1;
   End;
End;

{ͻ
                        EDIT IDCMP DE FENETRE DE BASE                       
 ͼ}

Procedure EDIT_IDCMP(Var M:TMenu);
Var But1                     :TButton;           {*Type pour Gadgets Prdfinit*}
    TRad                     :Array [1..16] of TRadioBox;{*Les Boutons Radios*}
    W1                       :TWindow;            {*Structure Window*}
    ExitFlg                  :Boolean;        {*Flag Sortie Programme*}
    ES,ES1,ES2               :String;         {*String Tout Usages*}
    OneTime                  :Boolean;        {*Bouton Souris Appuy ou pas*}
    IDCMP                    :Word;           {*IDCMP Fentre*}
    NUM                      :Word;           {*Numro Gadets Cliqu*}
    Even                     :Byte;           {*Evenements pour Fentres*}
    Cancel                   :Boolean;        {*Annulation Modifications*}
    A                        :Integer;        {*Loop*}

{************************** AFFICHAGE DU WORD IDCMP *************************}

Procedure DISP_IDCMP;
Begin
ES:=Str_L2H(IDCMP,4);
Bevel  (W1.X1+120,W1.Y1+328,W1.X1+208,W1.Y1+344, CLSky,BLLoweredLine,BLRaisedLine,Yes);
Display(W1.X1+126,W1.Y1+330, CLText,'IDCMP = $'+ES);
End;

Procedure CALC_IDCMP;
Begin
If OneTime=False Then
   Begin
   If IDCMP And NUM=NUM
      Then IDCMP:=IDCMP And ($FFFF-NUM)
      Else IDCMP:=IDCMP Or NUM;

   DISP_IDCMP;
   OneTime:=True;
   End;
End;

{********************* INITIALISATION WINDOW DE BASE ************************}

Procedure REDRAW_FRAME;
Var A,T,I:Integer;
Begin
Win_Clip(Yes,W1);
Button(40,W1.Y2-W1.Y1-HaF1-HaF-10,59,-1, CLTextButton,CLBgButton,$0100,But1,' _OK ');  {*Initialise les Boutons*}

For A:=1 to 16 do                             {*Initialise les Boutons Radio*}
   RadioBox(195,2+A*18,1,$00,0,12,TRad[A].Status,TRad[A],Language.Loc(483+A));
Win_Clip(No,W1);

OneTime:=False;

T:=1; I:=0;                                   {*Affichage IDCMP Numros*}
ES2:='0000';
For A:=1 to 16 do Begin
   ES:='$0000';
   Str(T,ES1);
   ES:=Copy(ES,1,5-I-Length(ES1))+ES1+Copy(ES2,1,I);
   Display(W1.X1+140,W1.Y1+A*18+3+HaF1, CLText,ES);
   T:=T*2;
   If T>8 Then Begin T:=1; Inc(I); End;
   End;
DISP_IDCMP;
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
TOGGLE_ITEM(NType);                           {*Dsentoure l'Item*}
If Not Win_Init(180,0,420,349,$51D9,Language.Loc(500),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0010,W1);
IDCMP:=W.IDCMP;                               {*Transmet IDCMP*}
Win_Draw(W1);

For A:=1 to 16 do                             {*Init All Radios*}
   If W.IDCMP And PUISS(2,A-1)=PUISS(2,A-1)
      Then TRad[A].Status:=Yes
      Else TRad[A].Status:=No;

REDRAW_FRAME;                                 {*Affiche Gadgets*}

DISP_IDCMP;                                   {*Affiche IDCMP*}
ExitFlg:=No; Cancel:=No;                    {*Don't Forget !!!*}

Repeat
try

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Window Closed*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}

{For A:=1 to 16 do
   If TRad[A].Fl1=True Then Begin NUM:=PUISS(2,A-1); CALC_IDCMP; End;} {Sybaris dbuggage}

If Mse_Clicked(1)=False Then OneTime:=False;

If Win_Ready(W1) Then Begin
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then ExitFlg:=True;{*Sortie du Programme*}
   For A:=1 to 16 do
     If RadioBox_GetMsg(TRad[A],1)<>CMNone Then {*Active et Teste Boutons*}    {Sybaris dbuggage}
       Begin                                                           {Sybaris dbuggage}
       NUM:=PUISS(2,A-1); CALC_IDCMP;                                  {Sybaris dbuggage}
       End;                                                            {Sybaris dbuggage}
   Win_Clip(No,W1);
   End;

except
  on e:Exception do HandleException(e);
end;
Until (ExitFlg=Yes) Or (Cancel=Yes);            {*Sortie du Programme*}

If Cancel=No Then Begin
   CREATE_UNDO(M);                            {*Cr un Fichier UNDO*}
   BSET(Has_Changed,Num_Pro);                 {*Une Modification a t Faite*}
   Win_IdCmp(IDCMP,W);                     {*Change IDCMP Fentre*}
   REDRAW_WINDOW(M);                          {*Raffiche le Contenu de Window*}
   End;
Win_Done(W1);                           {*Kill Requester*}
TOGGLE_ITEM(NType);                           {*Rentoure l'Item*}
End;

{ͻ
                        EDIT IDRES DE FENETRE DE BASE                       
 ͼ}

Procedure EDIT_IDRES(Var M:TMenu);
Var But1                     :TButton;           {*Type pour Gadgets Prdfinit*}
    TRad                     :Array [1..16] of TRadioBox;{*Les Boutons Radios*}
    W1                       :TWindow;            {*Structure Window*}
    ExitFlg                  :Boolean;        {*Flag Sortie Programme*}
    ES,ES1,ES2               :String;         {*String Tout Usages*}
    OneTime                  :Boolean;        {*Bouton Souris Appuy ou pas*}
    IDRES                    :Word;           {*IDRES Fentre*}
    NUM                      :Word;           {*Numro Gadets Cliqu*}
    Even                     :Byte;           {*Evenements pour Fentres*}
    Cancel                   :Boolean;        {*Annulation Modifications*}
    A                        :Integer;        {*Loop*}

{************************** AFFICHAGE DU WORD IDRES **************************}

Procedure DISP_IDRES;
Begin
ES:=Str_L2H(IDRES,4);
Bevel  (W1.X1+120,W1.Y2-21,W1.X1+208,W1.Y2-5, CLSky,BLLoweredLine,BLRaisedLine,Yes);
Display(W1.X1+126,W1.Y2-19, CLText,'IDRES = $'+ES);
End;

Procedure CALC_IDRES;
Begin
If OneTime=False Then
   Begin
   If IDRES And NUM=NUM
      Then IDRES:=IDRES And ($FFFF-NUM)
      Else IDRES:=IDRES Or NUM;

   DISP_IDRES;
   OneTime:=True;
   End;
End;

{********************* INITIALISATION WINDOW DE BASE ************************}

Procedure REDRAW_FRAME;
Var A,T,I:Integer;
Begin
Win_Clip(Yes,W1);
Button(40,W1.Y2-W1.Y1-HaF1-HaF-10,59,-1, CLTextButton,CLBgButton,$0100,But1,' _OK ');  {*Initialise les Boutons*}

For A:=1 to 7 do                              {*Initialise les Boutons Radio*}
   RadioBox(195,2+A*18,1,$00,0,12,TRad[A].Status,TRad[A],Language.Loc(500+A));
Win_Clip(No,W1);

OneTime:=False;

T:=1; I:=0;                                   {*Affichage IDCMP Numros*}
ES2:='0000';
For A:=1 to 7 do Begin
   ES:='$0000';
   Str(T,ES1);
   ES:=Copy(ES,1,5-I-Length(ES1))+ES1+Copy(ES2,1,I);
   Display(W1.X1+140,W1.Y1+A*18+3+HaF1, CLText,ES);
   T:=T*2;
   If T>8 Then Begin T:=1; Inc(I); End;
End;
DISP_IDRES;
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
TOGGLE_ITEM(NType);                           {*Dsentoure l'Item*}
If Not Win_Init(180,60,420,240+HaF1,$51D9,Language.Loc(508),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0010,W1);
IDRES:=W.IDRES;                               {*Transmet IDRES*}
Win_Draw(W1);

For A:=1 to 8 do                              {*Init All Radios*}
   If W.IDRES And PUISS(2,A-1)=PUISS(2,A-1)
      Then TRad[A].Status:=Yes
      Else TRad[A].Status:=No;

REDRAW_FRAME;                                 {*Affiche Gadgets*}

DISP_IDRES;                                   {*Affiche IDRES*}
ExitFlg:=No; Cancel:=No;                    {*Don't Forget !!!*}

Repeat
try

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Window Closed*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}

For A:=1 to 7 do
   If TRad[A].Fl1=True Then Begin NUM:=PUISS(2,A-1); CALC_IDRES; End;

If Mse_Clicked(1)=False Then OneTime:=False;

If Win_Ready(W1) Then Begin
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then ExitFlg:=True;{*Sortie du Programme*}
   For A:=1 to 7 do RadioBox_GetMsg(TRad[A],1);  {*Active et Teste Boutons*}
   Win_Clip(No,W1);
   End;

except
  on e:Exception do HandleException(e);
end;
Until (ExitFlg=Yes) Or (Cancel=Yes);            {*Sortie du Programme*}

If Cancel=No Then Begin
   CREATE_UNDO(M);                            {*Cr un Fichier UNDO*}
   BSET(Has_Changed,Num_Pro);                 {*Une Modification a t Faite*}
   Win_IdRes(IDRES,W);                     {*Change IDRES Fentre*}
   REDRAW_WINDOW(M);                          {*Raffiche le Contenu de Window*}
   End;
Win_Done(W1);                           {*Kill Requester*}
TOGGLE_ITEM(NType);                           {*Rentoure l'Item*}
End;

{ͻ
                       EDIT MISCELLANEOUS INFO FENETRE                      
 ͼ}

Procedure EDIT_MISCELLANEOUS(Var M:TMenu);
Var Exit_Flg    :Boolean;               {*Flag de Sortie*}
    Even        :Byte;                  {*Rception Evnements de la Fentre*}
    W1          :TWindow;                   {*Structure Fentre*}
    But0,But1,But2:TButton;                {*Structure Boutons*}
    TRad        :Array[1..4] of TRadioBox;    {*Radio Buttons Sructure*}
(*    Co1,Co2,Co3,Co4,                    {*String InputText*}
    Co5,Co6,Co7,Co8,
    Co9,CoA,CoB,CoC,*)
    TCo         :Array[1..12] of TInputText;
    CoD,CoE     :TInputText;
(*    Cin1,Cin2,Cin3,Cin4,                {*String Rcupre*}
    Cin5,Cin6,Cin7,Cin8,
    Cin9,CinA,CinB,CinC,*)
    CinD,CinE   :String;
    TCin        :Array[1..12] of String;
    Code        :Integer;
    Cancel      :Boolean;               {*Annulation Modifications*}
    IDRES       :Word;                  {*Stocke pour Restitution Ultrieure*}
    A           :Integer;               {*Loop*}

{************************** AFFICHE WINDOW CONTENU **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var A           :Integer;               {*Loop*}
Begin
Win_Clip(Yes,W1);
Bevel (200,74,390,148, CLMauve,BLLoweredLine,BLNoLine,Yes);

Font_Set('ITAL.CHR',4);
Display(324,36, CLText,Language.Loc(509));
Display(34, 56, CLText,Language.Loc(510));
Display(324,17, CLText,Language.Loc(511));
For A:=1 to 4 do RadioBox(350,82+(A-1)*(HaF+5), 2,$00,0,9,TRad[A].Status,TRad[A],Language.Loc(511+A));
Font_Set(Sys.FontMain,Sys.FontMainSize);

Button(LaF*18, 160,LaF*16,-1, CLTextButton,CLBgButton,$100,But0,'_OK');
Button(LaF*50, 160,LaF*16,-1, CLTextButton,CLBgButton,$0,But1,Language.Loc(13));
Button(LaF*40, HaF*3+5,LaF*12,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(516));

InputText(20, 16,295,60, CLSalmon,CLSky,1,$27,CoD,CinD);
InputText(285,35,30,4,W.Coul,CLSalmon,1,$66,CoE,CinE);

For A:=1 to 4 do InputText(20, 74+(A-1)*HaF*2,50,4, CLSky,CLSalmon,1,$26,TCo[A],TCin[A]);
For A:=1 to 4 do InputText(80, 74+(A-1)*HaF*2,50,4, CLSky,CLSalmon,1,$26,TCo[A+4],TCin[A+4]);
For A:=1 to 4 do InputText(140,74+(A-1)*HaF*2,50,4, CLSky,CLSalmon,1,$26,TCo[A+8],TCin[A+8]);

Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
TOGGLE_ITEM(NType);                     {*Dsentoure l'Item*}
If Not Win_Init(120,140,530,320+HaF1,$51D9,Language.Loc(517),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0010,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Str(W.X1,TCin[1]); Str(W.Y1,TCin[2]);         {*Init Values*}
Str(W.X2,TCin[3]); Str(W.Y2,TCin[4]);
Str(W.Xu,TCin[5]); Str(W.Yu,TCin[6]);
Str(W.Xv,TCin[7]); Str(W.Yv,TCin[8]);
Str(W.XMin,TCin[9]); Str(W.YMin,TCin[10]);
Str(W.XMax,TCin[11]); Str(W.YMax,TCin[12]);

IDRES:=W.IDRES;                         {*Stocke pour Eviter la Perte*}
CinD:=W.Name;
Str(W.Coul,CinE);

For A:=1 to 4 do If W.BarSld=A-1 Then TRad[A].Status:=Yes Else TRad[A].Status:=No;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   Win_Clip(Yes,W1);
   If Button_GetMsg(But0,1)=CMSelected Then Exit_Flg:=True;{*Ok*}
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;  {*Cancel*}
   If Button_GetMsg(But2,1)=CMSelected Then Begin          {*Color*}
      Req_SelectColor(200,150,W.Coul,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Win_Clip(Yes,W1);
      Str(W.Coul,CinE);
      InputText(285,35,30,4,W.Coul,CLSalmon,1,$26+$40,CoE,CinE);
      End;

   For A:=1 to 12 do InputText_GetMsg(TCo[A],TCin[A]); {*Test Gadgets Strings*}
   InputText_GetMsg(CoD,CinD);                 {*Nom Window*}

   For A:=1 to 4 do RadioBox_GetMsg(TRad[A],1); {*Messages Radio Box*}
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Suprime Fentre*}

If Cancel=No Then Begin
   CREATE_UNDO(M);                      {*Cr un Fichier UNDO*}
   W.Name:=CinD;                        {*Save Parameters in Structure*}
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   Win_Done(W);                      {*Sucre Fentre Actuelle*}

   Val(TCin[1],W.X1,Code); Val(TCin[2],W.Y1,Code);{*Define Window Size*}
   Val(TCin[3],W.X2,Code); Val(TCin[4],W.Y2,Code);
   Win_Init(W.X1,W.Y1,W.X2,W.Y2,W.IDCMP,W.NAME,W);

   Val(TCin[5],W.Xu,Code); Val(TCin[6],W.Yu,Code);{*Define Sup Values*}
   Val(TCin[7],W.Xv,Code); Val(TCin[8],W.Yv,Code);
   Val(TCin[9],W.XMin,Code); Val(TCin[10],W.YMin,Code);
   Val(TCin[11],W.XMax,Code); Val(TCin[12],W.YMax,Code);

   Val(CinE,W.Coul,Code);               {*Define Color and BarSld*}
   For A:=1 to 4 do If TRad[A].Status=Yes Then W.BarSld:=A-1;

   Win_Sup(W.Xu,W.Yu,W.Xv,W.Yv,W.Xmin,W.YMin,W.XMax,W.YMax,W.BarSld,W.Coul,IDRES,W);
   REDRAW_WINDOW(M);                    {*Raffiche le Contenu de Window*}
   End;

TOGGLE_ITEM(NType);                           {*Rentoure l'Item*}
End;

{ͻ
                          PROCEDURE DELETE_ITEMS                            
 ͼ}

Procedure DELETE_ITEMS(Var M:TMenu);
Var W1            :TWindow;                {*Structure Fentre*}
    Even          :Byte;                   {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;                {*Flag de Sortie*}
    Cancel        :Boolean;                {*Annulation Modifications*}
    But0,But1,But2:TButton;                {*Structure Boutons*}
    TRad:Array[1..Max_ITM] of TRadioBox;   {*Tableau de Radio Boxes*}
    Rad9,RadB     :TRadioBox;              {*Structure Radios*}
    A             :Integer;

{************************* AFFICHE BOUTONS RADIOS ***************************}

Procedure REDRAW_RADIO_BOXES;
Var A:Integer;
    St:String;
Begin
For A:=1 to Max_ITM do                  {*Could Be Modified*}
   Begin
   St:=Language.Loc(1647+A);
   RadioBox(175,5+A*15,1,$00,0,9,TRad[A].Status,TRad[A],Language.Loc(519)+Copy(St,1,Length(St)-2));
   End;
End;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (30,185,210,245, CLMauve,BLLoweredLine,BLNoLine,Yes);

Button(45, 225,150,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(529));
Button(LaF*6, 260,LaF*14,-1, CLTextButton,CLBgButton,$0,But1,'_OK');
Button(LaF*28,260,LaF*14,-1, CLTextButton,CLBgButton,$0,But0,Language.Loc(13));

REDRAW_RADIO_BOXES;                     {*Raffiche Radio_Boxes*}
RadioBox(160,192,2,$00,0,6,Rad9.Status,Rad9,Language.Loc(527)); {*Musn't Be Modified*}
RadioBox(160,207,2,$00,0,6,RadB.Status,RadB,Language.Loc(528));
Win_Clip(No,W1);
End;


{*************************** TOGGLE ITEMS LIST ******************************}

Procedure TOGGLE_ITEMS;
Var A:Integer;
Begin
For A:=1 to Max_ITM do
   TRad[A].Status:=Not(TRad[A].Status); {*Toggle Check Boxes*}
REDRAW_RADIO_BOXES;                     {*Raffiche Radio_Boxes*}
End;

{*********************** SELECT ITEMS TO BE CLEARED OR NO *******************}

Procedure SELECT_ITEMS;
Var A:Integer;
    B1:Boolean;
Begin
If Sys.RadioId And $1=$1 Then Exit;    {*Bit Extrude Mis => Pas Termin*}

If Rad9.Status=True Then B1:=Yes         {*Set On Check Boxes*}
                    Else B1:=No;       {*Set Off Check Boxes*}
   For A:=1 to MAX_ITM do TRad[A].Status:=B1;

REDRAW_RADIO_BOXES;                     {*Raffiche Radio_Boxes*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
TOGGLE_ITEM(NType);                     {*Dsentoure l'Item*}
If Not Win_Init(170,25,410,105+HaF*2*Max_ITM+HaF1,$51D9,Language.Loc(530),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,400,300,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

For A:=1 to Max_ITM do TRad[A].Status:=Yes;    {*Init Check Boxes*}
Rad9.Status:=Yes; RadB.Status:=No;      {*Init Radio Boxes*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But0,1)=CMSelected Then Cancel:=True;
   For A:=1 to Max_ITM do RadioBox_GetMsg(TRad[A],1);{*Test Main Radios*}

   If RadioBox_GetMsg(Rad9,1)<>CMNone  Then SELECT_ITEMS;{*Modifie Flags*}
   If RadioBox_GetMsg(RadB,1)<>CMNone  Then SELECT_ITEMS;
   If Button_GetMsg(But2,1)=CMSelected Then TOGGLE_ITEMS;{*Toggle Flags*}
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Suprime Fentre*}

If Cancel=No Then Begin                {*Modification Confirme*}
   CREATE_UNDO(M);                      {*Cr un Fichier UNDO*}
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   For A:=1 to Max_ITM do
      If TRad[A].Status=Yes Then
         Begin
         Qtt_ITM[A]:=0; Pos_ITM[A]:=0;  {*Clear Specificaly Items*}
         End;
   REDRAW_WINDOW(M);                    {*Raffiche Fentre de Test*}
   End;
TOGGLE_ITEM(NType);                     {*Rentoure l'Item*}
End;

{ͻ
                         PROCEDURE GET_ITEMS_INFO                           
 ͼ}

Procedure GET_ITEMS_INFO;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1          :TButton;                {*Structure Boutons*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var S:Array[1..Max_ITM] of String[6];
    Lp            :Integer;             {*Loop*}
Begin
Win_Clip(Yes,W1);
Bevel (30,35,210,205, CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Font_Set('ITAL.CHR',4);
Display(30,20, CLText,Language.Loc(1607));
Font_Set(Sys.FontMain,Sys.FontMainSize);

For Lp:=1 to Max_ITM do Begin
   Str(Qtt_ITM[Lp],S[Lp]);
   Display(40, 28+15*Lp, CLText,Language.Loc(1647+Lp));
   Display(145,28+15*Lp, CLText,S[Lp]);
   End;

Button(80,220,80,-1, CLTextButton,CLBgButton,$0100,But1,'   _OK   ');
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(190,40,430,280+HaF1,$51F9,Language.Loc(540),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,400,300,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}

Exit_Flg:=False;                        {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;          {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until Exit_Flg=True;                    {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}
End;

{ͻ
                             DEFINE MAIN PREFS                              
 ͼ}

Procedure DEFINE_MAIN_PREFS;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Cancel        :Boolean;             {*Annulation Modifications*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But0,But1     :TButton;                {*Structure Boutons*}
    TRad          :Array[1..5] of TRadioBox;  {*Structure Radios*}
    Lp            :Integer;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var Lp:Integer;
Begin
Win_Clip(Yes,W1);
Bevel (20,20,270,130, CLMauve,BLLoweredLine,BLRaisedLine,Yes);
For Lp:=1 to 5 do
   RadioBox(230, 10+Lp*20,1,$00,0,13,TRad[Lp].Status,TRad[Lp],Language.Loc(540+Lp));

Button( LaF*8, 145,LaF*16,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*34,145,LaF*16,-1, CLTextButton,CLBgButton,$0,But0,Language.Loc(13));
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(170,60,460,225+HaF1,$51D9,Language.Loc(546),W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

TRad[1].Status:=Disp_Beep;              {*En Fonction Etat Boolean*}
TRad[2].Status:=Full_Simul;
TRad[3].Status:=Show_Mcoo;
TRad[4].Status:=Show_Report;
TRad[5].Status:=Conf_Del;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But0,1)=CMSelected Then Cancel:=True;
   For Lp:=1 to 5 do RadioBox_GetMsg(TRad[Lp],1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Suprime Fentre*}

If Cancel=No Then Begin                {*Modifications Acceptes*}
   Disp_Beep:=TRad[1].Status;           {*Rcupre Etats Booleans*}
   Full_Simul:=TRad[2].Status;
   Show_MCoo:=TRad[3].Status;
   Show_Report:=TRad[4].Status;
   Conf_Del:=TRad[5].Status;
   Win_Rename(W.Name,W);             {*Raffiche Window Title*}
   End;
End;

{ͻ
                       PROCEDURE DEF_INIT_DONE_PROC                         
 ͼ}

Procedure DEF_INIT_DONE_PROC(Px,Py,Mode:Integer; Title:String);
Var W1            :TWindow;                 {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;
    But1,But2     :TButton;                {*Buttons Structure*}
    TCom          :Array[1..8] of TInputText; {*Commands Structure (8)*}
    TCin          :Array[1..8] of String; {*String Structure (8)*}
    A             :Integer;             {*Loop*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Var A,Cl,Fl       :Integer;             {*Loop, Color, Flags*}
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*4,  HaF*3+1, LaF*82,  HaF*18+1, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*10, HaF*2+1, LaF*76,  HaF*3+6,  CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*7+4,HaF*5+1, LaF*78+1,HaF*17+2, CLMauve,  BLLoweredLine,BLNoLine,Yes);
Display  (LaF*19, HaF*2+3, CLWhite,Language.Loc(520));

Button( LaF*20, HaF*19+6,LaF*18,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*48, HaF*19+6,LaF*18,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(13));

For A:=1 to Max_Lines do
   Begin
   If (A>=2) And (A<=Max_Lines-1)
      Then Begin Cl:=12; Fl:=$3E; End
      Else Begin Cl:=9;  Fl:=$7E; End;
   InputText( LaF*8, HaF*5+2+(A-1)*(HaF+5), LaF*70,255,Cl,CLLightBlue,2,Fl,TCom[A],TCin[A]);
   End;
TCom[2].Id:=$3F;                        {*1er InputText Activ...*}
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+LaF*86,Py+HaF1+HaF*21+6,$51D9,Title,W1) Then Exit;
Win_Sup(100,50,250,200,59,50,639,349,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                        {*Display Window*}

For A:=2 to Max_Lines-1 do              {*Clear Arrays...*}
   Begin
   If Mode=1 Then TCin[A]:=Init_Code[A]
             Else TCin[A]:=Done_Code[A];
   End;
TCin[1]:='Begin';                       {*Init Begin & End;*}
TCin[Max_Lines]:='End;';

REDRAW_FRAME;                           {*Display Window Content*}
Cancel:=No; Exit_Flg:=No;               {*Init Exit Flag*}

Repeat
try
;
If Win_Ready(W1) Then                {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;
   For A:=2 to Max_Lines-1 do InputText_GetMsg(TCom[A],TCin[A]);
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=Yes;             {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}
Win_Done(W1);                        {*Close Window if Needs*}

If Not Cancel Then
   For A:=1 to Max_Lines do             {*Save Arrays...*}
      Begin
      If Mode=1 Then Init_Code[A]:=TCin[A]
                Else Done_Code[A]:=TCin[A];
      End;
End;

{ͻ
                       PROCEDURE DEFINE_SOURCE_PREFS                        
 ͼ}

Procedure DEFINE_SOURCE_PREFS;
Var W1            :TWindow;                 {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;             {*Annulation Modifications*}
    But1,But2,But3,
    But4          :TButton;                {*Buttons Structure*}
    Cyc1,Cyc2     :TCycler;                {*Cyclers Structure*}
    TRad          :Array[1..7] of TRadioBox;  {*Structure pour Radios*}
    Com1,Com2,Com3,
    Com4          :TInputText;              {*Commands Structure*}
    Cin1,Cin2,Cin3,
    Cin4          :String;              {*Strings for Commands*}
    Lp            :Integer;
    Code          :Integer;             {*Error Code*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_CYCLER;                {*Define Cycler*}
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Cycler( LaF*48, HaF*14+6,LaF*22,Cyc2.CyclVal, CLTextButton,CLBgButton,$0,Cyc2,Language.Loc(854));
If Cyc1.CyclVal=1 Then Cycler_Freeze(Yes,Cyc2)
                  Else Cycler_Freeze(No,Cyc2);
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Var Lp:Integer;
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*4, HaF*3+1, LaF*80, HaF*25+1,CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*22,HaF*2+1, LaF*62, HaF*3+6, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*8, HaF*5+3, CLText, Language.Loc(855));
Display( LaF*8, HaF*7+3, CLText, Language.Loc(856));
Display( LaF*49,HaF*18+6,CLText,'X +');
Display( LaF*63,HaF*18+6,CLText,'Y +');
Display( LaF*52,HaF*10+6,CLText,Language.Loc(864));
Display( LaF*28,HaF*2+3, CLWhite,Language.Loc(865));

For Lp:=1 to 7 do                       {*Initialise Radios*}
   RadioBox(LaF*40, HaF*8+6+Lp*HaF*2, 1,$00,0,11,TRad[Lp].Status,TRad[Lp],Language.Loc(856+Lp));

Button( LaF*18, HaF*26+6,LaF*18,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*46, HaF*26+6,LaF*18,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
Button( LaF*48, HaF*20+6,LaF*28,-1, CLTextButton,CLBgButton,$0,But3,Language.Loc(866));
Button( LaF*48, HaF*22+6,LaF*28,-1, CLTextButton,CLBgButton,$0,But4,Language.Loc(867));
Cycler( LaF*48, HaF*12+6,LaF*22,Cyc1.CyclVal, CLTextButton,CLBgButton,$0,Cyc1,Language.Loc(868));

InputText( LaF*28, HaF*5+2,LaF*48,255, CLSky,CLSalmon,1,$27,Com1,Cin1);
InputText( LaF*28, HaF*7+2,LaF*48,255, CLSky,CLSalmon,1,$26,Com2,Cin2);
InputText( LaF*54, HaF*18+6,LaF*6,255, CLBlue,CLLightBlue,1,$26,Com3,Cin3);
InputText( LaF*68, HaF*18+6,LaF*6,255, CLBlue,CLLightBlue,1,$26,Com4,Cin4);

If TRad[1].Status=True Then InPutText_Freeze(No,Com1)  {*Freeze Eventually*}
                       Else InPutText_Freeze(Yes,Com1);
Win_Clip(No,W1);                    {*Restore Normal Clipping*}

REDRAW_CYCLER;                          {*Define Cycler*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(90,55,90+LaF*84,55+HaF1+HaF*28+6,$51D9,Language.Loc(652),W1) Then Exit;
Win_Sup(100,50,250,200,79,60,639,479,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                        {*Display Window*}

Cin1:=Name_Prog;                        {*Init Right Values*}
Cin2:=Name_Proc;
TRad[1].Status:=Gen_Prog;
TRad[2].Status:=Gen_Rem;
TRad[3].Status:=Gen_Menu;
TRad[4].Status:=Opt_Source;
TRad[5].Status:=Rel_PWin;
TRad[6].Status:=Perso_Init;
TRad[7].Status:=Perso_Done;
Cyc1.CyclVal:=Gen_Forp;
Cyc2.CyclVal:=Func_Type;
Str(Rel_Px,Cin3);
Str(Rel_Py,Cin4);

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No; Cancel:=No;             {*Flags de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But3,1)=CMSelected Then DEF_INIT_DONE_PROC(W1.X1+20,W1.Y1+30,1,'DEFINE INITIALISATION CODE');
   If Button_GetMsg(But4,1)=CMSelected Then DEF_INIT_DONE_PROC(W1.X1+20,W1.Y1+30,2,'DEFINE TERMINATION CODE');
   If Cycler_GetMsg(Cyc1,1)=CMSelected Then REDRAW_CYCLER; {*Define Cycler*}
   Cycler_GetMsg(Cyc2,1);

   For Lp:=2 to 7 do RadioBox_GetMsg(TRad[Lp],1);

   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   InputText_GetMsg(Com4,Cin4);
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}

   If RadioBox_GetMsg(TRad[1],1)<>CMNone Then      {*Test Radio Boxes*}
      If TRad[1].Status=True Then InPutText_Freeze(No,Com1)
                             Else InPutText_Freeze(Yes,Com1);
   End;

Even:=Win_Test(W1);                {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}
Win_Done(W1);                        {*Close Window if Needs*}

If Cancel=No Then Begin
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   Name_Prog:=Cin1;                     {*Define New Values*}
   Name_Proc:=Cin2;
   Gen_Prog:=  TRad[1].Status;
   Gen_Rem:=   TRad[2].Status;
   Gen_Menu:=  TRad[3].Status;
   Opt_Source:=TRad[4].Status;
   Rel_PWin  :=TRad[5].Status;
   Perso_Init:=TRad[6].Status;
   Perso_Done:=TRad[7].Status;
   Gen_Forp:= Cyc1.CyclVal;
   Func_Type:=Cyc2.CyclVal;
   Val(Cin3,Rel_Px,Code);
   Val(Cin4,Rel_Py,Code);
   End;
End;

{ͻ
                           TESTE ITEMS ET WINDOW                            
 ͼ}

Procedure TEST_ITEMS_WINDOW(Var M:TMenu);
Var Even,A,CPro:Integer;
    NUM:Integer;
    DirSel,FilSel:String;
    Size:Longint;
    P:TProgress;                          {*Pour le Progress Requester*}
    Px,Py:String[10];
    St:String;
    FontName:String;

Begin
If Gad_Exist=No Then Exit;                {*Pas de Gadgets  Tester*}
Sys.SetGrid:=My_Grid;                            {*Utilise Grille si Existe*}
Even:=Win_Test(W);                   {*Rceptionne Evnements*}
If Even=CMClosed Then Begin                      {*Close Window*}
   CREATE_UNDO(M);                        {*Sauve les Paramtres de la fentre*}
   UNDO_ACTION(M);                        {*Restaure la Fentre comme elle tait*}
(*   Win_Exist:=False;
   Gad_Exist:=False;                      {*Gadgets N'existent pas*}
*)
   End;
If (Even=3) Or (Even=4) Or (Even=9) Then  {*Extend, Resize,Dplace*}
   Begin
   BSET(Has_Changed,Num_Pro);             {*Une Modification a t Faite*}
   REDRAW_WINDOW(M);                      {*Fentre Extend*}
   End;
Sys.SetGrid:=No;                                {*Plus de Grille Gnerale*}

If Win_Ready(W) Then Begin

{====================== TEST ET ACTIONS DES BOUTONS =========================}

   Win_Clip(Yes,W);                     {*Clipping pour Test des Gadgets*}
   For A:=1 to Qtt_ITM[1] do              {*Teste Boutons*}
      If Button_GetMsg(TBU[A].B,TBU[A].MoA)=CMSelected Then
         If Full_Simul=Yes Then            {*Simulation Appel Requesters*}
            Case TBU[A].Action of
               1 : Begin Num:=4;          {*Exit With Ok...*}
                   Req_Dialog(Language.Loc(461),Language.Loc(552),'   _OK   ',NUM);
                   End;
               2 : Begin Num:=4;          {*Exit With Cancel...*}
                   Req_Dialog(Language.Loc(461),Language.Loc(750),'   _OK   ',NUM);
                   End;
               4 : Begin Num:=4;          {*Call Another Requester*}
                   Req_Dialog(Language.Loc(461),Language.Loc(553)+Proc_Name,'   _OK   ',NUM);
                   End;
               30: Begin                  {*EZ Requester*}
                   If REzV.BCenter=Yes Then DirSel:='#0' Else DirSel:='';
                   Num:=REzV.NumIco;      {*Set Icne*}
                   Req_Dialog(REzV.Title,DirSel+REzV.Phrase,REzV.Gadget,NUM);
                   End;
               31: Begin                  {*Font Requester*}
                   FontName:=Sys.FontMain;
                   Req_Font(RFntV.X1,RFntV.Y1,RFntV.Name,FontName,RFntV.Size_Sel);{Old Value = RFntV.Font_Sel}
                   End;
               32: Begin                  {*String Requester*}
                   If RStV.BCenter=Yes Then DirSel:='#0' Else DirSel:='';
                   Num:=RStV.NumIco;      {*Set Icne*}
                   Req_String(RStV.Name,DirSel+RStV.Txt,RStV.Gad,RStV.NbChar,RStV.Size,RStV.Str,NUM );
                   End;
               33: Begin                  {*Value Requester*}
                   If RVaV.BCenter=Yes Then DirSel:='#0' Else DirSel:='';
                   Num:=RVaV.NumIco;      {*Set Icne*}
                   Req_Value(RVaV.Name,DirSel+RVaV.Txt,RVaV.Gad,RVaV.BMin,RVaV.BMax,RVaV.Vai,NUM );
                   End;
               34: Begin                  {*RGB Picker Requester*}
                   Req_GetRGBColor(RPalV.X1,RPalV.Y1,0,1,$0007,RPalV.Name);
                   End;
               35: Begin                  {*Memory Requester*}
                   //Req_Memory(RMemV.X1,RMemV.Y1,RMemV.Name);
                   End;
               36: Begin                  {*Hardware Requester*}
                   Sys_Hardware(RHardV.X1,RHardV.Y1);
                   End;
               37: Begin                  {*Progress Requester*}
                   CPro:=0; Req_ProgressInit(P);
                      Repeat
                      MAIN_TASK; Str(CPro,DirSel);
                      Req_Progress(RProV.Name,RProV.Explain+' '+DirSel,-1,-1,CPro,RProV.Cob,P);
                      Delay(15); Inc(CPro);
                      Until (P.Abort=True) Or (CPro>100);
                   End;
               38: Begin DirSel:='';      {*File Requester*}
                   Req_FileManager(RFileV.X1,RFileV.Y1,RFileV.Sv,RFileV.Name,
                   RFileV.OkBut,RFileV.Mask,RFileV.Style,DirSel,FilSel,Size);
                   If RFileV.SendToCom=True Then Begin
                      TCO[RFileV.FPath].Cin:=''; TCO[RFileV.FName].Cin:='';
                      If RFileV.FPath>0 Then TCO[RFileV.FPath].Cin:=TCO[RFileV.FPath].Cin+DirSel;
                      If RFileV.FName>0 Then TCO[RFileV.FName].Cin:=TCO[RFileV.FName].Cin+FilSel;
                      If RFileV.FSize>0 Then Str(Size,TCO[RFileV.FSize].Cin);
                      REDRAW_WINDOW(M);
                      End;
                   End;                   {*Attrib Requester*}
               39: Req_FileInformation(RAttrV.X1,RAttrV.Y1,RAttrV.Name,'File information');
               40: Req_Register;     {*Register Requester*}
               60: Begin
                   Str(RSysV.X1,Px);      {*System Requester*}
                   Str(RSysV.Y1,Py);
{                   Call_System('-MSA=1 -WPX='+Px+' -WPY='+Py+' -PS1='+RSysV.Name);}
                   End;
               61..96: Begin
                   Str(TBU[A].Action,St);
                   Str(RExt[A].X1,Px);    {*Call External System / NET Requester*}
                   Str(RExt[A].Y1,Py);
{                   Call_System('-MSA='+St+' -WPX='+Px+' -WPY='+Py);}
                   End;

               End;
   For A:=1 to Qtt_ITM[2] do              {*Teste Cyclers*}
      Cycler_GetMsg(TCY[A].B,TCY[A].MoA);
   For A:=1 to Qtt_ITM[3] do              {*Teste Radios*}
      RadioBox_GetMsg(TRB[A].R,TRB[A].MoA);
   For A:=1 to Qtt_ITM[5] do              {*Teste Commands*}
      InputText_GetMsg(TCO[A].T,TCO[A].Cin);

{====================== TEST ET ACTIONS DES SLIDERS =========================}

(*   For A:=1 to Qtt_ITM[4] do              {*Teste Sliders*}
      If Slider_GetMsg(TSL[A].S,TSL[A].MoA)=CMModified Then Begin
         CPro:=RSldV[A].ComNum;           {*Numro du InputText  Toucher*}
         If (CPro>0) And (CPro<=Qtt_ITM[5]) Then Begin
            Str(TSL[A].S.Psl,TCO[CPro].Cin);{*Transmet Rsult to InputText*}
            InputText(TCO[CPro].X1, TCO[CPro].Y1-HaF1, TCO[CPro].T.Siz, TCO[CPro].T.Len,
                         TCO[CPro].T.CoB, TCO[CPro].T.Co2, TCO[CPro].T.Sty, $0, TCO[CPRo].T ,TCO[CPro].Cin);
            If TCO[CPro].Freeze=Yes Then InPutText_Freeze(Yes,TCO[CPro].T);
            End;
         End;*)
   Win_Clip(No,W);                    {*Fin de Clipping pour Test Gadgets*}
   End;
End;

{ͻ
                        SAVE PROJECTS BEFORE QUITTING                       
 ͼ}

Function ASKTOSAVE_CURRENT_PROJECT(Var M:TMenu):Boolean;
Var A,NUM:Integer;
    Fil1:Text;
    St:String;
    Ignore:Boolean;                             {*Ignore All Projects*}
    SvAll:Boolean;                              {*Sauvegarde de tous les Projets*}

Begin
Save_FileName:=GET_PROJECT_NAME(M,Num_Pro)+'.TMP';{*Save Current Projet en ".TMP"*}
If Qtt_Pro>1 Then SAVE_PROJECT(M,2);            {*Au moins 2 Projects...*}
Ignore:=False;
SvAll:=False;
For A:=1 to Qtt_Pro do Begin                    {*Passe en revue les Projects*}
   If BTST(Has_Changed,A) Then Begin            {*Project Modified ?*}
      Nom_Undo:=Get_Project_Name(M,A)+'.TMP';   {*Get Projet Name en ".TMP"*}
      If (Qtt_Pro>1) And (Not Ignore) Then
         Load_Project(M,1);                     {*Reload Project*}
      If Qtt_Pro=1 Then Save_FileName:=''       {*Pas de Nom de Base*}
                   Else Save_FileName:=Get_Project_Name(M,A)+'.MRE';{*Get Projet Name en ".MRE"*}
      Dec(Num_Pro);
      If (Not SvAll) And (Not Ignore) Then Begin
         Num:=3;                                {*Icne Question*}
         Req_Dialog(Language.Loc(461),Language.Loc(556),Language.Loc(557),NUM);
         If NUM=1 Then SAVE_PROJECT(M,1);       {*Save le Projet*}
         If NUM=2 Then Begin Save_FileName:='';
                       SAVE_PROJECT(M,1); End;  {*Save as => Get Name*}
         If NUM=3 Then SvAll:=True;             {*Save Tous les Projets*}
         If NUM=5 Then Ignore:=True;            {*Ignore All Projects*}
         If (NUM=6) Or (NUM=0) Then
            Begin ASKTOSAVE_CURRENT_PROJECT:=True;
            Inc(Num_Pro); Exit;
            End;
         End;
      If SvAll Then SAVE_PROJECT(M,1);          {*Save Automatik de tt Projets*}
      Inc(Num_Pro);
      End;
   St:=Dsk_GetCurrentDirectory+Get_Project_Name(M,A)+'.TMP';
   If (File_TestExist(St)) And (Qtt_Pro>1) Then
      Begin Assign(Fil1,St); Erase(Fil1); End;  {*Delete Project Temporaire*}
   End;
ASKTOSAVE_CURRENT_PROJECT:=False;
End;

{ͻ
                       INITIALISATION FENETRE DE BASE                       
 ͼ}

Procedure INIT_WINDOW0;
Begin
W0.X1:=120; W0.Y1:=80; W0.X2:=520; W0.Y2:=250;
W0.Name:=Language.Loc(558);
W0.IDCMP:=$51DF;
W0.Xu:=100; W0.Yu:=50; W0.Xv:=250; W0.Yv:=200;
W0.XMin:=79; W0.YMin:=60;
W0.XMax:=VESA_GetMaxX; W0.YMax:=VESA_GetMaxY;
W0.IDRES:=$10;
W0.BarSld:=0;
W0.Coul:=CLWinBorder;
WSizeX:=W0.X2-W0.X1; WSizeY:=W0.Y2-W0.Y1;
End;

{ͻ
                         REINIT ALL POUR NEW WINDOW                         
 ͼ}

Procedure REINIT_ALL_WINDOW(Var M:TMenu);
Begin
BCLR(Has_Changed,Num_Pro);              {*Rinit Changements*}
Gad_Exist:=True;                        {*Gadgets Existent*}
Show_Screen;                            {*Raffiche le fond de l'cran*}
Win_Init(W0.X1,W0.Y1,W0.X2,W0.Y2,W0.IDCMP,W0.NAME,W);
Win_Sup(W0.Xu,W0.Yu,W0.Xv,W0.Yv,W0.Xmin,W0.YMin,W0.XMax,W0.YMax,W0.BarSld,W0.Coul,W0.IDRES,W);
REDRAW_WINDOW(M);                       {*Raffiche le Contenu de Window*}

POS_TO_0;                               {*Rinit Positions for Cycles  0*}

M.TbMen[8,1]:='Project: ''''';          {*Name Cleared*}
Save_FileName:='';
End;

{ͻ
                             PROGRAMME PRINCIPAL                            
 ͼ}

Begin
End.
