{ͻ
                               UNIT MosExecute                              
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 01.06.1995                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Management of swap ( Allow yours programs to exit to dos     
               with the maximun memory free, like the dos shell of tp7)     
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 400 Lines and (8.400 Bytes compiled)                         
  LAST UPDATE: 27.12.1999 at 15:19                                          
  FROM.......: Copyright (c) 1988 TurboPower Software  (Free)               
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosExecute;

{$MODE objfpc}

INTERFACE

{|Execute|}
Procedure Execute(Path, CmdLine : String;Flg:word); {*Execute an external application*}
Procedure DOS_Shell;                                     {*Make a DOS Shell*}

{|Show graphics|}
Procedure Show_GFX(S:String; Imgflag:Byte);    {*Show the GIF*}

IMPLEMENTATION

Uses
     Dos,
     MosBase,
     MosConfig,
     MosCPUInstructions,
     MosCrt,
     MosErrors,
     MosFiles,
     MosGraphics,
     MosMouse,
     MosStrings,
     MosTasks;

{ͻ
                             PROCEDURE Execute                              
 ͹
  IN.....: Path    (STRING) : Path + NameFile + Extension                   
           Cmdline (STRING) : Command line parameter                        
           Flg     (WORD)   :                                               
  Bit  for Flg                                                              
   0   0001   Video mode                                  [Save_Image]      
   1   0002   Colors palette                              [Save_Image]      
   2   0004   Screen picture                              [Save_Image]      
   3   0008   Mouse pointer                               [Save_Image]      
   4   0010   Mouse coordinates                           [Save_Image]      
   5   0020   Mouse speed                                 [Save_Image]      
   6   0040   Make a Mse_Show                             [Save_Image]      
   7   0080   Make a Mse_Hide after save_screen           [Save_Image]      
   8   0100   Parameters VESA_SetViewPort                 [Save_Image]      
   9   0200                                                                 
   10  0400   Don't make init_mouse & done_mouse                            
   11  0800   Ask to Execute to don't use Save_Image                        
   12  1000   Execution of an external MOS program.                         
   13  2000   Show the DOS message : XXX bytes swapped                      
   14  4000   Change mode to text mode                                      
   15  8000   Make a Wait at the end                                        
  OUT....: /                                                                
  EXPLAIN: This procedure is very powerful because it free a maximum of     
           conventional memory useful to the program to execute.            
           It swap the contain of memory to disk.                           
  BUGS   : The programer must put all the interrupts like before they was   
           set to other values :                                            
  EXAMPLE: Path = 'c:\utils\arj.exe'                                        
           Cmdline = '-?'                                                   
           The programer have to make like this example :                   
           Restore_Old_Interrupt;                                           
           Execute('c:\utils\arj.exe','-?',$FFFF);                          
           New_Interrupt;                                                   
  SEEALSO: DOS_Shell                                                        
  CF.....: Exec from Tp7                                                    
 ͼ}

Procedure Execute(Path, CmdLine:String; Flg:Word);
Var chemin:string;
{    loc1,loc2:string;}
    F:Text;FN:String;

Begin
// To avoid warnings !
Path := Path;

(*Loc1:=loc(233);
Loc2:=loc(234);       {*Texte  afficher ?? BUG*}
*)
If BTST(Flg,12) Then
  Begin
  FN:=FExpand(File_BuildNextName(Sys.GetPath(SP_TEMP)+'SWAP.CL', FEValue));
  Assign(F,FN);
  Rewrite(F);
  Writeln(F,CmdLine);
  Close(F);
  End;
getdir(0,chemin);

{*Calcul du flag pour save_image *}
If $0400 And Flg=0 Then Done_Mouse;

{If $0800 And Flg=0 Then}
If $01FF And Flg<>0 Then
  Begin
  SAVE_SCREEN($01FF);
  End;
{* Choisit le nom a affecter *}


Done_Sound;                             {*Play end sound and Stop Buzzer*}
Done_Locale;                            {*Remove locale file from memory*}

if flg and $4000=$4000 then textmode(3);
{If flg and $2000=$2000 Then WriteLn(Loc1,' ', BytesSwapped, ' ',Loc2);}

SwapVectors;

//If BTST(Flg,12) Then Exec(GetEnv('COMSPEC'),'/C '+Path+' -CMD='+FN)
//                Else Exec(GetEnv('COMSPEC'),'/C '+Path+' '+CmdLine);

SwapVectors;

If flg and $8000=$8000 then readkey;

Init_Locale;                            {*Load locale file*}
Init_Sound;                             {*Init sound and play if needs*}

Chdir(chemin);

{If $0800 And Flg=0 Then}
If $01FF And Flg<>0 Then
  Begin
  RESTORE_SCREEN;
  End;
If $0400 And Flg=0 Then Init_Mouse;

main_task;
If BTST(Flg,12) Then File_Erase(FN);
(*Screen_BlankerInit;                  {*Rinitialise le screen blanker*}*)
End;

{ͻ
                            PROCEDURE DOS_SHELL                             
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Return to DOS and free maximum of memory.                        
           To come back to the program we quit, you have only to hit "exit" 
           on the keyboard.                                                 
  BUGS   : The programer must put all the interrupts like before they was   
           set to other values :                                            
  EXAMPLE: The programer must do like this example :                        
           Restore_old_interrupt;                                           
           doc_shell;                                                       
           New_interrupt;                                                   
  SEEALSO: Execute                                                          
 ͼ}

Procedure DOS_SHELL;
var chemin:string;
    loc3:string;
begin
Loc3:=Language.Loc(235);

getdir(0,chemin);
Done_Mouse;
SAVE_SCREEN($FFFF);

Done_Sound;                             {*Play end sound and Stop Buzzer*}
Done_Locale;                            {*Remove locale file from memory*}

textmode(3);
Write(Loc3);
SwapVectors;
//Exec(GetEnv('COMSPEC'), '');
SwapVectors;
Init_Locale;                            {*Load locale file*}
Init_Sound;                             {*Init sound and play if needs*}
Chdir(chemin);

RESTORE_SCREEN;
Init_Mouse;
Main_Task;
(*Screen_BlankerInit;                     {*Rinitialise le screen blanker*}*)
End;

{ͻ
                             PROCEDURE SHOW_GFX                             
 ͹
  IN.....: S (STRING) = Path + Name of a file.                              
           ImgFlag (BYTE)                                                   
           Bit 1 = Wait                                                     
               2 = Save_Img                                                 
  EXPLAIN: This procedure launch PV to view a file (Pictures...)            
  SEEALSO: BMP_Show                                                         
 ͼ}

Procedure SHOW_GFX(S:String;Imgflag:byte);
Var Flag:Word;
Begin
S:=Fexpand(s);
If Not File_TestExist(Sys.GetPath(SP_TOOLS)+'PV.EXE') Then
  Begin                                         {*Viewer not present*}
  Error(755);
  Exit;
  End;
If S='' Then                                    {*File not specified*}
  Begin
  Error(561);
  Exit;
  End;

If Not(File_TestExist(S)) Then                  {*File not found    *}
  Begin
  Error(720);
  Exit;
  End;

Flag:=0;
If ImgFlag And $2<>$2 Then Flag:=$1FF Else Flag:=$400;
If ImgFlag And $1=$1 Then Flag:=Flag Or $8000;
Execute(Sys.GetPath(SP_TOOLS)+'PV.EXE',s,Flag);
End;


begin
end.
