{ͻ
                     M.R.E (MOS RESOURCE EDITOR) v2.8                       
 ͹
                  UNITE DE GESTION DE L'ACTION DES BOUTONS                  
 ͹
  Coded by Zuul as BouFFtou as Cheveau Frdric.                            
  Programm  Toulouse COG (Gendarmerie) sur Turbo Pascal v7.00.            
  Contact us on the NET : ZuulCoder@Hotmail.Com or Sybaris@Multimania.Com   
 ͼ}

Unit MRE_ACTS;                           {*Nom du l'Unit*}

{$Mode Objfpc}

Interface

Uses MosCrt,                            {*Unit CRT pour MOS*}
     MosBase,
     MosDisks,
     MosMouse,                            {*Gestion de la Souris*}
     MosTools,                            {*Gestion des Tools et Box*}
     MosGadgets,                            {*Gestion des Gadgets*}
     MosTab,
     MosCPUInstructions,
     MosRequests,                            {*Gestion des Requesters*}
     MosDialogs,
     MosMenu,                            {*Gestion des Menus*}
     MosWindows,                            {*Gestion des Fentres*}
     MosDirectory,                            {*Gestion du Directory*}
     MosFiles,
     MosConfig,
     MosText,
     MosColors,
     Dos;

Const Esp='                                                                ';
      Bev_Style=1;                       {*Def Const pour Bevels Entries*}
      Bev_Coul=6;

      Max_ITM=10;                        {*10 Types d'Items Diffrents*}

      Max_TBB=20;                        {*Define Maximum for Array Gadgets*}
      Max_TSB=20;
      Max_TXT=20;
      Max_TBU=20;
      Max_TCY=10;
      Max_TRB=30;
      Max_TSL=10;
      Max_TCO=10;
      Max_IMG=10;
      Max_ONG= 3;

      TMB:Array[1..5] of Byte=(0,1,2,3,10);{*Mouse Buttons Test...*}

Type Window0=Record
    X1,Y1,X2,Y2  :Integer;
    Xu,Yu,Xv,Yv  :Integer;               {*2nd Coordones Window for Extend*}
    XMin,YMin    :Integer;               {*Taille minimum de la Fentre*}
    XMax,YMax    :Integer;               {*Taille maximum de la Fentre*}
    Name         :String;                {*Name de la Fentre*}
    IDCMP        :Word;                  {*Flags IDCMP Window*}
    IDRES        :Word;                  {*Flags IDCMP Window*}
    BarSld       :Integer;               {*Nb Sliders Hz or Vertical ou None*}
    Coul         :Longint;               {*Couleur de Fond de la Fentre*}
    End;

    TBevel=Record                        {*Struct pour Bevel*}
    X1,Y1,X2,Y2:Integer;
    Style:Integer;
    Co:Longint;
    Cave,Fill:Boolean;
    End;

    TText=Record                         {*Struct pour Labels Textes*}
    X1,Y1:Integer;
    CP,CB:Longint;
    Cin:String[42];
    TyF,SiF:Byte;
    Style:Byte; {F}
    TFont,SFont:Byte; {F}
    End;

    TButG=Record                         {*Record Buttons*}
    X1,Y1,SX,SY:Integer;
    Id:Byte;
    VanillaKey:Byte;
    Action:Byte;
    Cin:String;
    B:TButton;
    MoA:Byte;
    End;

    TCycG=Record                         {*Record Cycler*}
    X1,Y1,SX,SY:Integer;
    Id:Byte;
    VanillaKey:Byte;
    Action:Byte;
    Cin:String;
    B:TCycler;
    MoA:Byte;
    End;

    TRad=Record                          {*Record Radios*}
    X1,Y1:Integer;
    R:TRadioBox;
    MoA:Byte;
    End;

    TSlide=Record                        {*Record Sliders*}
    X1,Y1,X2,Y2:Integer;
    S:TSlider;
    MoA:Byte;
    End;

    TTCoReq=Record                       {*Record Commands*}
    X1,Y1:Integer;
    Freeze:Boolean; {D Useless...}
    Cin:String;
    T:TInputText;
    Id:Word;  {F Transfrer T.Id dans Id}
    End;

    TImage=Record                        {*Record Images BMP/ICO*}
    X1,Y1,X2,Y2:Integer;
    Ox,Oy:Integer;
    Use_MSize:Boolean;
    Use_Pal:Boolean;
    IType:Byte;                          {*0=Icon, 1=BMP*}
    FName:String;
    End;

    MTabs=Record                       {*Record Tabss*}
    X1,Y1,X2,Y2:Integer;
    Cin:String;
    O:TTabs;
    End;

{****************************************************************************}

Var W            :TWindow;                   {*Structure Fentre*}
    W0           :Window0;               {*Stocke Value Window*}
    Gad_Exist    :Boolean;               {*Gadgets Exists*}
    NUndo        :Byte;                  {*Numro de l'Undo*}
    Qtt_Pro      :Byte;                  {*Quantit de Projets ds la Fentre*}
    Num_Pro      :Byte;                  {*Numro du Projet Actuel*}
    Load_External:Boolean;               {*Get nom du Projet en Externe*}

    Gen_Prog     :Boolean;               {*Genre Programme Entier*}
    Gen_Rem      :Boolean;               {*Genre Remarques dans Prog*}
    Gen_Menu     :Boolean;               {*Genre le Code pour le Menu*}
    Gen_Cancel   :Boolean;               {*Generate Source "Cancel"*}

    Name_Prog    :String[30];            {*Nom du Programme*}
    Name_Proc    :String[30];            {*Nom de la Procdure*}
{Save_Conv    :String;}                {*Convertion CONVERT.EXE*}
    Rel_PWin     :Boolean;               {*Position Relative de la Fentre*}
    Rel_Px       :Integer;               {*Delta X de la Position Relative*}
    Rel_Py       :Integer;               {*Delta Y de la Position Relative*}
    Perso_Init   :Boolean;               {*Initialisations Personnelles*}
    Perso_Done   :Boolean;               {*Terminaisons Personnelles*}
    Gen_Forp     :Byte;                  {*Generate Procedure=1*}
    Func_Type    :Byte;                  {*Type Renvoy par la Fonction*}
    Max_Lines    :Byte;                  {*Nb Max de Lignes d'Init et Done de Code*}
    Init_Code    :Array[1..8] of String[80];{*Init Code (Max_Line=8)*}
    Done_Code    :Array[1..8] of String[80];{*Init Code (Max_Line=8)*}
    CGL_Qtt      :Byte;                  {*Qtt de Lignes pour Split*}
    CGL_Pos      :Byte;                  {*Pos Actuelle dans Lignes*}
    CGL_Inc      :Boolean;               {*Incrments des Lignes ? 1=Yes*}
    CGC_Qtt      :Byte;                  {*Qtt de Colonnes pour Split*}
    CGC_Pos      :Byte;                  {*Pos Actuelle dans Colonnes*}
    CGC_Inc      :Boolean;               {*Incrments des Colonnes ? 1=Yes*}

    My_Grid      :Boolean;               {*Pour Redfinir Grid QuSys.SetGridje Veux*}
    Disp_Beep    :Boolean;               {*Display Beep ifBeep_Modulo*}
    Show_MCoo    :Boolean;               {*Show Mouse Coordones*}
    Show_Report  :Boolean;               {*Show Report when save Source*}
    Full_Simul   :Boolean;               {*Full Simulation when Message*}
    Conf_Del     :Boolean;               {*Confirm Item Deletion*}
    Opt_Source   :Boolean;               {*Optimize Source*}

    Save_FileName:String[12];            {*Nom Sauvegarde Projet*}
    Nom_Undo     :String[12];            {*Nom du Fichier Undo*}
    Xold,Yold    :Word;                  {*Ancienne position souris*}
    OPos,OType   :Integer;               {*Old Type & Item Selected by Mouse*}
    NPos,NType   :Integer;               {*New Type et Pos dans Liste*}

    Lb1          :TLightBox;                {*Structure GetMsg_LightBox*}
    Item         :Byte;                  {*Type de Gadget Utilis Actuellement*}
    Has_Changed  :Word;                  {*Bits de Projets Modifis ?*}
    WSizeX,WSizeY:Integer;               {*Taille Window de Test X et Y*}

    Qtt_ITM      :Array[1..Max_ITM] of Byte; {*Quantit de Chaque Gadgets*}

    Pos_ITM      :Array[1..Max_ITM] of Shortint; {*Position dans Tableau pour Gadgets*}

    TBU   :Array[1..Max_TBU] Of TButG;   {*Tableau Boutons*}
    TCY   :Array[1..Max_TCY] Of TCycG;   {*Tableau Cyclers*}
    TRB   :Array[1..Max_TRB] Of TRad;    {*Tableau Radio Boxes*}
    TSL   :Array[1..Max_TSL] Of TSlide;  {*Tableau Sliders*}
    TCO   :Array[1..Max_TCO] Of TTCoReq; {*Tableau InputText Strings*}
    TBB   :Array[1..Max_TBB] Of TBevel;  {*Tableau Bevels Boxes*}
    TSB   :Array[1..Max_TSB] Of TBevel;  {*Tableau String Boxes*}
    TXT   :Array[1..Max_TXT] Of TText;   {*Tableau Labels Texte*}
    IMG   :Array[1..Max_IMG] Of TImage;  {*Tableau Images BMP/ICO*}
    ONG   :Array[1..Max_ONG] Of MTabs; {*Tableau Tabss*}

Var Menu:TMenu;                          {*Menu Temporaire et Menu dfinitif*}
    Qtt_Menu:Byte;                       {*Nombre de Menus et Labels ds Menu*}
    Menu_Num,Point_Num:Byte;             {*Menu Label et Menu Point Courant*}
    Qtt_MenuP:Array[1..Max_Menu_Points] of Byte;{*Nb de Points dans Menus*}

{============================================================================}

Type RFileR=Record                       {*Record File Requester*}
    X1,Y1,Sv:Integer;
    Name    :String[100];
    OkBut   :String[16];
{F}    Mask    :String[6];      {Mettre  100 Char}
    Style   :Byte;
    SendToCom:Boolean;
    FPath,FName,FSize:Byte;
    End;

Type RPalR=Record                        {*Record Palette Requester*}
    X1,Y1   :Integer;
    Name    :String[100];
    ColSel  :Byte;
    End;

Type RMemR=Record                        {*Record Memory Requester*}
    X1,Y1   :Integer;
    Name    :String[100];
    End;

Type RHardR=Record                       {*Record Hardware Requester*}
    X1,Y1   :Integer;
    Name    :String[100];
    End;

Type RSysR=Record                        {*Record System Requester*}
    X1,Y1   :Integer;
    Name    :String[100];
    SMosIni :Boolean;
    End;

Type REzR=Record                         {*Record EZ Requester*}
    Title   :String[100];
    Phrase  :String;
    Gadget  :String[150];
    TestRes :Boolean;
    BCenter :Boolean;
    NumIco  :Byte;
    End;

Type RFntR=Record                        {*Record Font Requester*}
    X1,Y1   :Integer;
    Name    :String[100];
    Font_Sel:Integer;
    Size_Sel:Longint;
    End;

Type RAttrR=Record                       {*Record Attrib Requester*}
    X1,Y1   :Integer;
    Name    :String[150];
    End;

Type RStR=Record                         {*Record String Requester*}
    Name    :String[150];
    Txt,Gad :String;
    Str     :String;
    NbChar  :Integer;
    Size    :Integer;
    TestRes :Boolean;
    BCenter :Boolean;
    NumIco  :Byte;
    End;

Type RVaR=Record                         {*Record Value Requester*}
    Name    :String[150];
    Txt,Gad :String;
    BMin,BMax:Longint;
    Vai     :Longint;
    TestRes :Boolean;
    BCenter :Boolean;
    NumIco  :Byte;
    End;

Type RProR=Record                        {*Record Progress Requester*}
    Name    :String[150];
    Explain :String[150];
    Cob     :Integer;
    End;

Type RSldR=Record                        {*Record Slider->InputText*}
    ComNum  :Integer;
    End;

Type RExter=Record                       {*Record External Requesters*}
    X1,Y1   :Integer;
    Exter   :Boolean;
    End;

Var Proc_Name    :String;                {*Nom de la Proc  Appeler*}
    RFileV       :RFileR;                {*Type pour Record*}
    RPalV        :RPalR;
    RMemV        :RMemR;
    RhardV       :RHardR;
    RSysV        :RSysR;
    REzV         :REzR;
    RFntV        :RFntR;
    RAttrV       :RAttrR;
    RStV         :RStR;
    RVaV         :RVaR;
    RProV        :RProR;
    RSldV :Array[1..MAX_TSL] of RSldR;   {*Tableau Sliders Actions*}
    RExt  :Array[1..MAX_TBU] of RExter;  {*Tableau Call External Requesters*}

{============================================================================}

Procedure BUTTON_ACTION(Pos:Byte);       {*Menu pour l'action des Boutons*}

Procedure ASK_SLIDER_TO_COMMAND(Pos:Integer);{*Def Slider to Command*}
Procedure TIC;                           {*Fait un tic (son)*}
Procedure SET_PNAME_IN_MENU(Var M:TMenu; FName:String);{*Modif Title Menu Projet*}
Procedure SAVE_PROJECT(Var M:TMenu; Mode:Byte); {*Mode: 0=Normal, 1=Update*}
Procedure CREATE_UNDO(Var M:TMenu);      {*Fait un Fichier UNDO*}
Function  PUISS(X,Exponent:Word):Word;   {*Fonction PUISSANCE d'un Nombre*}

Procedure INIT_MRE_ACTS;                 {*Initialisation des vars globales*}

Implementation

Uses
     SysUtils,
     MosErrors;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

{ͻ
                             PROCEDURE PUISS                                
 ͹
  MET A LA PUISSANCE PRECISEE PAR EXPONENT LE NOMBRE X.                     
 ͼ}

Function PUISS(X,Exponent:Word):Word;
Var A,Res:Integer;
Begin
If Exponent=0 Then Begin PUISS:=1; Exit; End;
Res:=1;
For A:=1 to Exponent do Res:=Res*X;
PUISS:=Res;
End;

{ͻ
                              PROCEDURE TIC                                 
 ͹
                   FAIT UN TIC QUAND ON APPELE LA PROCEDURE                 
 ͼ}

Procedure TIC;
Begin
If Disp_Beep=No Then Exit;
Sound(20);
Delay(10);
NoSound;
End;

{ͻ
                       PROCEDURE SET_PNAME_IN_MENU                          
 ͹
  MET DANS LE TITRE DU MENU LE NOM DU PROJET .MRE COURRANT...               
 ͼ}

Procedure SET_PNAME_IN_MENU(Var M:TMenu; FName:String);
Var FD           :DirStr;               {*For FSplit... and .TMP*}
    FN           :NameStr;
    FE           :ExtStr;
Begin
FSplit(FName, FD, FN, FE);
M.TbMen[8,1]:='Project: '''+FN+'.MRE''';
End;

{ͻ
                         SAUVEGARDE PROJET EN DATAS                         
  Mode : 2 = Sauvegarde ".TMP" pour MultiProjets                            
 ͼ}

Procedure SAVE_PROJECT(Var M:TMenu; Mode:Byte);  {*Mode: 0=Normal, 1=Update, 2=Undo*}
Var DirSel,FilSel,FName:String;
    Size         :Longint;
    F            :File;
    NUM,A,B      :Integer;
    St           :String;
    SR           :Array[1..Max_ITM] of Integer;{*Taille des Records*}

Begin
FilSel:=Save_FileName;                  {*FileName Courrant*}
DirSel:=Dsk_GetCurrentDirectory;
If (Mode=0) Or ((FilSel='') And (Mode>=1))
   Then Begin DirSel:='';               {*Mode "Save" With New Name*}
   Req_FileManager(50,32,282,Language.Loc(653),Language.Loc(460),'*.MRE',0,DirSel,FilSel,Size);
   End;

If FilSel<>'' Then Begin
   If Mode=2 Then FName:=DirSel+FilSel  {*Concatne pour Projet ".TMP"*}
      Else Begin
      A:=Pos('.',FilSel);               {*Search if Suffix Exist*}
      If A=0 Then FilSel:=FilSel+'.MRE';{*Append Suffix at Last*}
      FName:=DirSel+FilSel;             {*Concatne Nom*}
      End;
   If (File_TestExist(FName)) And (Mode=0) Then Begin
      Num:=3;                           {*Icne Question*}
      Req_Dialog(Language.Loc(461),Language.Loc(654),Language.Loc(463),Num);
      If Num<>1 Then Exit;              {*Fichier dja Existant !!!*}
      End;

   If Pos('\\',FName)>0 Then Delete(FName,3,1);{*Enlve 1 '\' sur les 2 car Root*}

   Assign(F,FName);
   {$I-}
   Rewrite(F,1);                        {*Create and Open File*}
   {$I+}
   If IOResult=0 Then Begin             {*No Errors ? => Ok !*}
      Mse_SetPointer(MPBusy);
      Save_FileName:=FilSel;            {*Redfinit Nom Fichier Sauvegarde*}
      SET_PNAME_IN_MENU(M,FilSel);      {*Update Title Menu Current Projet*}

      St:=Language.Loc(482)+Chr(10)+Chr(13); BlockWrite(F,St,21);
      St:=Language.Loc(655)+Chr(10)+Chr(13); BlockWrite(F,St,35);
      St:=Language.Loc(656)+Chr(10)+Chr(13); BlockWrite(F,St,43);
                                        {*Ecriture Source Prefs*}
      BlockWrite(F,Name_Prog,30);
      BlockWrite(F,Name_Proc,30);
      BlockWrite(F,Gen_Prog,1);
      BlockWrite(F,Gen_Rem,1);
      BlockWrite(F,Opt_Source,1);
      BlockWrite(F,Rel_PWin,1);
      BlockWrite(F,Perso_Init,1);
      BlockWrite(F,Perso_Done,1);
      BlockWrite(F,Gen_Forp,1);
      BlockWrite(F,Func_Type,1);
      BlockWrite(F,Rel_Px,2);
      BlockWrite(F,Rel_Py,2);
      BlockWrite(F,Show_Report,1);
      BlockWrite(F,Full_Simul,1);
      BlockWrite(F,CGL_Qtt,1);
      BlockWrite(F,CGL_Pos,1);
      BlockWrite(F,CGL_Inc,1);
      BlockWrite(F,CGC_Qtt,1);
      BlockWrite(F,CGC_Pos,1);
      BlockWrite(F,CGC_Inc,1);
      BlockWrite(F,HaF1,2);             {*Write Hauteur Fonte pour Update*}
      BlockWrite(F,W,Sizeof(W));        {*Write Window Parameters*}

      BlockWrite(F,Max_Lines,1);
      For Num:=1 to Max_Lines do        {*Save Init & Done Code Arrays...*}
         Begin
         BlockWrite(F,Init_Code[Num],Sizeof(Init_Code[Num]));
         BlockWrite(F,Done_Code[Num],Sizeof(Init_Code[Num]));
         End;

      For B:=1 to Max_ITM do Begin      {*Write Main Gadgets*}
         BlockWrite(F,Qtt_ITM[B],1);    {*Qtt of Gadgets*}
         Case B of
            1: SR[B]:=Sizeof(TBU[1]);
            2: SR[B]:=Sizeof(TCY[1]);
            3: SR[B]:=Sizeof(TRB[1]);
            4: SR[B]:=Sizeof(TSL[1]);
            5: SR[B]:=Sizeof(TCO[1]);
            6: SR[B]:=Sizeof(TBB[1]);
            7: SR[B]:=Sizeof(TSB[1]);
            8: SR[B]:=Sizeof(TXT[1]);
            9: SR[B]:=Sizeof(IMG[1]);
           10: SR[B]:=Sizeof(ONG[1]);
            End;
         BlockWrite(F,SR[B],2);         {*Write Records Sizes*}

         For A:=1 to Qtt_ITM[B] do
            Case B of
               1: BlockWrite(F,TBU[A],SR[B]);{*Write Buttons Parameters*}
               2: BlockWrite(F,TCY[A],SR[B]);{*Write Cyclers Parameters*}
               3: BlockWrite(F,TRB[A],SR[B]);{*Write Radios Parameters*}
               4: BlockWrite(F,TSL[A],SR[B]);{*Write Sliders Parameters*}
               5: BlockWrite(F,TCO[A],SR[B]);{*Write Commands Parameters*}
               6: BlockWrite(F,TBB[A],SR[B]);{*Write Bevel Parameters*}
               7: BlockWrite(F,TSB[A],SR[B]);{*Write String Boxes Parameters*}
               8: BlockWrite(F,TXT[A],SR[B]);{*Write Texts Parameters*}
               9: BlockWrite(F,IMG[A],SR[B]);{*Write Images Parameters*}
              10: BlockWrite(F,ONG[A],SR[B]);{*Write Tabss Parameters*}
               End;
         End;

      B:=0;
      BlockWrite(F,B,1);                     {*Qtt=0*}
      BlockWrite(F,B,2);                     {*Size=0*}

      {======================================================================}

      BlockWrite(F,Proc_Name,256);           {*Ecriture Nom Proc  Appeller*}

      BlockWrite(F,RFileV,Sizeof(RFileV));   {*Write File Requester Values*}
      BlockWrite(F,RPalV,Sizeof(RPalV));     {*Write Palette Requester Values*}
      BlockWrite(F,RMemV,Sizeof(RMemV));     {*Write Memory Requester Values*}
      BlockWrite(F,RHardV,Sizeof(RHardV));   {*Write Hardware Requester Values*}
      BlockWrite(F,RSysV,Sizeof(RSysV));     {*Write System Requester Values*}
      BlockWrite(F,REzV,Sizeof(REzV));       {*Write EZ Requester Values*}
      BlockWrite(F,RFntV,Sizeof(RFntV));     {*Write Font Requester Values*}
      BlockWrite(F,RAttrV,Sizeof(RAttrV));   {*Write Attrib Requester Values*}
      BlockWrite(F,RStV,Sizeof(RStV));       {*Write String Requester Values*}
      BlockWrite(F,RVaV,Sizeof(RVaV));       {*Write Value Requester Values*}
      BlockWrite(F,RProV,Sizeof(RProV));     {*Write Progress Requester Values*}

      For A:=1 to Max_TSL do BlockWrite(F,RSldV[A].ComNum,1);{*Write InputText to Slider*}

      {======================================================================}

      BlockWrite(F,Gen_Menu,1);         {*Ecriture des Paramtres du Menu*}
      BlockWrite(F,Qtt_Menu,1);         {*Write Qtt Menus*}

      For A:=1 to Qtt_Menu do Begin
         BlockWrite(F,Qtt_MenuP[A],1);  {*Write Qtt Menu Labels*}
         For B:=1 to Qtt_MenuP[A]+1 do
            BlockWrite(F,Menu.TbMen[A,B],Max_Length_Points); {*Write Labels*}
         End;

      {======================================================================}

      If Mode<2 Then BCLR(Has_Changed,Num_Pro); {*Rinit Modifications Potentielles*}

      Close(F);                         {*Ferme le Fichier*}
      Mse_SetPointer(P_Current);
      End
      Else Begin
      Num:=1;                           {*Icne Warning*}
      Req_Dialog(Language.Loc(461),Language.Loc(657),Language.Loc(469),NUM);
      End;
   End;
End;

{ͻ
                           PROCEDURE CREATE_UNDO                            
 ͼ}

Procedure CREATE_UNDO(Var M:TMenu);
Var PName:String;                       {*Sauvegarde nom du Projet*}
    Px:Integer;
Begin
PName:=Save_FileName;                   {*Backup of Project Name*}
{gotoxy(1,1); writeln('-',Save_Filename);}
Save_FileName:='MRE.U00';               {*Name of The Undo File*}
SAVE_PROJECT(M,2);                      {*Sauvegarde Automatique Boulot+Undo*}
Save_FileName:=PName;                   {*Restaure Nom Projet*}
Px:=Pos('.TMP',PName);
If Px>0 Then PName:=Copy(PName,1,Px)+'MRE';
M.TbMen[8,1]:='Project: '''+PName+'''';
{gotoxy(1,2); writeln('*',M.TbMen[8,1]);}
End;

{ͻ
                          PROCEDURE SELECT_SPICON                           
 ͼ}

Function SELECT_SPICON(Sp:Byte):Byte;
Var W1            :TWindow;                 {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Cancel        :Boolean;             {*Annulation Flag*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    But1,But2,But3:TButton;                {*Buttons Structure*}
    Cyc1          :TCycler;                {*Cyclers Structure*}
    OldSp         :Byte;                {*Old Value for Sp Icon*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure DRAW_SPICON;
Var Name:String;
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Name:=Sys.GetPath(SP_ICONS)+'I_inform.ico';
If Cyc1.CyclVal=Max_Ico+1 Then Name:='.ICO';
Button( LaF*31, HaF*5+1,LaF*7,-1, CLTextButton,CLBgButton,$0,But1,Name);
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*4,  HaF*3+1, LaF*42, HaF*10+1,CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*10, HaF*2+1, LaF*36, HaF*3+6, CLFLamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*29, HaF*4+6, LaF*40, HaF*9+1, CLLightGrey,BLLoweredLine,BLNoLine,Yes);
Display( LaF*16, HaF*2+3,15,Language.Loc(442));

Button( LaF*6, HaF*11+6,LaF*14,-1, CLTextButton,CLBgButton,$100,But2,'  _OK  ');
Button( LaF*25,HaF*11+6,LaF*14,-1, CLTextButton,CLBgButton,$0,But3,Language.Loc(13));
Cycler( LaF*6, HaF*5+6,LaF*17,Cyc1.CyclVal, CLTextButton,CLBgButton,$0,Cyc1,Language.Loc(853));
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
DRAW_SPICON;
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(200,99,200+LaF*46,99+HaF1+HaF*13+7,$51D9,Language.Loc(441),W1) Then Exit;
Win_Sup(100,50,250,200,79,60,639,479,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                        {*Display Window*}

Cyc1.CyclVal:=Sp;
OldSp:=Sp;                              {*Store Values*}

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=False;                        {*Init Exit Flag*}
Cancel:=False;

Repeat
try
;
If Win_Ready(W1) Then                {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But2,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But3,1)=CMSelected Then Cancel:=True;
   If Cycler_GetMsg(Cyc1,1)=CMSelected Then DRAW_SPICON;
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=True;            {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}

Win_Done(W1);                        {*Close Window if Needs*}
If Not Cancel Then SELECT_SPICON:=Cyc1.CyclVal
              Else SELECT_SPICON:=OldSp;
End;

{ͻ
                          PROCEDURE ASK_FONTREQ                             
 ͹
           DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER DE FONTE         
 ͼ}

Procedure ASK_FONTREQ;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;             {*Structure Boutons*}
    Com1,Com2,Com5:TInputText;          {*Structure Commands*}
    Cin1,Cin2{,Cin3,}
{    Cin4},Cin5   :String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Modif*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4+1, HaF*2+7, LaF*31+4,HaF*8+5,  CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8+1, HaF*1+7, LaF*27+4,HaF*3+2,  CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*4,   HaF*10+1,LaF*72,  HaF*13+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*26,  HaF*9+1, LaF*50,  HaF*10+6, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*14,  HaF*4+2, CLText, Language.Loc(658));
Display( LaF*6,   HaF*11+7,CLText, Language.Loc(661));
Display( LaF*14,  HaF*6+2, CLText, Language.Loc(662));
Display( LaF*13,  HaF*1+9, CLWhite,Language.Loc(603));
Display( LaF*30+1,HaF*9+2, CLWhite,Language.Loc(664));

Button( LaF*16, HaF*15+1,LaF*16,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*44, HaF*15+1,LaF*16,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
InputText( LaF*6, HaF*4+2,LaF*6,10, CLSky,CLSalmon,0,$126,Com1,Cin1);
InputText( LaF*6, HaF*6+2,LaF*6,10, CLSky,CLSalmon,0,$126,Com2,Cin2);
InputText( LaF*14,HaF*11+6,LaF*54,255, CLEmerald,CLLightBlue,0,$27,Com5,Cin5);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(80,75,80+LaF*76,75+HaF1+HaF*17+1,$51D9,Language.Loc(665),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Str(RFntV.X1,Cin1);                     {*Load Font Values*}
Str(RFntV.Y1,Cin2);
Cin5:=RFntV.Name;
{Str(RFntV.Font_Sel,Cin3);
Str(RFntV.Size_Sel,Cin4);}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=False;         {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com5,Cin5);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=True) Or (Cancel=True); {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=False Then Begin              {*Save Values*}
   Val(Cin1,RFntV.X1,Code);
   Val(Cin2,RFntV.Y1,Code);
   RFntV.Name:=Cin5;
   End;
End;

{ͻ
                           PROCEDURE ASK_MEMORY                             
 ͹
          DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER DE MEMOIRE        
 ͼ}

Procedure ASK_MEMORY;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;                {*Structure Boutons*}
    Com1,Com2,Com3:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3:String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Changements*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4+1, HaF*2+7, LaF*31+4, HaF*8+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34+1,HaF*2+7, LaF*71+4, HaF*6+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8+1, HaF*1+7, LaF*27+4, HaF*3+2, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*40+1,HaF*1+7, LaF*65+4, HaF*3+2, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*14,  HaF*4+2, CLText, Language.Loc(658));
Display( LaF*14,  HaF*6+2, CLText, Language.Loc(662));
Display( LaF*45+1,HaF*1+9, CLWhite,Language.Loc(664));
Display( LaF*13,  HaF*1+9, CLWhite,Language.Loc(603));

Button( LaF*16, HaF*10+1,LaF*16,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*44, HaF*10+1,LaF*16,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
InputText( LaF*6, HaF*4+2, LaF*6,10, CLSky,CLSalmon,0,$127,Com1,Cin1);
InputText( LaF*6, HaF*6+2, LaF*6,10, CLSky,CLSalmon,0,$126,Com2,Cin2);
InputText( LaF*36,HaF*4+2, LaF*34,100,CLEmerald,CLLightBlue,0,$26,Com3,Cin3);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(80,75,80+LaF*76,75+HaF1+HaF*12+1,$51D9,Language.Loc(666),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Str(RMemV.X1,Cin1);                     {*Init Memory Values*}
Str(RMemV.Y1,Cin2);
Cin3:=RMemV.Name;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=No;            {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;          {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=True) Or (Cancel=True); {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=False Then Begin
   Val(Cin1,RMemV.X1,Code);                  {*Save Memory Values*}
   Val(Cin2,RMemV.Y1,Code);
   RMemV.Name:=Cin3;
   End;
End;

{ͻ
                          PROCEDURE ASK_HARDWARE                            
 ͹
           DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER HARDWARE         
 ͼ}

Procedure ASK_HARDWARE;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;                {*Structure Boutons*}
    Com1,Com2,Com3:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3:String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4+1, HaF*2+7, LaF*31+4, HaF*8+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34+1,HaF*2+7, LaF*71+4, HaF*6+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8+1, HaF*1+7, LaF*27+4, HaF*3+2, CLFLamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*40+1,HaF*1+7, LaF*65+4, HaF*3+2, CLFLamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*14,  HaF*4+2, CLText, Language.Loc(658));
Display( LaF*14,  HaF*6+2, CLText, Language.Loc(662));
Display( LaF*45+1,HaF*1+9, CLWhite,Language.Loc(664));
Display( LaF*13,  HaF*1+9, CLWhite,Language.Loc(603));

Button( LaF*16,HaF*10+1,LaF*16,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*44,HaF*10+1,LaF*16,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
InputText(LaF*6, HaF*4+2,LaF*6, 10, CLSky,CLSalmon,0,$127,Com1,Cin1);
InputText(LaF*6, HaF*6+2,LaF*6, 10, CLSky,CLSalmon,0,$126,Com2,Cin2);
InputText(LaF*36,HaF*4+2,LaF*34,100,CLEmerald,CLLightBlue,0,$26,Com3,Cin3);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(80,75,80+LaF*76,75+HaF1+HaF*12+1,$51D9,Language.Loc(667),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Str(RHardV.X1,Cin1);                    {*Init Hardware Values*}
Str(RHardV.Y1,Cin2);
Cin3:=RHardV.Name;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=False;         {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Exit_Flg:=True;          {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=True) Or (Cancel=True); {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=False Then Begin              {*Save Hardware Values*}
   Val(Cin1,RHardV.X1,Code);
   Val(Cin2,RHardV.Y1,Code);
   RMemV.Name:=Cin3;
   End;
End;

{ͻ
                          PROCEDURE ASK_PALETTE                             
 ͹
          DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER DE PALETTE        
 ͼ}

Procedure ASK_PALETTE;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg,Cancel:Boolean;            {*Flag de Sortie*}
    But1,But2     :TButton;             {*Structure Boutons*}
    Com1,Com2,Com3:TInputText;          {*Structure Commands*}
    Cin1,Cin2,Cin3
{    Cin4    }      :String;            {*Strings pour Commands*}
    Code          :Integer;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4+1, HaF*2+7, LaF*31+4, HaF*8+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34+1,HaF*2+7, LaF*71+4, HaF*8+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8+1, HaF*1+7, LaF*27+4, HaF*3+2, CLFLamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*40+1,HaF*1+7, LaF*65+4, HaF*3+2, CLFLamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*14,  HaF*4+2, CLText, Language.Loc(658));
Display( LaF*14,  HaF*6+2, CLText, Language.Loc(662));
Display( LaF*45+1,HaF*1+9, CLWhite,Language.Loc(664));
Display( LaF*13,  HaF*1+9, CLWhite,Language.Loc(603));

Button( LaF*16,HaF*10+1,LaF*16,-1,  CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*44,HaF*10+1,LaF*16,-1,  CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
InputText(LaF*6, HaF*4+2,LaF*6,10,  CLSky,CLSalmon,0,$127,Com1,Cin1);
InputText(LaF*6, HaF*6+2,LaF*6,10,  CLSky,CLSalmon,0,$126,Com2,Cin2);
InputText(LaF*36,HaF*4+2,LaF*34,100,CLEmerald,CLLightBLue,0,$26,Com3,Cin3);
{InputText(LaF*64,HaF*6+2,LaF*6,100,2,1,0,$26,Com4,Cin4);
InPutText_Freeze(On,Com4);}
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(110,65,110+LaF*76,65+HaF1+HaF*12+1,$51D9,Language.Loc(669),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Str(RPalV.X1,Cin1);                     {*Get Values*}
Str(RPalV.Y1,Cin2);
Cin3:=RPalV.Name;
{Cin4:='0';}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=False;         {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
{   InputText_GetMsg(Com4,Cin4);}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=True) Or (Cancel=True); {*Flags de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=False Then Begin              {*Save Values*}
   Val(Cin1,RPalV.X1,Code);
   Val(Cin2,RPalV.Y1,Code);
   RPalV.Name:=Cin3;
   End;
End;

{ͻ
                          PROCEDURE ASK_FILEREQ                             
 ͹
         DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER DE DIRECTORY       
 ͼ}

Procedure ASK_FILEREQ;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;                {*Structure Boutons*}
    Cyc1          :TCycler;                {*Structure Cyclers*}
    Rad1,Rad2     :TRadioBox;                 {*Structure Radios*}
    Com1,Com2,Com3,
    Com4,Com5,Com6,
    Com7,Com8,Com9:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6,
    Cin7,Cin8,Cin9:String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure FREEZE_COM1;
Begin
If Rad1.Status=Yes Then Begin
   InPutText_Freeze(No,Com7); InPutText_Freeze(No,Com8); InPutText_Freeze(No,Com9);
   End Else Begin
   InPutText_Freeze(Yes,Com7);InPutText_Freeze(Yes,Com8);InPutText_Freeze(Yes,Com9);
   End;
End;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4+1, HaF*2+7, LaF*31+4, HaF*10+5,CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34+1,HaF*2+7, LaF*71+4, HaF*10+5,CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8+1, HaF*1+7, LaF*27+4, HaF*3+2, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*44+1,HaF*1+7, LaF*61+4, HaF*3+2, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*4+1, HaF*11+2,LaF*71+4, HaF*16+5,CLMauve,  BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*14, HaF*4+2, CLText,Language.Loc(658));
Display( LaF*14, HaF*6+2, CLText,Language.Loc(662));
Display( LaF*14, HaF*8+2, CLText,Language.Loc(670));
Display( LaF*55, HaF*6+2, CLText,Language.Loc(671));
Display( LaF*62, HaF*8+2, CLText,Language.Loc(672));
Display( LaF*46, HaF*11+7,CLText,Language.Loc(673));
Display( LaF*46, HaF*13+2,CLText,Language.Loc(674));
Display( LaF*46, HaF*14+7,CLText,Language.Loc(675));
Display( LaF*30, HaF*11+7,CLText,Language.Loc(676));
Display( LaF*8+3,HaF*12+2,CLText,Language.Loc(677));
Display( LaF*49+1,HaF*1+9,CLWhite,Language.Loc(678));
Display( LaF*13,  HaF*1+9,CLWhite,Language.Loc(603));

Button( LaF*16,HaF*18+1,LaF*16,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*44,HaF*18+1,LaF*16,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
Cycler( LaF*8, HaF*14+1,LaF*14+2,Cyc1.CyclVal, CLTextButton,CLBgButton,$0,Cyc1,Language.Loc(679));
RadioBox( LaF*32, HaF*13,  2,$00,0,0,Rad1.Status,Rad1,Language.Loc(80));
RadioBox( LaF*32, HaF*14+4,2,$00,0,0,Rad2.Status,Rad2,Language.Loc(81));

InputText( LaF*6, HaF*4+2, LaF*6, 10, CLSky,CLSalmon,0,$127,Com1,Cin1);
InputText( LaF*6, HaF*6+2, LaF*6, 10, CLSky,CLSalmon,0,$126,Com2,Cin2);
InputText( LaF*6, HaF*8+2, LaF*6, 10, CLSky,CLSalmon,0,$126,Com3,Cin3);
InputText( LaF*36,HaF*4+2, LaF*34,100,CLEmerald,CLLightBLue,0,$26,Com4,Cin4);
InputText( LaF*36,HaF*6+2, LaF*14,100,CLEmerald,CLLightBLue,0,$26,Com5,Cin5);
InputText( LaF*36,HaF*8+2, LaF*22,100,CLEmerald,CLLightBLue,0,$26,Com6,Cin6);
InputText( LaF*64,HaF*11+7,LaF*6, 3,  CLGreen,CLGrey,0,$126,Com7,Cin7);
InputText( LaF*64,HaF*13+2,LaF*6, 3,  CLGreen,CLGrey,0,$126,Com8,Cin8);
InputText( LaF*64,HaF*14+7,LaF*6, 3,  CLGreen,CLGrey,0,$126,Com9,Cin9);

FREEZE_COM1;
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(110,65,110+LaF*76,65+HaF1+HaF*20+1,$51F9,Language.Loc(680),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

If RFileV.SendToCom=True
   Then Begin Rad2.Status:=False; Rad1.Status:=True; End
   Else Begin Rad2.Status:=True; Rad1.Status:=False; End;
Str(RFileV.X1,Cin1);
Str(RFileV.Y1,Cin2);
Str(RFileV.Sv,Cin3);
Cin4:=RFileV.Name;
Cin5:=RFileV.OkBut;
Cin6:=RFileV.Mask;
Cyc1.CyclVal:=RFileV.Style+1;
Str(RFileV.FPath,Cin7);
Str(RFileV.FName,Cin8);
Str(RFileV.FSize,Cin9);

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=No;            {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   Win_Clip(Yes,W1);
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   Cycler_GetMsg(Cyc1,1);
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   InputText_GetMsg(Com4,Cin4);
   InputText_GetMsg(Com5,Cin5);
   InputText_GetMsg(Com6,Cin6);
   InputText_GetMsg(Com7,Cin7);
   InputText_GetMsg(Com8,Cin8);
   InputText_GetMsg(Com9,Cin9);
   If RadioBox_GetMsg(Rad1,1)<>CMNone Then FREEZE_COM1;
   If RadioBox_GetMsg(Rad2,1)<>CMNone Then FREEZE_COM1;
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=False Then Begin              {*Save Values*}
   If Rad1.Status=True Then RFileV.SendToCom:=True
      Else RFileV.SendToCom:=False;
   Val(Cin1,RFileV.X1,Code);
   Val(Cin2,RFileV.Y1,Code);
   Val(Cin3,RFileV.Sv,Code);
   RFileV.Name:=Cin4;
   RFileV.OkBut:=Cin5;
   RFileV.Mask:=Cin6;
   RFileV.Style:=Cyc1.CyclVal-1;
   Val(Cin7,RFileV.FPath,Code);
   Val(Cin8,RFileV.FName,Code);
   Val(Cin9,RFileV.FSize,Code);
   End;
End;

{ͻ
                           PROCEDURE ASK_ATTRIB                             
 ͹
         DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER ATTRIB-FLAGS       
 ͼ}

Procedure ASK_ATTRIB;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;                {*Structure Boutons*}
    Com1,Com2,Com3:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3:String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Modifs*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4+1, HaF*2+7, LaF*31+4, HaF*8+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34+1,HaF*2+7, LaF*71+4, HaF*6+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8+1, HaF*1+7, LaF*27+4, HaF*3+2, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*40+1,HaF*1+7, LaF*65+4, HaF*3+2, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*14,  HaF*4+2, CLText, Language.Loc(658));
Display( LaF*14,  HaF*6+2, CLText, Language.Loc(662));
Display( LaF*42+4,HaF*1+9, CLWhite,Language.Loc(681));
Display( LaF*13,  HaF*1+9, CLWhite,Language.Loc(603));

Button( LaF*16,HaF*10+1,LaF*16,-1,  CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*44,HaF*10+1,LaF*16,-1,  CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
InputText(LaF*6, HaF*4+2,LaF*6, 10, CLSky,CLSalmon,0,$127,Com1,Cin1);
InputText(LaF*6, HaF*6+2,LaF*6, 10, CLSky,CLSalmon,0,$126,Com2,Cin2);
InputText(LaF*36,HaF*4+2,LaF*34,100,CLEmerald,CLLightBlue,0,$26,Com3,Cin3);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(80,75,80+LaF*76,75+HaF1+HaF*12+1,$51D9,Language.Loc(682),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Str(RAttrV.X1,Cin1);                    {*Load Attrib Values*}
Str(RAttrV.Y1,Cin2);
Cin3:=RAttrV.Name;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=False;         {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);   {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=False Then Begin
   Val(Cin1,RAttrV.X1,Code);            {*Save Attrib Values*}
   Val(Cin2,RAttrV.Y1,Code);
   RAttrV.Name:=Cin3;
   End;
End;

{ͻ
                           PROCEDURE ASK_SYSTEM                             
 ͹
           DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER SYSTEM           
 ͼ}

Procedure ASK_SYSTEM;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;                {*Structure Boutons*}
    Rad1          :TRadioBox;                 {*Structure Radios*}
    Com1,Com2,Com3:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3:String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Modifs*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_DEFCOMMAND;            {*Dfinition Command*}
Begin
If Rad1.Status=Yes Then Cin3:='MOS.INI';
InputText( W1.X1+LaF*36, W1.Y1+HaF1+HaF*4+2,LaF*34,100, CLEmerald,CLLightBlue,0,$26,Com3,Cin3);
If Rad1.Status=Yes Then InPutText_Freeze(Yes,Com3)
                   Else InPutText_Freeze(No,Com3);
End;

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4+1, HaF*2+7, LaF*31+4, HaF*8+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34+1,HaF*2+7, LaF*71+4, HaF*8+5, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8+1, HaF*1+7, LaF*27+4, HaF*3+2, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*40+1,HaF*1+7, LaF*65+4, HaF*3+2, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*14,  HaF*4+2, CLText, Language.Loc(658));
Display( LaF*14,  HaF*6+2, CLText, Language.Loc(662));
Display( LaF*43+3,HaF*1+9, CLWhite,Language.Loc(684));
Display( LaF*13,  HaF*1+9, CLWhite,Language.Loc(603));

Button( LaF*16,HaF*10+1,LaF*16,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*44,HaF*10+1,LaF*16,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
InputText(LaF*6, HaF*4+2,LaF*6,10, CLSky,CLSalmon,0,$127,Com1,Cin1);
InputText(LaF*6, HaF*6+2,LaF*6,10, CLSky,CLSalmon,0,$126,Com2,Cin2);
RadioBox( LaF*36, HaF*6+1,1,$00,0,0,Rad1.Status,Rad1,Language.Loc(683));
Win_Clip(No,W1);

REDRAW_DEFCOMMAND;                      {*Dfinition Command*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(80,75,80+LaF*76,75+HaF1+HaF*12+1,$51D9,Language.Loc(685),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Rad1.Status:=RSysV.SMosIni;
Str(RSysV.X1,Cin1);                     {*Init System Values*}
Str(RSysV.Y1,Cin2);
Cin3:=RSysV.Name;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=No;           {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   If RadioBox_GetMsg(Rad1,1)<>CMNone  Then REDRAW_DEFCOMMAND;
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=True) Or (Cancel=True); {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=False Then Begin              {*Save Values*}
   RSysV.SMosIni:=Rad1.Status;
   Val(Cin1,RSysV.X1,Code);
   Val(Cin2,RSysV.Y1,Code);
   RSysV.Name:=Cin3;
   End;
End;

{ͻ
                        PROCEDURE ASK_EZREQUESTER                           
 ͹
             DEMANDE A L'UTILISATEUR DE DEFINIR UN EZ REQUESTER             
 ͼ}

Procedure ASK_EZ_REQUESTER;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2,But3:TButton;                {*Structure Boutons*}
    Rad1,Rad2     :TRadioBox;                 {*Structure Radios*}
    Com1,Com2,Com3:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3:String;              {*Strings pour Commands*}
    Cancel        :Boolean;             {*Annulation Modifications*}
    VSp           :Byte;                {*Value Special Icon*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4, HaF*2+6, LaF*72, HaF*10+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*24,HaF*1+6, LaF*52, HaF*3+1,  CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*4, HaF*12+6,LaF*32, HaF*16+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*10,HaF*11+6,LaF*26, HaF*13+1, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34,HaF*12+6,LaF*72, HaF*18+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*42,HaF*11+6,LaF*64, HaF*13+1, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*46,   HaF*4+1, CLText, Language.Loc(689));
{Display( LaF*42,   HaF*16+2,CLText, Language.Loc(690));
Display( LaF*42,   HaF*14+2,CLText, Language.Loc(691));}
Display( LaF*28+4, HaF*1+8, CLWhite,Language.Loc(686));
Display( LaF*13+4, HaF*11+8,CLWhite,Language.Loc(687));
Display( LaF*45+1, HaF*11+8,CLWhite,Language.Loc(688));

Button( LaF*44,HaF*20+1,LaF*16,-1, CLTextButton,CLBgButton,$0,But1,Language.Loc(13));
Button( LaF*16,HaF*20+1,LaF*16,-1, CLTextButton,CLBgButton,$100,But2,'_OK');
Button( LaF*7, HaF*14+1,LaF*22,-1, CLTextButton,CLBgButton,$0,But3,Language.Loc(471));
InputText(LaF*6, HaF*4+1,LaF*38,255, CLEmerald,CLLightBlue,0,$27,Com1,Cin1);
InputText(LaF*6, HaF*6+1,LaF*64,255, CLEmerald,CLLightBlue,0,$26,Com2,Cin2);
InputText(LaF*6, HaF*8+1,LaF*64,255, CLEmerald,CLLightBlue,0,$26,Com3,Cin3);
RadioBox( LaF*36,HaF*16+1,1,$00,0,0,Rad1.Status,Rad1,Language.Loc(690));
RadioBox( LaF*36,HaF*14+1,1,$00,0,0,Rad2.Status,Rad2,Language.Loc(691));
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(110,65,110+LaF*76,65+HaF1+HaF*22+1,$51D9,Language.Loc(692),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Cin1:=REzV.Title;                       {*Init EZ Requester Values*}
Cin2:=REzV.Phrase;
Cin3:=REzV.Gadget;
Rad1.Status:=REzV.TestRes;
Rad2.Status:=REzV.BCenter;
VSp:=REzV.NumIco;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=False;         {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But3,1)=CMSelected Then VSp:=SELECT_SPICON(VSp);
   RadioBox_GetMsg(Rad1,1);
   RadioBox_GetMsg(Rad2,1);
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin
   REzV.Title:=Cin1;                    {*Save EZ Requester Values*}
   REzV.Phrase:=Cin2;
   REzV.Gadget:=Cin3;
   REzV.TestRes:=Rad1.Status;
   REzV.BCenter:=Rad2.Status;
   REzV.NumIco:=VSp;
   End;
End;

{ͻ
                      PROCEDURE ASK_STRING_REQUESTER                        
 ͹
          DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER DE STRING         
 ͼ}

Procedure ASK_STRING_REQUESTER;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2,But3:TButton;                {*Structure Boutons*}
    Rad1,Rad2     :TRadioBox;                 {*Structure Radios*}
    Com1,Com2,Com3,
    Com4,Com5,Com6:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6:String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Modifications*}
    VSp           :Byte;                {*Value Special Icon*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4, HaF*2+6, LaF*72, HaF*12+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*24,HaF*1+6, LaF*52, HaF*3+1,  CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*4, HaF*14+6,LaF*32, HaF*22+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8, HaF*13+6,LaF*28, HaF*15+1, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34,HaF*14+6,LaF*72, HaF*20+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*42,HaF*13+6,LaF*64, HaF*15+1, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*46,  HaF*4+1,  CLText, Language.Loc(695));
Display( LaF*36,  HaF*16+2, CLText, Language.Loc(697));
Display( LaF*36,  HaF*18+2, CLText, Language.Loc(698));
Display( LaF*28+4,HaF*1+8,  CLWhite,Language.Loc(693));
Display( LaF*10+1,HaF*13+8, CLWhite,Language.Loc(664));
Display( LaF*46+4,HaF*13+8, CLWhite,Language.Loc(694));

Button( LaF*44,HaF*24+1,LaF*16,-1, CLTextButton,CLBgButton,$0000,But1,Language.Loc(13));
Button( LaF*16,HaF*24+1,LaF*16,-1, CLTextButton,CLBgButton,$0100,But2,'_OK');
Button( LaF*6, HaF*20+3,LaF*24,-1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(471));
InputText(LaF*6, HaF*4+1,LaF*38,100, CLEmerald,CLLightBlue,0,$27,Com1,Cin1);
InputText(LaF*6, HaF*6+1,LaF*64,100, CLEmerald,CLLightBlue,0,$26,Com2,Cin2);
InputText(LaF*6, HaF*8+1,LaF*64,100, CLEmerald,CLLightBlue,0,$26,Com3,Cin3);
InputText(LaF*64,HaF*16+2,LaF*6,3,   CLGreen,CLGrey,0,$126,Com4,Cin4);
InputText(LaF*64,HaF*18+2,LaF*6,4,   CLGreen,CLGrey,0,$126,Com5,Cin5);
InputText(LaF*6, HaF*10+2,LaF*64,255,CLGreen,CLLightBlue,0,$26,Com6,Cin6);
RadioBox( LaF*6, HaF*16+1,1,$00,0,0,Rad1.Status,Rad1,Language.Loc(690));
RadioBox( LaF*6, HaF*18+1,1,$00,0,0,Rad2.Status,Rad2,Language.Loc(691));
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(110,65,110+LaF*76,65+HaF1+HaF*26+1,$51D9,Language.Loc(700),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Rad1.Status:=RStV.TestRes;              {*Load And Init Values*}
Rad2.Status:=RStV.BCenter;
Cin1:=RStV.Name;
Cin2:=RStV.Txt;
Cin3:=RStV.Gad;
Str(RStV.NbChar,Cin4);
Str(RStV.Size,Cin5);
Cin6:=RStV.Str;
VSp:=RStV.NumIco;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=No;           {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But3,1)=CMSelected Then VSp:=SELECT_SPICON(VSp);
   RadioBox_GetMsg(Rad1,1);
   RadioBox_GetMsg(Rad2,1);
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   InputText_GetMsg(Com6,Cin6);
   InputText_GetMsg(Com4,Cin4);
   InputText_GetMsg(Com5,Cin5);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin                {*Save Modifications*}
   RStV.TestRes:=Rad1.Status;           {*Save Values*}
   RStV.BCenter:=Rad2.Status;
   RStV.Name:=Cin1;
   RStV.Txt:=Cin2;
   RStV.Gad:=Cin3;
   Val(Cin4,RStV.NbChar,Code);
   Val(Cin5,RStV.Size,Code);
   RStV.Str:=Cin6;
   RStV.NumIco:=VSp;
   End;
End;

{ͻ
                      PROCEDURE ASK_VALUE_REQUESTER                         
 ͹
         DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER DE VALEURS         
 ͼ}

Procedure ASK_VALUE_REQUESTER;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2,But3:TButton;                {*Structure Boutons*}
    Rad1,Rad2     :TRadioBox;                 {*Structure Radios*}
    Com1,Com2,Com3,
    Com4,Com5,Com6:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6:String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Modifications*}
    VSp           :Byte;                {*Value Special Icon*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4, HaF*2+6,  LaF*72, HaF*12+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*24,HaF*1+6,  LaF*52, HaF*3+1,  CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*4, HaF*14+6, LaF*32, HaF*22+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*8, HaF*13+6, LaF*28, HaF*15+1, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*34,HaF*14+6, LaF*72, HaF*20+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*42,HaF*13+6, LaF*64, HaF*15+1, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*46,  HaF*4+1,  CLText, Language.Loc(695));
Display( LaF*36,  HaF*16+2, CLText, Language.Loc(701));
Display( LaF*36,  HaF*18+2, CLText, Language.Loc(702));
Display( LaF*24,  HaF*10+2, CLText, Language.Loc(703));
Display( LaF*28+4,HaF*1+8,  CLWhite,Language.Loc(693));
Display( LaF*10+1,HaF*13+8, CLWhite,Language.Loc(664));
Display( LaF*46+4,HaF*13+8, CLWhite,Language.Loc(694));

Button( LaF*44,HaF*24+1,LaF*16,-1, CLTextButton,CLBgButton,$0000,But1,Language.Loc(13));
Button( LaF*16,HaF*24+1,LaF*16,-1, CLTextButton,CLBgButton,$0100,But2,'_OK');
Button( LaF*6, HaF*20+3,LaF*24,-1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(471));
InputText(LaF*6, HaF*4+1,LaF*38,100, CLEmerald,CLLightBlue,0,$27,Com1,Cin1);
InputText(LaF*6, HaF*6+1,LaF*64,100, CLEmerald,CLLightBlue,0,$26,Com2,Cin2);
InputText(LaF*6, HaF*8+1,LaF*64,100, CLEmerald,CLLightBlue,0,$26,Com3,Cin3);
InputText(LaF*60,HaF*16+2,LaF*10,10, CLGreen,CLGrey,0,$126,Com4,Cin4);
InputText(LaF*60,HaF*18+2,LaF*10,10, CLGreen,CLGrey,0,$126,Com5,Cin5);
InputText(LaF*6,HaF*10+2,LaF*16,255, CLGreen,CLLightBlue,0,$126,Com6,Cin6);

RadioBox( LaF*6, HaF*16+1,1,$00,0,0,Rad1.Status,Rad1,Language.Loc(690));
RadioBox( LaF*6, HaF*18+1,1,$00,0,0,Rad2.Status,Rad2,Language.Loc(691));
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(110,65,110+LaF*76,65+HaF1+HaF*26+1,$51D9,Language.Loc(704),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Rad1.Status:=RVaV.TestRes;              {*Init Values*}
Rad2.Status:=RVaV.BCenter;
Cin1:=RVaV.Name;
Cin2:=RVaV.Txt;
Cin3:=RVaV.Gad;
Str(RVaV.BMin,Cin4);
Str(RVaV.BMax,Cin5);
Str(RVaV.Vai,Cin6);
VSp:=RVaV.NumIco;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But3,1)=CMSelected Then VSp:=SELECT_SPICON(VSp);
   RadioBox_GetMsg(Rad1,1);
   RadioBox_GetMsg(Rad2,1);
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   InputText_GetMsg(Com6,Cin6);
   InputText_GetMsg(Com4,Cin4);
   InputText_GetMsg(Com5,Cin5);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin                {*Save Values*}
   RVaV.TestRes:=Rad1.Status;
   RVaV.BCenter:=Rad2.Status;
   RVaV.Name:=Cin1;
   RVaV.Txt:=Cin2;
   RVaV.Gad:=Cin3;
   Val(Cin4,RVaV.BMin,Code);
   Val(Cin5,RVaV.BMax,Code);
   Val(Cin6,RVaV.Vai,Code);
   RVaV.NumIco:=VSp;
   End;
End;

{ͻ
                     PROCEDURE ASK_PROGRESS_REQUESTER                       
 ͹
          DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER PROGRESS          
 ͼ}

Procedure ASK_PROGRESS_REQUESTER;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But1,But2     :TButton;                {*Structure Boutons*}
    Com1,Com2,Com3:TInputText;              {*Structure Commands*}
    Cin1,Cin2,Cin3:String;              {*Strings pour Commands*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Modifications*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (LaF*4, HaF*2+6, LaF*72, HaF*8+6,  CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*24,HaF*1+6, LaF*52, HaF*3+1,  CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*4, HaF*10+6,LaF*40, HaF*14+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*10,HaF*9+6, LaF*34, HaF*11+1, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);

Display( LaF*46,  HaF*4+1, CLText, Language.Loc(695));
Display( LaF*8,   HaF*12+2,CLText, Language.Loc(705));
Display( LaF*28+4,HaF*1+8, CLWhite,Language.Loc(693));
Display( LaF*14,  HaF*9+8, CLWhite,Language.Loc(664));

Button( LaF*44,HaF*16+1,LaF*16,-1, CLTextButton,CLBgButton,$0,But1,Language.Loc(13));
Button( LaF*16,HaF*16+1,LaF*16,-1, CLTextButton,CLBgButton,$100,But2,'_OK');
InputText(LaF*6, HaF*4+1,LaF*38,100, CLEmerald,CLLightBlue,0,$27,Com1,Cin1);
InputText(LaF*6, HaF*6+1,LaF*44,100, CLEmerald,CLLightBlue,0,$26,Com2,Cin2);
InputText(LaF*30,HaF*12+2,LaF*6,3,   CLGreen,CLGrey,0,$126,Com3,Cin3);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
If Not Win_Init(110,65,110+LaF*76,65+HaF1+HaF*18+1,$51D9,Language.Loc(706),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,500,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Cin1:=RProV.Name;                       {*Init And Load Values*}
Cin2:=RProV.Explain;
Str(RProV.Cob,Cin3);

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Init Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Perso*}
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then Exit_Flg:=Yes;
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   InputText_GetMsg(Com3,Cin3);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=Yes;              {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin                {*Save Values*}
   RProV.Name:=Cin1;
   RProV.Explain:=Cin2;
   Val(Cin3,RProV.Cob,Code);
   End;
End;

{ͻ
                          PROCEDURE ASK_PROCNAME                            
 ͹
    DEMANDE A L'UTILISATEUR LE NOM DE LA PROCEDURE QUI DOIT ETRE APPELLEE   
 ͼ}

Procedure ASK_PROCNAME;
Var NUM:Integer;
    ES :String;
Begin
ES:=Proc_Name;
Num:=3;
Req_String(Language.Loc(461),Language.Loc(707),Language.Loc(708),64,390,ES,NUM);
If NUM=1 Then Proc_Name:=ES;
End;

{ͻ
                     PROCEDURE DEFINE_EXTERNAL_REQUEST                      
 ͼ}

Procedure DEFINE_EXTERNAL_REQUEST(B,Px,Py:Integer);
Var W1            :TWindow;                 {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    XOk,XCancel   :Boolean;             {*Exit Flags*}
    But1,But2     :TButton;                {*Buttons Structure*}
    Rad1          :TRadioBox;                 {*Radios Structure*}
    Com1,Com2     :TInputText;              {*Commands Structure*}
    Cin1,Cin2     :String;              {*Strings for Commands*}
    Code          :Integer;             {*Pour "Val"*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*4,  HaF*2+6, LaF*40, HaF*10+6, CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*10, HaF*1+6, LaF*34, HaF*3+1,  CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Display( LaF*6, HaF*4+1, CLText, 'POSITION X');
Display( LaF*6, HaF*6+1, CLText, 'POSITION Y');
Display( LaF*14,HaF*1+8, CLWhite,'MISCELLANEOUS');

Button( LaF*4,  HaF*12+1, LaF*16,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*24, HaF*12+1, LaF*16,-1, CLTextButton,CLBgButton,$00,But2,Language.Loc(13));
RadioBox( LaF*6,HaF*8+1,1,$10,1,0,Rad1.Status,Rad1,'USE EXTERNAL LIBRARY');
InputText( LaF*22, HaF*4+1,LaF*8,255, CLSky,CLLightBlue,1,$0127,Com1,Cin1);
InputText( LaF*22, HaF*6+1,LaF*8,255, CLSky,CLLightBlue,1,$0126,Com2,Cin2);
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
If Not Win_Init(Px,Py,Px+LaF*44,Py+HaF1+HaF*14+1,$51D9,'DEFINE EXTERNAL REQUEST',W1) Then Exit;
Win_Sup(100,50,250,200,79,60,639,479,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                        {*Display Window*}

Str(RExt[B].X1,Cin1);                   {*Init Values...*}
Str(RExt[B].Y1,Cin2);
Rad1.Status:=RExt[B].Exter;
{gotoxy(1,1); writeln(B);}

REDRAW_FRAME;                           {*Display Window Content*}
XOk:=No; XCancel:=No;                   {*Init Exit Flags*}

Repeat
try
;
If Win_Ready(W1) Then                {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then XOk:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then XCancel:=Yes;
   RadioBox_GetMsg(Rad1,1);
   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                {*Get Windows Evens*}
If Even=CMClosed Then XCancel:=Yes;            {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (XOk) Or (XCancel);               {*Exit Flags*}
Win_Done(W1);                        {*Close Window if Needs*}

If Not XCancel Then Begin               {*Ok Validate...*}
   Val(Cin1,RExt[B].X1,Code);
   Val(Cin2,RExt[B].Y1,Code);
   RExt[B].Exter:=Rad1.Status;
   End;
End;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

{ͻ
                         PROCEDURE BUTTON_ACTION                            
 ͹
       DEMANDE A L'UTILISATEUR QUELLE ACTION IL DESIRE POUR SON BOUTON      
      SELECTION ET EDITION POSSIBLE DES DIFFERENTS REQUESTERS STANDARDS     
 ͼ}

Procedure BUTTON_ACTION(Pos:Byte);       {*Menu pour l'action des Boutons*}
Const TbI:Array[1..5] of Byte=(1,1, 1, 16,1);
      TbF:Array[1..5] of Byte=(5,14,15,19,7);
      Max_Blk=30;                       {*Maximum de Lignes par Tabs*}

Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evnements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    Cancel        :Boolean;
    A             :Integer;             {*For Loop*}
    But1,But2,But3:TButton;                {*Structure Boutons*}
    TRad          :Array[1..19] of TRadioBox; {*Tableau de Radios*}
    Ong           :TTabs;             {*Tabs....*}
    NOA,NRA       :Byte;                {*Les Numros d'activations...*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Var    A :Integer;                      {*For Loop*}
Begin
Win_Clip(Yes,W1);                     {*Clipping de la Fentre*}

Tabs(LaF*4, HaF*2, LaF*74, HaF*29+6, Ong.No, CLLightGrey,CLGrey,$04,Ong,Language.Loc(709));
Bevel (LaF*6, HaF*2+Ong.STxt+HaF, LaF*72, HaF*29-5, CLLightGrey,BLLoweredLine,BLNoLine,No);

Case Ong.No of
   1: For A:=TbI[1] to TbF[1] do RadioBox (LaF*8, (HaF+5)*A+HaF*4,2,$10,0,0,TRad[A].Status,TRad[A],Language.Loc(728+A));
   2: For A:=TbI[2] to TbF[2] do RadioBox (LaF*8, (HaF+5)*A+HaF*4,2,$10,0,0,TRad[A].Status,TRad[A],Language.Loc(733+A));
   3: Begin
      For A:=TbI[3] to TbF[3] do RadioBox (LaF*8, (HaF+5)*A+HaF*4,2,$10,0,0,TRad[A].Status,TRad[A],Language.Loc(1616+A));
      For A:=TbI[4] to TbF[4] do RadioBox (LaF*40,(HaF+5)*(A-15)+HaF*4,2,$10,0,0,TRad[A].Status,TRad[A],Language.Loc(1616+A));
      End;
   4: For A:=TbI[5] to TbF[5] do RadioBox (LaF*8, (HaF+5)*A+HaF*4,2,$10,0,0,TRad[A].Status,TRad[A],Language.Loc(530+A));
   End;

Button( LaF*13, HaF*31+1, LaF*14,-1, CLTextButton,CLBgButton,$0100,But1,'_OK');
Button( LaF*33, HaF*31+1, LaF*14,-1, CLTextButton,CLBgButton,$0000,But2,Language.Loc(714));
Button( LaF*52, HaF*31+1, LaF*14,-1, CLTextButton,CLBgButton,$0000,But3,Language.Loc(13));

Win_Clip(No,W1);                    {*Restore le Clipping Normal*}
End;

{****************** DEFINIT LES YES/NO DES BOUTONS RADIOS *******************}

Procedure SET_RADIOS;
Var A:Integer;
Begin
If Ong.No<>NOA Then TRad[NRA].Status:=No   {*Unselect Curent Radio*}
   Else For A:=1 to Max_Blk do
      If NRA=A Then TRad[A].Status:=Yes    {*Select Radio...*}
               Else TRad[A].Status:=No;
End;

{************************** PROCEDURE PRINCIPALE ****************************}

Begin
If Not Win_Init(250,0,250+LaF*78,HaF1+HaF*33,$51D9,Language.Loc(715),W1) Then Exit;
Win_Sup(100,50,250,200,59,50,639,349,0,CLWinBorder,$0A10,W1); {*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

NOA:=(TBU[Pos].Action Div Max_Blk)+1;   {*No Tabs  Activer*}
NRA:=(TBU[Pos].Action Mod Max_Blk)+1;   {*No Radio  Activer*}

{Gotoxy(1,1); Writeln(TBU[Pos].Action);}

Ong.No:=NOA;                            {*Neme Tabs Slectionn*}
SET_RADIOS;                             {*Select Radio...*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=False;         {*Init Flags de Sortie*}

Repeat
try
;
{Gotoxy(1,3); Writeln(NOA,' ');
Gotoxy(1,4); Writeln(NRA,' ');}
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin                                {*Test des Gadgets Personnels*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then   {*Edit Requesters*}
      Case Ong.No of
         1: Begin
            If TRad[5].Status  Then ASK_PROCNAME;
            End;
         2: Begin
            If TRad[1].Status  Then ASK_EZ_REQUESTER;
            If TRad[2].Status  Then ASK_FONTREQ;
            If TRad[3].Status  Then ASK_STRING_REQUESTER;
            If TRad[4].Status  Then ASK_VALUE_REQUESTER;
            If TRad[5].Status  Then ASK_PALETTE;
            If TRad[6].Status  Then ASK_MEMORY;
            If TRad[7].Status  Then ASK_HARDWARE;
            If TRad[8].Status  Then ASK_PROGRESS_REQUESTER;
            If TRad[9].Status  Then ASK_FILEREQ;
            If TRad[10].Status Then ASK_ATTRIB;
            End;
         3: Begin
            If TRad[1].Status  Then ASK_SYSTEM;
            For A:=2 to TbF[4] do If TRad[A].Status Then DEFINE_EXTERNAL_REQUEST(Pos,W.X1+20,W.Y1+30);
            End;
         4: For A:=1 to TbF[5] do If TRad[A].Status Then DEFINE_EXTERNAL_REQUEST(Pos,W.X1+20,W.Y1+30);
         End;

   If Button_GetMsg(But3,1)=CMSelected Then Cancel:=True;

   If Tabs_GetMsg(Ong,1)=CMSelected Then Begin   {*Define Radios State and Redraw...*}
      SET_RADIOS;
      REDRAW_FRAME;
      End;
   Case Ong.No of
      1: For A:=TbI[1] to TbF[1] do If RadioBox_GetMsg(TRad[A],1)<>CMNone Then Begin NRA:=A; NOA:=Ong.No; End;
      2: For A:=TbI[2] to TbF[2] do If RadioBox_GetMsg(TRad[A],1)<>CMNone Then Begin NRA:=A; NOA:=Ong.No; End;
      3: For A:=TbI[3] to TbF[4] do If RadioBox_GetMsg(TRad[A],1)<>CMNone Then Begin NRA:=A; NOA:=Ong.No; End;
      4: For A:=TbI[5] to TbF[5] do If RadioBox_GetMsg(TRad[A],1)<>CMNone Then Begin NRA:=A; NOA:=Ong.No; End;
      End;
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Flags de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Not Cancel Then
   TBU[Pos].Action:=(NOA-1)*Max_Blk+NRA-1; {*Numro d'Activation*}
{Gotoxy(1,6); Writeln((NOA-1)*Max_Blk+NRA-1);}
End;

{ͻ
                     PROCEDURE ASK_SLIDER_TO_COMMAND                        
 ͹
      DEMANDE A L'UTILISATEUR DE DEFINIR UN REQUESTER Slider TO InputText     
 ͼ}

Procedure ASK_SLIDER_TO_COMMAND(Pos:Integer);
Var Max :String;
    Num :Integer;
    Val1:Longint;
Begin
Num:=3;
Val1:=RSldV[Pos].ComNum;                {*Init and Load Value*}
Str(Qtt_Itm[5],Max);                    {*Get Maximum...*}
Req_Value(Language.Loc(716),Language.Loc(717)+Max,'  _OK  |'+Language.Loc(13),0,Qtt_Itm[5],Val1,Num);
If Num=1 Then RSldV[Pos].ComNum:=Val1;
End;

{ͻ
                     PROCEDURE INIT_MRE_ACTS                                
 ͹
      INITIALIZE ALL GLOBAL VARS                                            
 ͼ}

Procedure INIT_MRE_ACTS;
Begin                                   {*Def File Requester Values*}
RFileV.X1:=120;                         {*Init File Requester*}
RFileV.Y1:=30;
RFileV.Sv:=300;
RFileV.Name:=Language.Loc(720);
RFileV.OkBut:='_OK';
RFileV.Mask:='*.*';
RFileV.Style:=0;
RFileV.FPath:=0;
RFileV.FName:=0;
RFileV.FSize:=0;
RFileV.SendToCom:=False;

RPalV.X1:=120;                          {*Init Palette Requester*}
RPalV.Y1:=30;
RPalV.Name:=Language.Loc(721);
RPalV.ColSel:=0;

RMemV.X1:=120;                          {*Init Memory Requester*}
RMemV.Y1:=30;
RMemV.Name:=Language.Loc(722);

RHardV.X1:=120;                         {*Init Hardware Requester*}
RHardV.Y1:=30;
RHardV.Name:=Language.Loc(723);

RSysV.X1:=120;                          {*Init System Requester*}
RSysV.Y1:=30;
RSysV.Name:='MOS.INI';
RSysV.SMosIni:=True;

REzV.Title:=Language.Loc(724);                   {*Init EZ Requester*}
REzV.Phrase:=Language.Loc(725);
REzV.Gadget:=Language.Loc(726);
REzV.TestRes:=Yes;
REzV.BCenter:=No;
REzV.NumIco:=4;

RFntV.X1:=120;                          {*Record Font Requester*}
RFntV.Y1:=30;
RFntV.Name:=Language.Loc(724);
RFntV.Font_Sel:=0;
RFntV.Size_Sel:=0;

RAttrV.X1:=120;                         {*Record Attrib Requester*}
RAttrV.Y1:=30;
RAttrV.Name:='TEST.EXE';

RStV.Name:=Language.Loc(724);                    {*Record String Requester*}
RStV.Txt:=Language.Loc(725);
RStV.Gad:=Language.Loc(726);
RStV.Str:=Language.Loc(727);
RStV.NbChar:=100;
RStV.Size:=180;
RStV.TestRes:=Yes;
RStV.BCenter:=No;
RStV.NumIco:=4;

RVaV.Name:=Language.Loc(724);                    {*Record Value Requester*}
RVaV.Txt:=Language.Loc(725);
RVaV.Gad:=Language.Loc(726);
RVaV.BMin:=-100;
RVaV.BMax:=100;
RVaV.Vai:=0;
RVaV.TestRes:=Yes;
RVaV.BCenter:=No;
RVaV.NumIco:=4;

RProV.Name:=Language.Loc(724);                   {*Record Progress Requester*}
RProV.Explain:=Language.Loc(728);
RProV.Cob:=CLSky;

For Item:=1 to MAX_TSL do RSldV[Item].ComNum:=0;{*Record pour Slider to InputText*}

For Item:=1 to MAX_TBU do               {*Button Action = External Requester*}
   Begin
   RExt[Item].X1:=100;
   RExt[Item].Y1:=100;
   RExt[Item].Exter:=Yes;
   End;
End;

{**************************** PROGRAMME PRINCIPAL ***************************}

Begin
End.
