{ͻ
                     M.R.E (MOS RESOURCE EDITOR) v2.8                       
 ͹
                         UNITE DE GESTION DES ITEMS                         
 ͹
  Coded by Zuul as BouFFtou as Cheveau Frdric.                            
  Programm  Toulouse COG (Gendarmerie) sur Turbo Pascal v7.00.            
  Contact us on the NET : ZuulCoder@Hotmail.Com or Sybaris@Multimania.Com   
 ͼ}

Unit MRE_ITEMS;                          {*Nom du l'Unit*}

{$Mode Objfpc}

Interface

Uses MosCrt,                            {*Unit CRT pour MOS*}
     MosStrings,
     MosBase,
     MosGraph,
     MosMouse,                            {*Gestion de la Souris*}
     MosTools,                            {*Gestion des Tools et Box*}
     MosGraphics,                            {*Gestion des Gfx*}
     MosCPUInstructions,
     MosImages,                            {*Gestion des BMP*}
     MosGadgets,                            {*Gestion des Gadgets*}
     MosRequests,                            {*Gestion des Requesters*}
     MosDialogs,
     MosMenu,                            {*Gestion des Menus*}
     MosWindows,                            {*Gestion des Fentres*}
     MosDirectory,                            {*Gestion du Directory*}
     MosKeyboard,
     MosColorDialogs,
     MosConfig,
     MosText,
     MosColors,
     MRE_ACTS,                           {*Gestion Action des Boutons*}
     Dos;
                                         {*Espaces pour Strings*}
Procedure HELP(P:Integer);               {*Gestion de l'Aide*}
Procedure ERROR_01;                      {*Gestion des Erreurs*}
Procedure REDRAW_WINDOW(Var M:TMenu);    {*Raffiche le Contenu de Window*}

Procedure GERE_ITEMS(Var M:TMenu; I:Byte);{*Gestion des Items*}

Procedure TOGGLE_ITEM(Ty:Byte);          {*Toggle Cadre Items*}

Procedure SAVE_MRE_CONFIG(Var M:TMenu);
Function  LOAD_MRE_CONFIG(Var M:TMenu):Boolean; {*Load And Init MRE Constants*}
Procedure QTT_TO_0;                      {*POS et QTT to 0...*}
Procedure POS_TO_0;

Implementation

Uses
     SysUtils,
     Windows,
     MosErrors;

{ͻ
                         GESTION DE L'AIDE DANS MRE                         
 ͼ}

Procedure HELP(P:Integer);
Var NUM:Integer;
Begin
Num:=4;                                 {*Icne Information*}
Req_Dialog(Language.Loc(588),Language.Loc(581+P),'  _OK  |',NUM);{*Display Help*}
End;

{ͻ
                           ERREURS INTERNES A MRE                           
 ͼ}

Procedure ERROR_01;
Var NUM:Integer;
Begin
Num:=1;                                 {*Icne Warning*}
Req_Dialog(Language.Loc(461),Language.Loc(589),Language.Loc(469),NUM);
End;

{ͻ
                               SET POS TO 0                                 
 ͼ}

Procedure POS_TO_0;
Var A:Byte;
Begin
For A:=1 to Max_ITM do Pos_ITM[A]:=0;{*Positions de Chaque Outils*}
End;

{ͻ
                               SET QTT TO 0                                 
 ͼ}

Procedure QTT_TO_0;
Var A:Byte;
Begin
For A:=1 to Max_ITM do Qtt_ITM[A]:=0;{*Quantit de Chaque Outils*}
End;

{ͻ
               JUSTIFY A DROITE ET EN BAS LES ITEMS DE LA FENETRE           
 ͼ}

Procedure LEFT_JUSTIFY(Var M:TMenu);    {*Garde Proportions par Rapport Window*}
Var A:Byte;                             {*For Loop*}
    OffX,OffY:Integer;                  {*Variation  Corriger*}
Begin
If Menu_TestCheck(M,2,3)=No Then Exit;  {*Pas de Justifications*}

OffX:=(W.X2-W.X1)-WSizeX;               {*Calcule Variations*}
OffY:=(W.Y2-W.Y1)-WSizeY;

WSizeX:=W.X2-W.X1;                      {*Stocke Nouvelle Taille*}
WSizeY:=W.Y2-W.Y1;

For A:=1 to Qtt_ITM[6] do Begin         {*Rajuste Bevels*}
   Inc(TBB[A].X2,OffX); Inc(TBB[A].Y2,OffY); End;
For A:=1 to Qtt_ITM[7] do Begin         {*Rajuste String Boxes*}
   Inc(TSB[A].X2,OffX); Inc(TSB[A].Y2,OffY); End;
For A:=1 to Qtt_ITM[8] do Begin         {*Rajuste Textes*}
   Inc(TXT[A].X1,OffX); Inc(TXT[A].Y1,OffY); End;
For A:=1 to Qtt_ITM[1] do Begin         {*Rajuste Boutons*}
   Inc(TBU[A].X1,(OffX Div 2));         {*Bouton Centr en X et Ajust en Y*}
   Inc(TBU[A].Y1,OffY) ;End;
For A:=1 to Qtt_ITM[2] do Begin         {*Rajuste Cyclers*}
   Inc(TCY[A].X1,(OffX Div 2));         {*Bouton Centr en X et Ajust en Y*}
   Inc(TCY[A].Y1,OffY) ;End;
For A:=1 to Qtt_ITM[4] do Begin         {*Rajuste Sliders*}
   Inc(TSL[A].X1,(OffX Div 2));         {*Bouton Centr en X et Ajust en Y*}
   Inc(TSL[A].Y1,OffY);
   Inc(TSL[A].X2,(OffX Div 2));
   Inc(TSL[A].Y2,OffY) ;End;
For A:=1 to Qtt_ITM[2] do               {*Rajuste Commands*}
   Inc(TCO[A].T.Siz,OffX);
End;

{ͻ
                      REAFFICHE CONTENU FENETRE DE BASE                     
 ͼ}

Procedure REDRAW_WINDOW(Var M:TMenu);   {*Raffiche le Contenu de Window*}
Var A,Id  :Byte;                        {*For Loop and "Id"*}
    Tit   :Integer;                     {*Si Title Absent*}
    S     :String;

Begin
If Gad_Exist=No Then Exit;              {*Pas de Gadgets  Afficher*}

Tit:=-4;                                {*Pas de Titre => Dcalage...*}
If W.IDCMP And $80=$80 Then Tit:=HaF1;
If BTST(W.IDCMP,13) Then W.Sw.PutImageToScreen(W.X1,W.Y1); {*BackTrans*}

Win_Draw(W);                         {*Affiche Fentre Test*}
If (W.X2-W.X1<>WSizeX) Or (W.Y2-W.Y1<>WSizeY) Then LEFT_JUSTIFY(M);{*Justify Dte*}

Win_Clip(Yes,W);                      {*Clipping des Gadgets*}
For A:=1 to Qtt_ITM[7] do               {*Draw String Boxes*}
   Bevel (TSB[A].X1, TSB[A].Y1-Tit, TSB[A].X2,
   TSB[A].Y2-Tit, TSB[A].Co, BLLoweredLine,BLRaisedLine,Yes);
For A:=1 to Qtt_ITM[6] do               {*Draw Bevels*}
   Bevel (TBB[A].X1, TBB[A].Y1-Tit, TBB[A].X2,
   TBB[A].Y2-Tit, {TBB[A].Style,} TBB[A].Co, BLRaisedLine,BLNoLine,{TBB[A].Cave,} TBB[A].Fill);
For A:=1 to Qtt_ITM[9] do               {*Draw Icons / Images*}
   Begin
   If IMG[A].Use_Pal Then Id:=$A0 Else Id:=$80;
   If IMG[A].IType=0 Then Show_Icon(IMG[A].X1,IMG[A].Y1-Tit,IMG[A].FName)
                     Else BMP_Show (IMG[A].X1,IMG[A].Y1-Tit,
                                    IMG[A].X2,IMG[A].Y2-Tit, IMG[A].Ox, IMG[A].Oy, IMG[A].FName,Id);
   End;
For A:=1 to Qtt_ITM[8] do               {*Draw Texts*}
   Display(TXT[A].X1, TXT[A].Y1-Tit, {TXT[A].CB,} TXT[A].CP, TXT[A].Cin);

For A:=1 to Qtt_ITM[1] do Begin         {*Draw Buttons*}
   If TBU[A].VanillaKey<>0 Then
     Begin
{SR}{Insert('_',TBU[A].B.TCT[1],TBU[A].VanillaKey);}
     S:=Str_Get(TBU[A].B.TCT,1,'|');
     Insert('_',S,TBU[A].VanillaKey);
     TBU[A].B.TCT:=Str_Put(TBU[A].B.TCT,S,1,'|');
     End;
   Button(TBU[A].X1, TBU[A].Y1-Tit, TBU[A].SX, TBU[A].SY, TBU[A].B.Font.PenColor,
{SR}   TBU[A].B.Font.BgColor,TBU[A].B.Id, TBU[A].B ,Str_Get(TBU[A].B.TCT,1,'|'));
   Gen_Cancel:=No;
   If TBU[A].Action=2 Then Gen_Cancel:=Yes;
   End;
For A:=1 to Qtt_ITM[2] do Begin         {*Draw Cyclers*}
   If TCY[A].VanillaKey<>0 Then Insert('_',TCY[A].Cin,TCY[A].VanillaKey);
{***}   Cycler(TCY[A].X1, TCY[A].Y1-Tit, TCY[A].SX, {TCY[A].B.CyclVal}1,
   TCY[A].B.B.Font.PenColor,TCY[A].B.B.Font.BgColor, TCY[A].B.Id, {TCY[A].B} TCY[A].B,TCY[A].Cin);
   End;
For A:=1 to Qtt_ITM[3] do Begin         {*Draw Radios*}
   RadioBox(TRB[A].X1, TRB[A].Y1-Tit, TRB[A].R.Style, TRB[A].R.IDCMP,
             TRB[A].R.Group, TRB[A].R.PLab, TRB[A].R.Status, TRB[A].R, TRB[A].R.Cin);
   End;
For A:=1 to Qtt_ITM[4] do Begin         {*Draw Sliders*}
{   Slider(TSL[A].X1, TSL[A].Y1-Tit, TSL[A].X2, TSL[A].Y2-Tit,
   TSL[A].S.Quantity, TSL[A].S.Aff, TSL[A].S.Typ, TSL[A].S.GDep, TSL[A].S ,TSL[A].S.Value);}
   End;
For A:=1 to Qtt_ITM[5] do Begin         {*Draw Commands*}
   InputText(TCO[A].X1, TCO[A].Y1-Tit, TCO[A].T.Siz, TCO[A].T.Len,
   TCO[A].T.CoB, TCO[A].T.Co2, TCO[A].T.Sty, TCO[A].T.Id, TCO[A].T ,TCO[A].Cin);
   End;
Win_Clip(No,W);                     {*Retour au Clipping Normal*}
End;

{ͻ
                       PROCEDURE  SAVE_MRECONFIG                            
 ͼ}

Procedure SAVE_MRE_CONFIG(Var M:TMenu);
Var NUM:Integer;
    Fil1:Text;                          {*Fichier de Configuration*}

Begin
Assign(Fil1,'MRE.CFG');                 {*Ouvre la Configuration*}
{$I-}
Rewrite(Fil1);
{$I+}
If IOResult=0 Then Begin                {*Pas d'Erreurs ?*}
   For Num:=1 to 4 do Writeln(Fil1,Language.Loc(591+Num));
   Writeln(Fil1);

   Writeln(Fil1,Gen_Prog);              {*Save Booleans and Various Datas*}
   Writeln(Fil1,Gen_Rem);
   Writeln(Fil1,Gen_Menu);
   Writeln(Fil1,Name_Prog);
   Writeln(Fil1,Name_Proc);
   Writeln(Fil1,Rel_PWin);              {*Window In Relative Pos*}
   Writeln(Fil1,Rel_Px);                {*Relative PX*}
   Writeln(Fil1,Rel_Py);                {*Relative Py*}
   Writeln(Fil1,Perso_Init);            {*Pas d'Init Personelles*}
   Writeln(Fil1,Perso_Done);            {*Pas de Done Personnelles*}
   Writeln(Fil1,Gen_Forp);              {*Generate Procedure=1*}
   Writeln(Fil1,Func_Type);             {*Type Renvoy par Fonction*}

   Writeln(Fil1,My_Grid);
   Writeln(Fil1,Sys.GridStepX);
   Writeln(Fil1,Sys.GridStepY);
   Writeln(Fil1,Disp_Beep);
   Writeln(Fil1,Show_MCoo);
   Writeln(Fil1,Conf_Del);
   Writeln(Fil1,Menu_TestCheck(M,1,8));
   Writeln(Fil1,Menu_TestCheck(M,6,7));
   For Num:=1 to 3 do
      Writeln(Fil1,Menu_TestCheck(M,2,Num));

   Writeln(Fil1,Max_Lines);
   For Num:=1 to Max_Lines do           {*Save Init & Done Code Arrays...*}
      Begin
      Writeln(Fil1,Init_Code[Num]);
      Writeln(Fil1,Done_Code[Num]);
      End;

   Writeln(Fil1,CGL_Qtt);               {*Qtt de Lignes pour Split*}
   Writeln(Fil1,CGL_Pos);               {*Pos Actuelle dans Lignes*}
   Writeln(Fil1,CGL_Inc);               {*Incrments des Lignes ? 1=Yes*}
   Writeln(Fil1,CGC_Qtt);               {*Qtt de Colonnes pour Split*}
   Writeln(Fil1,CGC_Pos);               {*Pos Actuelle dans Colonnes*}
   Writeln(Fil1,CGC_Inc);               {*Incrments des Colonnes ? 1=Yes*}

   Close(Fil1);                         {*Ferme le Fichier...*}

   Num:=4;                              {*Icne Information*}
   Req_Dialog(Language.Loc(461),Language.Loc(596),'   _OK   |',NUM);
   End
   Else Begin
   Num:=1;                              {*Icne Warning*}
   Req_Dialog(Language.Loc(461),Language.Loc(597),'   _OK   |',NUM);
   End;
End;

{ͻ
                        PROCEDURE INIT_MRE_CONFIG                           
 ͼ}

Function LOAD_MRE_CONFIG(Var M:TMenu):Boolean; {*Load And Init MRE Constants*}
Var NUM,Code:Integer;
    St:String;
    Fil1:Text;                          {*Fichier de Configuration*}

Begin
Assign(Fil1,'MRE.CFG');                 {*Ouvre la Configuration*}
{$I-}
Reset(Fil1);
{$I+}
If IOResult=0 Then Begin                {*Pas d'Erreurs ?*}
   For Num:=1 to 5 do Readln(Fil1);     {*Read Entte*}

   Readln(Fil1,St); If Upper(St)='TRUE' Then Gen_Prog:=True Else Gen_Prog:=False;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Gen_Rem:=True Else Gen_Rem:=False;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Gen_Menu:=True Else Gen_Menu:=False;
   Readln(Fil1,Name_Prog);
   Readln(Fil1,Name_Proc);
   Readln(Fil1,St); If Upper(St)='TRUE' Then Rel_PWin:=True Else Rel_PWin:=False;
   Readln(Fil1,Rel_Px);                 {*Relative PX*}
   Readln(Fil1,Rel_Py);                 {*Relative Py*}
   Readln(Fil1,St); If Upper(St)='TRUE' Then Perso_Init:=True Else Perso_Init:=False;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Perso_Done:=True Else Perso_Done:=False;
   Readln(Fil1,Gen_Forp);              {*Generate Procedure=1*}
   Readln(Fil1,Func_Type);             {*Type Renvoy par Fonction*}

   Readln(Fil1,St); If Upper(St)='TRUE' Then My_Grid:=True Else My_Grid:=False;
   Readln(Fil1,Sys.GridStepX);
   Readln(Fil1,Sys.GridStepY);
   Readln(Fil1,St); If Upper(St)='TRUE' Then Disp_Beep:=Yes Else Disp_Beep:=No;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Show_MCoo:=Yes Else Show_MCoo:=No;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Conf_Del:=Yes Else Conf_Del:=No;
   Readln(Fil1,St); If Upper(St)='TRUE' Then Menu_SetId(M,1,8,$0C) Else Menu_SetId(M,1,8,$04);
   Readln(Fil1,St);
   For Num:=1 to 3 do Begin
      Readln(Fil1,St); If Upper(St)='TRUE' Then Menu_SetId(M,2,Num,$0C) Else Menu_SetId(M,2,Num,$04);
      End;

   Readln(Fil1,Code);
   For Num:=1 to Code do                {*Load Init & Done Code Arrays...*}
      Begin
      Readln(Fil1,Init_Code[Num]);
      Readln(Fil1,Done_Code[Num]);
      End;

   Readln(Fil1,CGL_Qtt);                {*Qtt de Lignes pour Split*}
   Readln(Fil1,CGL_Pos);                {*Pos Actuelle dans Lignes*}
   Readln(Fil1,St); If Upper(St)='TRUE' Then CGL_Inc:=Yes Else CGL_Inc:=No;
   Readln(Fil1,CGC_Qtt);                {*Qtt de Colonnes pour Split*}
   Readln(Fil1,CGC_Pos);                {*Pos Actuelle dans Colonnes*}
   Readln(Fil1,St); If Upper(St)='TRUE' Then CGC_Inc:=Yes Else CGC_Inc:=No;

   Close(Fil1);
   LOAD_MRE_CONFIG:=Yes;                {*Loading OK...*}
   End
   Else LOAD_MRE_CONFIG:=No;            {*Loading Error !*}
End;

{ͻ
                          TOGGLE D'UN ITEM ENTOURE                          
 ͼ}

Procedure TOGGLE_ITEM(Ty:Byte);         {*Type et Numro (Implicite) Item*}
Var Nx1,Ny1,Nx2,Ny2:Integer;            {*Coordonnes du Box*}
//    OffX,OffY:Integer;                  {*Dcalage Box for Sliders Buttons*}
    P:Byte;                             {*Numro de l'Item*}

Begin
P:=Pos_ITM[Ty];                         {*Get Numro de l'Item...*}
{gotoxy(1,1); writeln(P,' ',Ty,' ');}
If (P<1) Or (Ty<1) Then Exit;           {*Pas de Box  Effacer*}
VESA_SetLineStyle(0,0,3);                    {*Ligne Grosse*}
VESA_SetWriteMode(XorPut);
VESA_SetColor(CLBackground);

Case Ty of
   1: Begin
      Nx1:=TBU[P].X1;                   {*Coordonnes for Button Item*}
      Ny1:=TBU[P].Y1;
      Nx2:=TBU[P].X1+TBU[P].SX;
      Ny2:=TBU[P].Y1+TBU[P].SY;
      End;
   2: Begin
      Nx1:=TCY[P].X1;                   {*Coordonnes for Cycler Item*}
      Ny1:=TCY[P].Y1;
      Nx2:=TCY[P].X1+TCY[P].SX+18;
      Ny2:=TCY[P].Y1+TCY[P].SY;
      End;
   3: Begin
      Nx1:=TRB[P].X1;                   {*Coordonnes for Radio Box Item*}
      Ny1:=TRB[P].Y1;
      Nx2:=TRB[P].X1+19;
      Ny2:=TRB[P].Y1+4+HaF;
      End;
   4: Begin
//      OffX:=0; OffY:=0;                 {*Coordonnes for Slider Item*}
{      If TSL[P].S.GDep=Yes Then
         If TSL[P].S.Typ=0 Then OffX:=41 Else OffY:=30;
      Nx1:=TSL[P].X1;
      Ny1:=TSL[P].Y1;
      Nx2:=TSL[P].X2+OffX;
      Ny2:=TSL[P].Y2+OffY;}
      End;
   5: Begin
      Nx1:=TCO[P].X1;                   {*Coordonnes for InputText Item*}
      Ny1:=TCO[P].Y1;
      Nx2:=TCO[P].X1+TCO[P].T.Siz;
      Ny2:=TCO[P].Y1+4+HaF;
      End;
   6: Begin
      Nx1:=TBB[P].X1;                   {*Coordonnes for Bevel Item*}
      Ny1:=TBB[P].Y1;
      Nx2:=TBB[P].X2;
      Ny2:=TBB[P].Y2;
      End;
   7: Begin
      Nx1:=TSB[P].X1;                   {*Coordonnes for String Box Item*}
      Ny1:=TSB[P].Y1;
      Nx2:=TSB[P].X2;
      Ny2:=TSB[P].Y2;
      End;
   8: Begin
      Nx1:=TXT[P].X1-2;                 {*Coordonnes for Text Item*}
      Ny1:=TXT[P].Y1;
      Nx2:=TXT[P].X1+VESA_TextWidth(TXT[P].Cin)+2;
      Ny2:=TXT[P].Y1+2+HaF;
      End;
   9: Begin
      Nx1:=IMG[P].X1;                   {*Coordonnes for Icon Item*}
      Ny1:=IMG[P].Y1;
      Nx2:=IMG[P].X2;
      Ny2:=IMG[P].Y2;
      End;
   End;

Nx1:=Nx1+W.X1;                          {*Add Coordonnes Window Project*}
Ny1:=Ny1+W.Y1;
Nx2:=Nx2+W.X1;
Ny2:=Ny2+W.Y1;

Mse_Hide;
VESA_Rectangle(Nx1, Ny1, Nx2, Ny2);          {*Toggle Box*}
Mse_Show;

VESA_SetWriteMode(NormalPut);
VESA_SetLineStyle(0,0,1);                    {*Return to Ligne Fine*}
End;

{ͻ
                          PROCEDURE DEFINE_BUTTONS                          
 ͼ}

Function DEFINE_BUTTONS(M:TMenu; Pos:Byte):Boolean;
Var W1          :TWindow;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,But2,
    But3,But4,But5:TButton;                {*Bouton Classique*}
    Cyc1          :TCycler;
    Co1,Co2,Co3,Co4,Co5,Co6,Co7:TInputText; {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,Cin4,
    Cin5,Cin6,Cin7:String;              {*String Rcupre*}
    Rad1,Rad2,Rad3,Rad4:TRadioBox;            {*Pour Radio Evidement*}
    Code,I      :Integer;
    Cancel      :Boolean;               {*Annulation Modifications*}
    X,Y         :Word;                  {*For Sys.SetGrid Parameters*}
    V1,V2       :Integer;               {*Couleurs TC/BGC*}
    DirSel,Filsel:String;               {*Gestion File Requester*}
    Size        :Longint;

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (125,20,320,167,CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Button(LaF*12, 202,LaF*16,-1, CLTextButton,CLBgButton,$100,But0,'_OK');
Button(LaF*42, 202,LaF*16,-1, CLTextButton,CLBgButton,$0,But2,Language.Loc(13));
Button(20, 125,95,-1, CLLightBLue,CLBlue,$0,But1,Language.Loc(600));
Button(20, 105,95,-1, CLLightBLue,CLBlue,$0,But5,Language.Loc(773));
Button(140,28,110,-1, CLLightBLue,CLBlue,$0,But3,Language.Loc(601));
Button(140,47,110,-1, CLLightBLue,CLBlue,$0,But4,Language.Loc(602));

Cycler( LaF*44, HaF*14+6,LaF*14,Cyc1.CyclVal, CLTextButton,CLBgButton,$0,Cyc1,Language.Loc(548));

Display(22,25, CLText,Language.Loc(604));
Display(22,45, CLText,Language.Loc(605));
Display(22,65, CLText,Language.Loc(606));
Display(22,85, CLText,Language.Loc(607));
Display(22,176,CLText,Language.Loc(608));

Font_Set('ITAL.CHR',4);
Display (138,146,CLText,Language.Loc(547));
RadioBox(279,67, 1,$00,0,10,Rad1.Status,Rad1,Language.Loc(609));
RadioBox(279,86, 1,$00,0,10,Rad2.Status,Rad2,Language.Loc(610));
RadioBox(279,105,1,$00,0,10,Rad3.Status,Rad3,Language.Loc(611));
RadioBox(279,125,1,$00,0,10,Rad4.Status,Rad4,Language.Loc(799));
Font_Set(Sys.FontMain,Sys.FontMainSize);

InputText(75, 24,30,3,  CLSky,CLSalmon,1,$126,Co1,Cin1);
InputText(75, 44,30,3,  CLSky,CLSalmon,1,$126,Co2,Cin2);
InputText(75, 64,30,3,  CLSky,CLSalmon,1,$126,Co3,Cin3);
InputText(75, 84,30,3,  CLLightGrey,CLSalmon,1,$126,Co4,Cin4);
InputText(279,28,30,3,  V1,CLSalmon,1,$166,Co5,Cin5);
InputText(279,47,30,3,  V2,CLSalmon,1,$166,Co6,Cin6);
InputText(60,175,259,37,CLSky,CLSalmon,1,$27,Co7,Cin7);

Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Button Number*}
If Not Win_Init(30,140,376,362+HaF1,$51D9,Language.Loc(612)+Cin1,W1) Then Exit;
Win_Sup(100,50,347,218,59,50,400,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Sys.SetGrid:=My_Grid;                          {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
   X:=TBU[Pos].X1; Y:=TBU[Pos].Y1;      {*Calcul New Coordonnes With Steps*}
   Mse_GetPosInGrid(X,Y);
   TBU[Pos].X1:=X; TBU[Pos].Y1:=Y;
   X:=TBU[Pos].SX;
   Mse_GetPosInGrid(X,Y);
   TBU[Pos].SX:=X;
End;
Sys.SetGrid:=No;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TBU[Pos].X1,Cin1); Str(TBU[Pos].Y1,Cin2);{*Init Values*}
Str(TBU[Pos].SX,Cin3); Str(TBU[Pos].SY,Cin4);
Str(TBU[Pos].B.Font.BgColor,Cin5); Str(TBU[Pos].B.Font.PenColor,Cin6);
{SR}Cin7:=Str_Get(TBU[Pos].B.TCT,1,'|');
If TBU[Pos].B.Id And $2=$2   Then Rad1.Status:=Yes{*Init Radios*}
                             Else Rad1.Status:=No;
If TBU[Pos].B.Id And $1=$1   Then Rad2.Status:=Yes
                             Else Rad2.Status:=No;
If TBU[Pos].B.Id And $4=$4   Then Rad3.Status:=Yes
                             Else Rad3.Status:=No;
If TBU[Pos].B.Id And $10=$10 Then Rad4.Status:=Yes
                             Else Rad4.Status:=No;
If TBU[Pos].VanillaKey<>0 Then          {*Remet Caractre Soulign*}
   Insert('_',Cin7,TBU[Pos].VanillaKey);

Cyc1.CyclVal:=TBU[Pos].MoA+1;           {*Mouse Button Test...*}
If TBU[Pos].MoA=10 Then Cyc1.CyclVal:=5;{*Correct 10=No Buttons*}

V1:=TBU[Pos].B.Font.BgColor; V2:=TBU[Pos].B.Font.PenColor; {*Couleurs Gadgets*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flag de Sortie*}
DirSel:=Sys.GetPath(SP_MAIN); FilSel:='';

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   Win_Clip(Yes,W1);
   If Button_GetMsg(But0,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But1,1)=CMSelected Then BUTTON_ACTION(Pos);
   If Button_GetMsg(But3,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V1,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V1,Cin5); REDRAW_FRAME
      End;
   If Button_GetMsg(But4,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V2,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V2,Cin6); REDRAW_FRAME;
      End;
   If Button_GetMsg(But5,1)=CMSelected Then Begin  {*Slectionner une Icne*}
      Req_FileManager(60,14,282,Language.Loc(260),Language.Loc(162),'*.ICO|*.BMP',0,DirSel,FilSel,Size);
      If FilSel<>'' Then Begin          {*Pas d'annulation ?*}
         Cin7:=DirSel+FilSel; REDRAW_FRAME;
         End;
      End;
   InputText_GetMsg(Co1,Cin1); InputText_GetMsg(Co2,Cin2);
   InputText_GetMsg(Co3,Cin3); InputText_GetMsg(Co4,Cin4);
   InputText_GetMsg(Co7,Cin7);

   Cycler_GetMsg(Cyc1,1);
   RadioBox_GetMsg(Rad1,1);
   RadioBox_GetMsg(Rad2,1);
   RadioBox_GetMsg(Rad3,1);
   RadioBox_GetMsg(Rad4,1);
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin
   TBU[Pos].VanillaKey:=0;              {*De Base si il n'y en a pas*}
   For I:=1 to Length(Cin7) do
      If Copy(Cin7,I,1)='_' Then Begin
         TBU[Pos].VanillaKey:=I;
         End;
   If TBU[Pos].VanillaKey<>0 Then
      Cin7:=Copy(Cin7,1,TBU[Pos].VanillaKey-1)+Copy(Cin7,TBU[Pos].VanillaKey+1,Length(Cin7)-TBU[Pos].VanillaKey);

   Val(Cin1,TBU[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TBU[Pos].Y1,Code);
   Val(Cin3,TBU[Pos].SX,Code);
   Val(Cin4,TBU[Pos].SY,Code);
   TBU[Pos].B.Font.BgColor:=V1;
   TBU[Pos].B.Font.PenColor:=V2;
{SR}{   TBU[Pos].B.TCT[1]:=Cin7;}
   TBU[Pos].B.TCT:=Str_Put(TBU[Pos].B.TCT,Cin7,1,'|');
   TBU[Pos].MoA:=TMB[Cyc1.CyclVal];     {*Mouse Button Test...*}
   If Rad1.Status Then TBU[Pos].B.Id:=TBU[Pos].B.Id Or $2
                  Else TBU[Pos].B.Id:=TBU[Pos].B.Id And $FD;
   If Rad2.Status Then TBU[Pos].B.Id:=TBU[Pos].B.Id Or $1
                  Else TBU[Pos].B.Id:=TBU[Pos].B.Id And $FE;
   If Rad3.Status Then TBU[Pos].B.Id:=TBU[Pos].B.Id Or $4
                  Else TBU[Pos].B.Id:=TBU[Pos].B.Id And $FB;
   If Rad4.Status Then TBU[Pos].B.Id:=TBU[Pos].B.Id Or $10
                  Else TBU[Pos].B.Id:=TBU[Pos].B.Id And $EF;
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_BUTTONS:=True;
   End Else DEFINE_BUTTONS:=False;

End;

{ͻ
                          PROCEDURE DEFINE_CYCLER                           
 ͼ}

Function DEFINE_CYCLERS(M:TMenu; Pos:Byte):Boolean;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evenements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But0,But1,
    But2,But3     :TButton;                {*Bouton Classique*}
    Cyc1          :TCycler;
    Co1,Co2,Co3,Co4,
    Co5,Co6,Co7,Co8:TInputText;             {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,Cin4,
    Cin5,Cin6,Cin7,Cin8:String;         {*String Rcupre*}
    Rad1,Rad2,Rad3:TRadioBox;                 {*Pour Radio Evidement*}
    Code,I        :Integer;
    Cancel        :Boolean;             {*Annulation Modifications*}
    X,Y           :Word;                {*For Sys.SetGrid Parameters*}
    V1,V2         :Integer;             {*Couleurs TC/BGC*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (125,20,320,167,CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Button(LaF*12, 202,LaF*16,-1, CLTextButton,CLBgButton,$100,But0,'_OK');
Button(LaF*42, 202,LaF*16,-1, CLTextButton,CLBgButton,$0,But1,Language.Loc(13));
Button(140,28,110,-1, CLLightBlue,CLBlue,$0,But2,Language.Loc(601));
Button(140,47,110,-1, CLLightBlue,CLBlue,$0,But3,Language.Loc(602));

Cycler( LaF*44, HaF*14+6,LaF*14,Cyc1.CyclVal, CLTextButton,CLBgButton,$0,Cyc1,Language.Loc(548));

Display(60,16, CLText,Language.Loc(603));
Display(22,35, CLText,Language.Loc(604));
Display(22,55, CLText,Language.Loc(605));
Display(22,75, CLText,Language.Loc(606));
Display(22,95, CLText,Language.Loc(607));
Display(22,176,CLText,Language.Loc(608));

Font_Set('ITAL.CHR',4);
Display(138,68, CLText,Language.Loc(616));
Display(138,146,CLText,Language.Loc(547));
RadioBox(279,86, 1,$00,0,10,Rad2.Status,Rad2,Language.Loc(611));
RadioBox(279,106,1,$00,0,10,Rad1.Status,Rad1,Language.Loc(618));
RadioBox(279,126,1,$00,0,10,Rad3.Status,Rad3,Language.Loc(799));
Font_Set(Sys.FontMain,Sys.FontMainSize);

InputText(75, 34,30,3, CLSky,CLSalmon,1,$126,Co1,Cin1);
InputText(75, 54,30,3, CLSky,CLSalmon,1,$126,Co2,Cin2);
InputText(75, 74,30,3, CLSky,CLSalmon,1,$126,Co3,Cin3);
InputText(75, 94,30,3, CLLightGrey, CLSalmon,1,$166,Co4,Cin4);
InputText(279,67,30,3, CLSky,CLSalmon,1,$126,Co8,Cin8);
InputText(279,28,30,3, V1,CLSalmon,1,$166,Co5,Cin5);
InputText(279,47,30,3, V2,CLSalmon,1,$166,Co6,Cin6);
InputText(60,175,259,255,CLSky,CLSalmon,1,$27,Co7,Cin7);

If Rad2.Status=True Then InPutText_Freeze(Yes,Co4)    {*Gadget Autoris or No*}
                    Else InPutText_Freeze(No, Co4);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
If Not Win_Init(30,140,376,362+HaF1,$51D9,Language.Loc(619)+Cin1,W1) Then Exit;
Win_Sup(100,50,347,218,59,50,400,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Sys.SetGrid:=My_Grid;                          {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
   X:=TCY[Pos].X1; Y:=TCY[Pos].Y1;      {*Calcul New Coordonnes With Steps*}
   Mse_GetPosInGrid(X,Y);
   TCY[Pos].X1:=X; TCY[Pos].Y1:=Y;
   X:=TCY[Pos].SX; Y:=TCY[Pos].SY;
   Mse_GetPosInGrid(X,Y);
   TCY[Pos].SX:=X; TCY[Pos].SY:=Y;
End;
Sys.SetGrid:=No;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TCY[Pos].X1,Cin1); Str(TCY[Pos].Y1,Cin2);{*Init Values*}
Str(TCY[Pos].SX,Cin3); Str(TCY[Pos].SY,Cin4);
Str(TCY[Pos].B.B.Font.BgColor,Cin5); Str(TCY[Pos].B.B.Font.PenColor,Cin6);
Cin7:=TCY[Pos].Cin;
{Str(TCY[Pos].B.CyclVal,Cin8);}

If TCY[Pos].B.Id And $2=$2   Then Rad1.Status:=Yes{*Init Radio*}
                             Else Rad1.Status:=No;
If TCY[Pos].B.Id And $4=$4   Then Rad2.Status:=Yes
                             Else Rad2.Status:=No;
If TCY[Pos].B.Id And $10=$10 Then Rad3.Status:=Yes
                             Else Rad3.Status:=No;
If TCY[Pos].VanillaKey<>0 Then          {*Remet Caractre Soulign*}
   Insert('_',Cin7,TCY[Pos].VanillaKey);

Cyc1.CyclVal:=TCY[Pos].MoA+1;           {*Mouse Button Test...*}
If TCY[Pos].MoA=10 Then Cyc1.CyclVal:=5;{*Correct 10=No Buttons*}

V1:=TCY[Pos].B.B.Font.BgColor; V2:=TCY[Pos].B.B.Font.PenColor; {*Couleurs Gadget*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   Win_Clip(Yes,W1);
   If Button_GetMsg(But0,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V1,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V1,Cin5); REDRAW_FRAME;
      End;
   If Button_GetMsg(But3,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V2,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V2,Cin6); REDRAW_FRAME;
      End;

   InputText_GetMsg(Co7,Cin7);
   InputText_GetMsg(Co1,Cin1);
   InputText_GetMsg(Co2,Cin2);
   InputText_GetMsg(Co3,Cin3);
   InputText_GetMsg(Co8,Cin8);

   Cycler_GetMsg(Cyc1,1);
   RadioBox_GetMsg(Rad1,1);
   RadioBox_GetMsg(Rad3,1);
   If RadioBox_GetMsg(Rad2,1)<>CMNone Then
      If Rad2.Status=True
         Then InPutText_Freeze(Yes,Co4)    {*Gadget Autoris*}
         Else InPutText_Freeze(No,Co4);
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin                {*Modification Confirme*}
   TCY[Pos].VanillaKey:=0;              {*De Base si il n'y en a pas*}
   For I:=1 to Length(Cin7) do
      If Copy(Cin7,I,1)='_' Then Begin
         TCY[Pos].VanillaKey:=I;
         End;
   If TCY[Pos].VanillaKey<>0 Then
      Cin7:=Copy(Cin7,1,TCY[Pos].VanillaKey-1)+Copy(Cin7,TCY[Pos].VanillaKey+1,Length(Cin7)-TCY[Pos].VanillaKey);

   Val(Cin1,TCY[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TCY[Pos].Y1,Code);
   Val(Cin3,TCY[Pos].SX,Code);
   Val(Cin4,TCY[Pos].SY,Code);
   TCY[Pos].B.B.Font.BgColor:=V1;
   TCY[Pos].B.B.Font.PenColor:=V2;
{   Val(Cin8,TCY[Pos].B.CyclVal,Code);}
   TCY[Pos].Cin:=Cin7;
   TCY[Pos].MoA:=TMB[Cyc1.CyclVal];     {*Mouse Button Test...*}
   If Rad1.Status Then TCY[Pos].B.Id:=TCY[Pos].B.Id Or $2
                  Else TCY[Pos].B.Id:=TCY[Pos].B.Id And $FD;
   If Rad2.Status Then TCY[Pos].B.Id:=TCY[Pos].B.Id Or $4
                  Else TCY[Pos].B.Id:=TCY[Pos].B.Id And $FB;
   If Rad3.Status Then TCY[Pos].B.Id:=TCY[Pos].B.Id Or $10
                  Else TCY[Pos].B.Id:=TCY[Pos].B.Id And $EF;
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_CYCLERS:=True;
   End Else DEFINE_CYCLERS:=False;

End;

{ͻ
                           PROCEDURE DEFINE_RADIO                           
 ͼ}

Function DEFINE_RADIOS(M:TMenu; Pos:Byte):Boolean;
Var W1            :TWindow;             {*Structure Fentre*}
    Even          :Byte;                {*Rception Evenements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But0,But1     :TButton;             {*Bouton Classique*}
    Cyc0,Cyc1,Cyc2,Cyc3:TCycler;        {*Bouton Cycler*}
    Co1,Co2,Co3,Co4:TInputText;         {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,Cin4:String;         {*String Rcupre*}
    Rad1,Rad2,Rad3:TRadioBox;           {*Pour Radio Evidemment*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Modifications*}
    X,Y           :Word;                {*For Sys.SetGrid Parameters*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (125,20,325,186,CLMauve,BLLoweredLine,BLRaisedLine,Yes);

Display(60, 16,CLText,Language.Loc(603));
Display(22, 35,CLText,Language.Loc(604));
Display(22, 55,CLText,Language.Loc(605));

Font_Set('ITAL.CHR',4);
Display(140,29, CLText,Language.Loc(620));
Display(140,48, CLText,Language.Loc(621));
Display(140,125,CLText,Language.Loc(623));
Display(20, 196,CLText,Language.Loc(608));
Display(140,144,CLText,Language.Loc(795));
Display(140,165,CLText,Language.Loc(547));

RadioBox(266,85, 1,$00,0,9,Rad1.Status,Rad1,Language.Loc(611));
RadioBox(266,66, 1,$00,0,9,Rad2.Status,Rad2,Language.Loc(622));
RadioBox(266,104,1,$00,0,9,Rad3.Status,Rad3,Language.Loc(599));
Font_Set(Sys.FontMain,Sys.FontMainSize);

Button(LaF*12, 222, LaF*16,-1, CLTextButton,CLBgButton,$100,But0,'_OK');
Button(LaF*42, 222, LaF*16,-1, CLTextButton,CLBgButton,$0,But1,Language.Loc(13));

InputText(75, 34, 30,3,  CLSky,CLSalmon,1,$126,Co1,Cin1);
InputText(75, 54, 30,3,  CLSky,CLSalmon,1,$126,Co2,Cin2);
InputText(65,195,260,255,CLSky,CLSalmon,1,$27,Co3,Cin3);
InputText(266,124,30,3,  CLSky,CLSalmon,1,$126,Co4,Cin4);
Cycler(230, 28, 70,Cyc0.CyclVal, CLTextButton,CLBgButton,$0,Cyc0,Language.Loc(624));
Cycler(230, 47, 70,Cyc1.CyclVal, CLTextButton,CLBgButton,$0,Cyc1,Language.Loc(625));
Cycler(230, 144,70,Cyc2.CyclVal, CLTextButton,CLBgButton,$0,Cyc2,Language.Loc(640));
Cycler(230, 164,70,Cyc3.CyclVal, CLTextButton,CLBgButton,$0,Cyc3,Language.Loc(548));

If Cyc0.CyclVal=3 Then InputText_Freeze(No,Co4) Else InputText_Freeze(Yes,Co4);
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
If Not Win_Init(30,180,376,422+HaF1,$51D9,Language.Loc(626)+Cin1,W1) Then Exit;
Win_Sup(100,50,347,218,59,50,400,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Sys.SetGrid:=My_Grid;                          {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TRB[Pos].X1; Y:=TRB[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Mse_GetPosInGrid(X,Y);
TRB[Pos].X1:=X; TRB[Pos].Y1:=Y;
End;
Sys.SetGrid:=No;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TRB[Pos].X1,Cin1); Str(TRB[Pos].Y1,Cin2);{*Init Values*}
Str(TRB[Pos].R.Group,Cin4);
Cin3:=TRB[Pos].R.Cin;
If TRB[Pos].R.IDCMP And $4=$4 Then Rad2.Status:=Yes{*Init Radios*}
                              Else Rad2.Status:=No;
If TRB[Pos].R.IDCMP And $8=$8 Then Rad1.Status:=Yes
                              Else Rad1.Status:=No;
If TRB[Pos].R.IDCMP And $10=$10 Then Rad3.Status:=Yes
                                Else Rad3.Status:=No;
Cyc0.CyclVal:=TRB[Pos].R.Style+1;
Cyc2.CyclVal:=TRB[Pos].R.Plab+1;
Cyc3.CyclVal:=TRB[Pos].MoA+1;           {*Mouse Button Test...*}
If TRB[Pos].MoA=10 Then Cyc3.CyclVal:=5;{*Correct 10=No Buttons*}

If TRB[Pos].R.Status=Yes Then Cyc1.CyclVal:=1 Else Cyc1.CyclVal:=2;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   Win_Clip(Yes,W1);
   If Button_GetMsg(But0,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;
   InputText_GetMsg(Co1,Cin1);
   InputText_GetMsg(Co2,Cin2);
   InputText_GetMsg(Co3,Cin3);
   InputText_GetMsg(Co4,Cin4);
   If Cycler_GetMsg(Cyc0,1)=CMSelected Then
     If Cyc0.CyclVal=3 Then InPutText_Freeze(No,Co4)
                       Else InPutText_Freeze(Yes,Co4);
   Cycler_GetMsg(Cyc1,1);
   Cycler_GetMsg(Cyc2,1);
   Cycler_GetMsg(Cyc3,1);
   RadioBox_GetMsg(Rad1,1);
   RadioBox_GetMsg(Rad2,1);
   RadioBox_GetMsg(Rad3,1);
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin
   Val(Cin1,TRB[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TRB[Pos].Y1,Code);
   Val(Cin4,TRB[Pos].R.Group,Code);
   TRB[Pos].R.Cin:=Cin3;
   TRB[Pos].R.Style:=Cyc0.CyclVal-1;
   TRB[Pos].R.Plab:=Cyc2.CyclVal-1;
   If Cyc1.CyclVal=1 Then TRB[Pos].R.Status:=Yes Else TRB[Pos].R.Status:=No;
   TRB[Pos].MoA:=TMB[Cyc3.CyclVal];     {*Mouse Button Test...*}
   If Rad2.Status Then TRB[Pos].R.IDCMP:=TRB[Pos].R.IDCMP Or $4
                  Else TRB[Pos].R.IDCMP:=TRB[Pos].R.IDCMP And ($FF-$4);
   If Rad1.Status Then TRB[Pos].R.IDCMP:=TRB[Pos].R.IDCMP Or $8
                  Else TRB[Pos].R.IDCMP:=TRB[Pos].R.IDCMP And ($FF-$8);
   If Rad3.Status Then TRB[Pos].R.IDCMP:=TRB[Pos].R.IDCMP Or $10
                  Else TRB[Pos].R.IDCMP:=TRB[Pos].R.IDCMP And ($FF-$10);
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_RADIOS:=True;
   End Else DEFINE_RADIOS:=False;

End;

{ͻ
                          PROCEDURE DEFINE_SLIDERS                          
 ͼ}

Function DEFINE_SLIDERS(M:TMenu; Pos:Byte):Boolean;
Var W1            :TWindow;                 {*Structure Fentre*}
    Even          :Byte;                {*Rception Evenements Fentre*}
    Exit_Flg      :Boolean;             {*Flag de Sortie*}
    But0,But1,But2:TButton;                {*Bouton Classique*}
    Cyc0,Cyc1     :TCycler;                {*Bouton Cycler*}
    Co1,Co2,Co3,Co4,
    Co5,Co6,Co7   :TInputText;              {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,Cin4,
    Cin5,Cin6,Cin7:String;              {*String Rcupre*}
    Rad2          :TRadioBox;                 {*Pour Radio Evidement*}
    Code          :Integer;
    Cancel        :Boolean;             {*Annulation Modifications*}
    X,Y           :Word;                {*For Sys.SetGrid Parameters*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (125,20,325,147,CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Button(LaF*12, 162,LaF*16,-1, CLTextButton,CLBgButton,$100,But0,'_OK');
Button(LaF*42, 162,LaF*16,-1, CLTextButton,CLBgButton,$0,But1,Language.Loc(13));
Button(20, 115,85,-1, CLLightBlue,CLBlue,$0,But2,Language.Loc(600));

Cycler( LaF*46, HaF*12+6,LaF*14,Cyc1.CyclVal, CLTextButton,CLBgButton,$0,Cyc1,Language.Loc(548));

Display(60, 16, CLText,Language.Loc(603));
Display(22, 35, CLText,Language.Loc(604));
Display(22, 55, CLText,Language.Loc(605));
Display(22, 75, CLText,Language.Loc(627));
Display(22, 95, CLText,Language.Loc(628));

Font_Set('ITAL.CHR',4);
Display(135,28, CLText,Language.Loc(629));
Display(135,48, CLText,Language.Loc(630));
Display(135,68, CLText,Language.Loc(631));
Display(135,88, CLText,Language.Loc(632));
Display(135,128,CLText,Language.Loc(547));

RadioBox(230,106,1,$00,0,7,Rad2.Status,Rad2,Language.Loc(633));
Font_Set(Sys.FontMain,Sys.FontMainSize);

InputText(75, 34,30,3, CLSky,CLSalmon,1,$127,Co1,Cin1);
InputText(75, 54,30,3, CLSky,CLSalmon,1,$126,Co2,Cin2);
InputText(75, 74,30,3, CLSky,CLSalmon,1,$126,Co3,Cin3);
InputText(75, 94,30,3, CLSky,CLSalmon,1,$126,Co4,Cin4);
InputText(230,27,30,3, CLSky,CLSalmon,1,$126,Co5,Cin5);
InputText(230,47,30,3, CLSky,CLSalmon,1,$126,Co6,Cin6);
InputText(230,67,30,3, CLSky,CLSalmon,1,$126,Co7,Cin7);
Cycler( 230,87,70,Cyc0.CyclVal, CLTextButton,CLBgButton,$0,Cyc0,Language.Loc(634));
Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
If Not Win_Init(30,160,376,342+HaF1,$51D9,Language.Loc(635)+Cin1,W1) Then Exit;
Win_Sup(100,50,347,218,59,50,400,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Sys.SetGrid:=My_Grid;                          {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TSL[Pos].X1; Y:=TSL[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Mse_GetPosInGrid(X,Y);
TSL[Pos].X1:=X; TSL[Pos].Y1:=Y;
X:=TSL[Pos].X2; Y:=TSL[Pos].Y2;
Mse_GetPosInGrid(X,Y);
TSL[Pos].X2:=X; TSL[Pos].Y2:=Y;
End;
Sys.SetGrid:=No;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TSL[Pos].X1,Cin1); Str(TSL[Pos].Y1,Cin2);{*Init Values*}
Str(TSL[Pos].X2,Cin3); Str(TSL[Pos].Y2,Cin4);
{Str(TSL[Pos].S.Quantity,Cin5); Str(TSL[Pos].S.Aff,Cin6);}
Str(TSL[Pos].S.Value,Cin7);
{Rad2.Status:=TSL[Pos].S.GDep;}           {*Init Radios*}
{Cyc0.CyclVal:=TSL[Pos].S.Typ+1;}
Cyc1.CyclVal:=TSL[Pos].MoA+1;           {*Mouse Button Test...*}
If TSL[Pos].MoA=10 Then Cyc1.CyclVal:=5;{*Correct 10=No Buttons*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   Win_Clip(Yes,W1);
   If Button_GetMsg(But0,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But2,1)=CMSelected Then ASK_SLIDER_TO_COMMAND(Pos);

   InputText_GetMsg(Co1,Cin1);
   InputText_GetMsg(Co2,Cin2);
   InputText_GetMsg(Co3,Cin3);
   InputText_GetMsg(Co4,Cin4);
   InputText_GetMsg(Co5,Cin5);            {*Prefs Fill Colors And Background*}
   InputText_GetMsg(Co6,Cin6);
   InputText_GetMsg(Co7,Cin7);
   Cycler_GetMsg(Cyc0,1);
   Cycler_GetMsg(Cyc1,1);
   RadioBox_GetMsg(Rad2,1);
   Win_Clip(No,W1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Supprime Fentre*}

If Cancel=No Then Begin
   Val(Cin1,TSL[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TSL[Pos].Y1,Code);
   Val(Cin3,TSL[Pos].X2,Code);
   Val(Cin4,TSL[Pos].Y2,Code);
   Val(Cin5,TSL[Pos].S.Quantity,Code);
{   Val(Cin6,TSL[Pos].S.Aff,Code);}
   Val(Cin7,TSL[Pos].S.Value,Code);
{   TSL[Pos].S.Typ:=Cyc0.CyclVal-1;}
   TSL[Pos].MoA:=TMB[Cyc1.CyclVal];     {*Mouse Button Test...*}
{   TSL[Pos].S.GDep:=Rad2.Status;}
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_SLIDERS:=True;
   End Else DEFINE_SLIDERS:=False;

End;

{ͻ
                          PROCEDURE DEFINE_COMMANDS                         
 ͼ}

Function DEFINE_COMMANDS(M:TMenu; Pos:Byte):Boolean;
Const Max_Rad=13;                       {*Nombre Max de Radio-Box*}
      Max_Com=8;
Var W1            :TWindow;                 {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;
    But1,But2,But3,
    But4          :TButton;                {*Buttons Structure*}
    TRad          :Array[1..Max_Rad] of TRadioBox; {*Radios Structure*}
    TCom          :Array[1..Max_Com] of TInputText; {*Commands Structure*}
    TCin          :Array[1..Max_Com] of String; {*Strings for Commands*}
    X,Y           :Word;                {*For Sys.SetGrid Parameters*}
    V1,V2         :Integer;             {*Couleurs TC/BGC*}
    Code          :Integer;
    A             :Integer;             {*Loop*}
    Lab           :Integer;             {*Loc Label*}

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Var A,V           :Integer;             {*Loop And Color*}
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*4, HaF*10+6,LaF*42, HaF*22+1, CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*44,HaF*2+1, LaF*80, HaF*23+1, CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Display( LaF*8, HaF*2+2, CLText,Language.Loc(603));
Display( LaF*4, HaF*4+2, CLText,Language.Loc(604));
Display( LaF*4, HaF*6+2, CLText,Language.Loc(605));
Display( LaF*4, HaF*8+3, CLText,Language.Loc(606));
Display( LaF*4, HaF*24+1,CLText,Language.Loc(608));
Font_Set('ITAL.CHR',4);
Display( LaF*6, HaF*16+8,CLText,Language.Loc(638));
Display( LaF*6, HaF*18+8,CLText,Language.Loc(639));
Font_Set(Sys.FontMain,Sys.FontMainSize);

For A:=1 to Max_Rad do
   Begin
   If A<=12 Then Lab:=868 Else Lab:=883;
   RadioBox( LaF*46, HaF*3+1+(A-1)*(HaF+5),1,$0,0,0,TRad[A].Status,TRad[A],Language.Loc(Lab+A));
   End;

Button( LaF*6, HaF*12+6, LaF*26,-1, CLLightBlue,CLBlue,$00,But1,Language.Loc(636));
Button( LaF*6, HaF*14+6, LaF*26,-1, CLLightBlue,CLBlue,$00,But2,Language.Loc(637));
Button( LaF*15,HaF*26+8, LaF*16,-1, CLTextButton,CLBgButton,$100,But3,'_OK');
Button( LaF*51,HaF*26+8, LaF*16,-1, CLTextButton,CLBgButton,$00,But4,Language.Loc(13));

For A:=1 to 3 do InputText( LaF*14, HaF*2+2+HaF*2*A,LaF*6,4, CLSky,CLLightBlue,1,$0126,TCom[A],TCin[A]);
For A:=1 to 4 do
   Begin
   Case A of                            {*Definit Couleurs Commands*}
      1: V:=V1;
      2: V:=V2;
      Else V:=CLSky;
      End;
   InputText( LaF*34, HaF*10+6+HaF*2*A,LaF*6,3, V,CLLightBlue,1,$0126,TCom[A+4],TCin[A+4]);
   End;
InputText( LaF*14, HaF*24+1,LaF*66,255, CLSky,CLLightBlue,1,$0027,TCom[4],TCin[4]);

Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Str(Pos,TCin[1]);                       {*For Item Number*}
If Not Win_Init(0,160,LaF*84,160+HaF1+HaF*28+8,$51D9,Language.Loc(641)+TCin[1],W1) Then Exit;
Win_Sup(0,0,0,0,0,0,0,0,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                        {*Display Window*}

Sys.SetGrid:=My_Grid;                          {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
   X:=TCO[Pos].X1; Y:=TCO[Pos].Y1;      {*Calcul New Coordonnes With Steps*}
   Mse_GetPosInGrid(X,Y);
   TCO[Pos].X1:=X; TCO[Pos].Y1:=Y;
   X:=TCO[Pos].T.Siz;
   Mse_GetPosInGrid(X,Y);
   TCO[Pos].T.Siz:=X;
   End;
Sys.SetGrid:=No;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TCO[Pos].X1,TCin[1]); Str(TCO[Pos].Y1,TCin[2]);{*Init Values*}
Str(TCO[Pos].T.Siz,TCin[3]);
Str(TCO[Pos].T.CoB,TCin[5]);
Str(TCO[Pos].T.Co2,TCin[6]);
Str(TCO[Pos].T.Len,TCin[7]);
Str(TCO[Pos].T.Sty,TCin[8]);
TCin[4]:=TCO[Pos].Cin;

V1:=TCO[Pos].T.CoB; V2:=TCO[Pos].T.Co2; {*Couleurs Gadgets*}
For A:=1 to Max_Rad do                  {*Init Radios*}
   TRad[A].Status:=BTST(TCO[Pos].T.Id,A-1);

REDRAW_FRAME;                           {*Display Window Content*}
Cancel:=No; Exit_Flg:=No;               {*Init Exit Flag*}

Repeat
try
;
If Win_Ready(W1) Then                {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V1,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V1,TCin[5]); REDRAW_FRAME;
      End;
   If Button_GetMsg(But2,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V2,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V2,TCin[6]); REDRAW_FRAME;
      End;
   If Button_GetMsg(But3,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But4,1)=CMSelected Then Cancel:=Yes;

   For A:=1 to Max_Rad do RadioBox_GetMsg(TRad[A],1);
   For A:=1 to Max_Com do InputText_GetMsg(TCom[A],TCin[A]);
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=Yes;             {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Exit Flag*}

Win_Done(W1);                        {*Close Window if Needs*}

If Not Cancel Then Begin
   Val(TCin[1],TCO[Pos].X1,Code);       {*Transmet Values*}
   Val(TCin[2],TCO[Pos].Y1,Code);
   Val(TCin[3],TCO[Pos].T.Siz,Code);
   Val(TCin[7],TCO[Pos].T.Len,Code);
   TCO[Pos].T.CoB:=V1;
   TCO[Pos].T.Co2:=V2;
   Val(TCin[8],TCO[Pos].T.Sty,Code);
   TCO[Pos].Cin:=TCin[4];

   For A:=1 to Max_Rad do               {*Set Commands Bits*}
      If TRad[A].Status Then BSET(TCO[Pos].T.Id,A-1)
                        Else BCLR(TCO[Pos].T.Id,A-1);

   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_COMMANDS:=True;
   End Else DEFINE_COMMANDS:=False;

End;

{ͻ
                         PROCEDURE DEFINE_BEVEL_BOX                         
 ͼ}

Function DEFINE_BEVEL_BOX(M:TMenu; Pos:Byte):Boolean;
Var W1          :TWindow;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,But2,But3:TButton;           {*Bouton Classique*}
    Co1,Co2,Co3,Co4,Co5,Co6:TInputText;     {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6:String;              {*String Rcupre*}
    Rad1,Rad2   :TRadioBox;                   {*Pour Radio Evidement*}
    Code        :Integer;
    Cancel      :Boolean;               {*Annulation Modifs*}
    X,Y         :Word;                  {*For Sys.SetGrid Parameters*}
    V1,V2       :Integer;               {*Couleur TC/BGC*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (125,20,325,107, CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Button(LaF*12, 122,LaF*16,-1, CLTextButton,CLBgButton,$100,But0,'_OK');
Button(LaF*42, 122,LaF*16,-1, CLTextButton,CLBgButton,$0,But1,Language.Loc(13));
Button(140,28,110,-1, CLLightBlue,CLBlue,$0,But3,Language.Loc(643));
Button(140,48,110,-1, CLLightBlue,CLBlue,$0,But2,Language.Loc(601));

Display(80, 16, CLMauve,Language.Loc(644));
Display(22, 35, CLMauve,Language.Loc(604));
Display(22, 55, CLMauve,Language.Loc(605));
Display(22, 75, CLMauve,Language.Loc(627));
Display(22, 95, CLMauve,Language.Loc(628));

Font_Set('ITAL.CHR',4);
RadioBox(270,68,1,$00,0,9,Rad1.Status,Rad1,Language.Loc(645));
RadioBox(270,88,1,$00,0,9,Rad2.Status,Rad2,Language.Loc(646));
Font_Set(Sys.FontMain,Sys.FontMainSize);

InputText(75, 34,30,3, CLSky,CLSalmon,1,$127,Co1,Cin1);
InputText(75, 54,30,3, CLSky,CLSalmon,1,$126,Co2,Cin2);
InputText(75, 74,30,3, CLSky,CLSalmon,1,$126,Co3,Cin3);
InputText(75, 94,30,3, CLSky,CLSalmon,1,$126,Co4,Cin4);
InputText(270,28,30,3, CLSky,CLSalmon,1,$166,Co5,Cin5);
InputText(270,48,30,3, V1,CLSalmon,1,$166,Co6,Cin6);

Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
If Not Win_Init(30,180,376,322+HaF1,$51D9,Language.Loc(647)+Cin1,W1) Then Exit;
Win_Sup(100,50,347,218,59,50,400,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Sys.SetGrid:=My_Grid;                          {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TBB[Pos].X1; Y:=TBB[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Mse_GetPosInGrid(X,Y);
TBB[Pos].X1:=X; TBB[Pos].Y1:=Y;
X:=TBB[Pos].X2; Y:=TBB[Pos].Y2;
Mse_GetPosInGrid(X,Y);
TBB[Pos].X2:=X; TBB[Pos].Y2:=Y;
End;
Sys.SetGrid:=No;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TBB[Pos].X1,Cin1); Str(TBB[Pos].Y1,Cin2);{*Init Values*}
Str(TBB[Pos].X2,Cin3); Str(TBB[Pos].Y2,Cin4);
Str(TBB[Pos].Style,Cin5); Str(TBB[Pos].Co,Cin6);
Rad1.Status:=TBB[Pos].Fill;             {*Init Radios*}
Rad2.Status:=TBB[Pos].Cave;

V1:=TBB[Pos].Co; V2:=TBB[Pos].Style;    {*Couleur/Pattern Gadget*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=False; Cancel:=No;           {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If Button_GetMsg(But0,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V1,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V1,Cin6); REDRAW_FRAME;
      End;
   If Button_GetMsg(But3,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V2,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(648));
      Str(V2,Cin5); REDRAW_FRAME;
      End;

   InputText_GetMsg(Co1,Cin1); InputText_GetMsg(Co2,Cin2);
   InputText_GetMsg(Co3,Cin3); InputText_GetMsg(Co4,Cin4);
   RadioBox_GetMsg(Rad1,1); RadioBox_GetMsg(Rad2,1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Suprime Fentre*}

If Cancel=No Then Begin
   Val(Cin1,TBB[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TBB[Pos].Y1,Code);
   Val(Cin3,TBB[Pos].X2,Code);
   Val(Cin4,TBB[Pos].Y2,Code);
   TBB[Pos].Style:=V2;
   TBB[Pos].Co:=V1;
   TBB[Pos].Fill:=Rad1.Status;
   TBB[Pos].Cave:=Rad2.Status;
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_BEVEL_BOX:=True;
   End Else DEFINE_BEVEL_BOX:=False;

End;

{ͻ
                        PROCEDURE DEFINE_STRING_BOX                         
 ͼ}

Function DEFINE_STRING_BOX(M:TMenu; Pos:Byte):Boolean;
Var W1          :TWindow;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But0,But1,But2,But3:TButton;           {*Bouton Classique*}
    Co1,Co2,Co3,Co4,Co5,Co6:TInputText;     {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6:String;              {*String Rcupre*}
    Rad1        :TRadioBox;                   {*Pour Radio Evidement*}
    Code        :Integer;
    Cancel      :Boolean;               {*Annulation Modifs*}
    X,Y         :Word;                  {*For Sys.SetGrid Parameters*}
    V1,V2       :Integer;               {*Couleur TC/BGC*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);
Bevel (125,20,325,90, CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Button(LaF*12, 122,LaF*16,-1, CLTextButton,CLBgButton,$100,But0,'_OK');
Button(LaF*42, 122,LaF*16,-1, CLTextButton,CLBgButton,$0,But1,Language.Loc(13));
Button(139, 30,115,-1, CLLightBlue,CLBlue,$0,But3,Language.Loc(643));
Button(139, 50,115,-1, CLLightBlue,CLBlue,$0,But2,Language.Loc(601));

Display(80, 16, CLText,Language.Loc(644));
Display(22, 35, CLText,Language.Loc(604));
Display(22, 55, CLText,Language.Loc(605));
Display(22, 75, CLText,Language.Loc(627));
Display(22, 95, CLText,Language.Loc(628));
RadioBox(270,70,1,$00,0,9,Rad1.Status,Rad1,Language.Loc(646));

InputText(75, 34,30,3, CLSky,CLSalmon,1,$127,Co1,Cin1);
InputText(75, 54,30,3, CLSky,CLSalmon,1,$126,Co2,Cin2);
InputText(75, 74,30,3, CLSky,CLSalmon,1,$126,Co3,Cin3);
InputText(75, 94,30,3, CLSky,CLSalmon,1,$126,Co4,Cin4);
InputText(270,30,30,3, CLSky,CLSalmon,1,$166,Co5,Cin5);
InputText(270,50,30,3, V1,CLSalmon,1,$166,Co6,Cin6);

Win_Clip(No,W1);
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
If Not Win_Init(30,180,376,322+HaF1,$51D9,Language.Loc(649)+Cin1,W1) Then Exit;
Win_Sup(100,50,347,218,59,50,400,250,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                        {*Affiche la Fentre*}

Sys.SetGrid:=My_Grid;                          {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TSB[Pos].X1; Y:=TSB[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Mse_GetPosInGrid(X,Y);
TSB[Pos].X1:=X; TSB[Pos].Y1:=Y;
X:=TSB[Pos].X2; Y:=TSB[Pos].Y2;
Mse_GetPosInGrid(X,Y);
TSB[Pos].X2:=X; TSB[Pos].Y2:=Y;
End;
Sys.SetGrid:=No;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TSB[Pos].X1,Cin1); Str(TSB[Pos].Y1,Cin2);{*Init Values*}
Str(TSB[Pos].X2,Cin3); Str(TSB[Pos].Y2,Cin4);
Str(TSB[Pos].Style,Cin5); Str(TSB[Pos].Co,Cin6);
Rad1.Status:=TSB[Pos].Cave;             {*Init Radios*}

V1:=TSB[Pos].Co; V2:=TSB[Pos].Style;    {*Couleur/Pattern Gadget*}

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flag de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If Button_GetMsg(But0,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But1,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But2,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V1,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V1,Cin6); REDRAW_FRAME;
      End;
   If Button_GetMsg(But3,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V2,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(648));
      Str(V2,Cin5); REDRAW_FRAME;
      End;

   InputText_GetMsg(Co1,Cin1); InputText_GetMsg(Co2,Cin2);
   InputText_GetMsg(Co3,Cin3); InputText_GetMsg(Co4,Cin4);
   RadioBox_GetMsg(Rad1,1);
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Suprime Fentre*}

If Cancel=No Then Begin
   Val(Cin1,TSB[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TSB[Pos].Y1,Code);
   Val(Cin3,TSB[Pos].X2,Code);
   Val(Cin4,TSB[Pos].Y2,Code);
   TSB[Pos].Style:=V2;
   TSB[Pos].Co:=V1;
   TSB[Pos].Cave:=Rad1.Status;
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_STRING_BOX:=True;
   End Else DEFINE_STRING_BOX:=False;

End;

{ͻ
                          PROCEDURE DEFINE_TEXT                             
 ͼ}

Function DEFINE_TEXT(M:TMenu; Pos:Byte):Boolean;
Var W1          :TWindow;                   {*Structure Fentre*}
    Even        :Byte;                  {*Rception Evenements Fentre*}
    Exit_Flg    :Boolean;               {*Flag de Sortie*}
    But1,But2,
    But3,But4,But5:TButton;                {*Bouton Classique*}
    Com1,Com2,Com3,
    Com4,Com5,Com6,Com7:TInputText;         {*Structure Bevels Boxes*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6,Cin7:String;         {*String Rcupre*}
    Rad1        :TRadioBox;
    Code        :Integer;
    Cancel      :Boolean;               {*Cancel Modifications*}
    X,Y         :Word;                  {*For Sys.SetGrid Parameters*}
    V1,V2       :Integer;               {*Couleurs TC/BGC*}
    FontT       :String;
    FontS       :Longint;               {*Gestion Requester de Fontes*}

{************************* AFFICHE CONTENU FENETRE **************************}

Procedure REDRAW_COMMANDS;              {*Dfinition Commands*}
Begin
Win_Clip(Yes,W1);                       {*Clipping de la Fentre*}
InputText(LaF*14, HaF*4+2, LaF*6,4, CLSky,CLSalmon,1,$126,Com1,Cin1);
InputText(LaF*14, HaF*6+2, LaF*6,4, CLSky,CLSalmon,1,$126,Com2,Cin2);
InputText(LaF*14, HaF*8+2, LaF*6,4, CLSalmon,CLSalmon,1,$166,Com3,Cin3);
InputText(LaF*54, HaF*3+1, LaF*6,3, V1,CLSalmon,1,$166,Com5,Cin5);
InputText(LaF*54, HaF*5+1, LaF*6,3, V2,CLSalmon,1,$166,Com6,Cin6);
InputText(LaF*54, HaF*7+1, LaF*6,5, CLSky,CLSalmon,1,$166,Com7,Cin7);
Win_Clip(No,W1);                        {*Restore le Clipping Normal*}
End;

Procedure REDRAW_FRAME;                 {*Dfinition Contenu Fentre*}
Begin
Win_Clip(Yes,W1);                       {*Clipping de la Fentre*}
Bevel  ( LaF*22+0, HaF*2+1, LaF*63+0, HaF*11+6, CLMauve,BLLoweredLine,BLRaisedLine,Yes);
Display( LaF*8, HaF*1+7, CLText,Language.Loc(650));
Display( LaF*4, HaF*4+2, CLText,Language.Loc(604));
Display( LaF*4, HaF*6+2, CLText,Language.Loc(605));
Display( LaF*4, HaF*8+2, CLText,Language.Loc(644));
Display( LaF*4, HaF*12+8,CLText,Language.Loc(642));
RadioBox( LaF*54, HaF*9+3, 1,$00,0,10,Rad1.Status,Rad1,Language.Loc(617));

Button( LaF*26, HaF*3+1, LaF*24,-1, CLLightBlue,CLBlue,$0,But1,Language.Loc(601));
Button( LaF*26, HaF*5+1, LaF*24,-1, CLLightBlue,CLBlue,$0,But2,Language.Loc(602));
Button( LaF*26, HaF*7+1, LaF*24,-1, CLLightBlue,CLBlue,$0,But3,Language.Loc(719));
Button( LaF*10, HaF*15+6,LaF*16,-1, CLTextButton,CLBgButton,$100,But4,'_OK');
Button( LaF*40, HaF*15+6,LaF*16,-1, CLTextButton,CLBgButton,$0,But5,Language.Loc(13));

InputText(LaF*11, HaF*12+7,LaF*52,255, CLSky,CLSalmon,1,$27,Com4,Cin4);
Win_Clip(No,W1);                        {*Restore le Clipping Normal*}

REDRAW_COMMANDS;                        {*Raffiche les Commands*}
End;

{****************************** MAIN PROCEDURE ******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
If Not Win_Init(30,180,30+LaF*67,180+HaF1+HaF*17+6,$51D9,Language.Loc(651)+Cin1,W1) Then Exit;
Win_Sup(100,50,250,200,59,50,639,479,0,CLWinBorder,$0A10,W1);{*Supplment*}
Win_Draw(W1);                           {*Affiche la Fentre*}

Sys.SetGrid:=My_Grid;                   {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=TXT[Pos].X1; Y:=TXT[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Mse_GetPosInGrid(X,Y);
TXT[Pos].X1:=X; TXT[Pos].Y1:=Y;
End;
Sys.SetGrid:=No;                        {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(TXT[Pos].X1,Cin1); Str(TXT[Pos].Y1,Cin2);{*Init Values*}
Cin4:=TXT[Pos].Cin; Str(VESA_TextWidth(Cin4),Cin3);
Str(TXT[Pos].CB,Cin5); Str(TXT[Pos].CP,Cin6);
Cin7:='ABC1';
FontT:=Sys.FontMain; FontS:=Sys.FontMainSize; {*Dfinition Fonte*}

V1:=TXT[Pos].CB; V2:=TXT[Pos].CP;       {*Couleurs Gadgets*}
If TXT[Pos].CB=-1 Then Rad1.Status:=Yes
                  Else Rad1.Status:=No;

REDRAW_FRAME;                           {*Affiche le Contenu de la Fentre*}
Exit_Flg:=No; Cancel:=No;             {*Flags de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Teste si Fentre Prte*}
   Begin
   If Button_GetMsg(But4,1)=CMSelected Then Exit_Flg:=True;
   If Button_GetMsg(But5,1)=CMSelected Then Cancel:=True;
   If Button_GetMsg(But3,1)=CMSelected Then
      Req_Font(80,100,Language.Loc(518),FontT,FontS);
   If Button_GetMsg(But1,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V1,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V1,Cin5); REDRAW_COMMANDS;    {*Raffiche les Commands*}
      End;
   If Button_GetMsg(But2,1)=CMSelected Then Begin
      Req_SelectColor(080,100,V2,CLBlack,CLBlack,Sys.GetPath(SP_PALETTES)+'PALETTE.PAL',Language.Loc(518));
      Str(V2,Cin6); REDRAW_COMMANDS;    {*Raffiche les Commands*}
      End;
   InputText_GetMsg(Com1,Cin1); InputText_GetMsg(Com2,Cin2);
   If RadioBox_GetMsg(Rad1,1)<>CMNone Then
      Begin
      Cin5:='-1'; REDRAW_COMMANDS;      {*Raffiche les Commands*}
      End;
   If InputText_GetMsg(Com4,Cin4)=CMModified Then Begin
      Str(VESA_TextWidth(Cin4),Cin3);
      InputText(W1.X1+LaF*14, W1.Y1+HaF1+HaF*8+2, LaF*6,255,13,13,1,$26+$40,Com3,Cin3);
      End;
   End;

Even:=Win_Test(W1);
If Even=CMClosed Then Cancel:=True;            {*Fentre Ferme => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Fentre Dplace => Rafficher Contenu*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg=Yes) Or (Cancel=Yes);     {*Flag de Sortie*}

Win_Done(W1);                        {*Suprime Fentre*}
If Not Cancel Then Begin
   Val(Cin1,TXT[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,TXT[Pos].Y1,Code);
   TXT[Pos].Cin:=Cin4;
   Val(Cin5,TXT[Pos].CB,Code);
   Val(Cin6,TXT[Pos].CP,Code);
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_TEXT:=True;
   End
   Else DEFINE_TEXT:=False;
End;

{ͻ
                           PROCEDURE DEFINE_IMAGE                           
 ͼ}

Function DEFINE_IMAGE(M:TMenu; Pos:Byte):Boolean;
Var W1            :TWindow;                 {*Window Structure*}
    Even          :Byte;                {*Get Windows Evens*}
    Exit_Flg      :Boolean;             {*Exit Flag*}
    Cancel        :Boolean;             {*Cancel Modifications*}
    But1,But2,But3,But4:TButton;           {*Buttons Structure*}
    Com1,Com2,Com3,
    Com4,Com5,Com6,
    Com7          :TInputText;              {*Commands Structure*}
    Rad1,Rad2     :TRadioBox;                 {*Radios Structure*}
    Cin1,Cin2,Cin3,
    Cin4,Cin5,Cin6,
    Cin7          :String;              {*Strings for Commands*}
    DirSel,FilSel :String;              {*Manage Directories*}
    Size          :Longint;
    Code          :Word;
    X,Y           :Word;                {*For Sys.SetGrid Parameters*}
    FD            :DirStr;              {*FSplit...*}
    FN            :NameStr;
    FE            :ExtStr;
    Px,Py,Sx,Sy   :Integer;             {*BMP Displaying Calculs...*}
    Vx1,Vy1,Vx2,Vy2:Integer;
    NSx,NSy       :Word;
    Co            :Longint;
    Mask          :String;              {*Mask*}
    Ox,Oy         :Integer;             {*Offsets X,Y*}

{****************************** TAKE INFOS BMP ******************************}

Procedure SET_INFOS_IMG;
Begin
If Test_Icon(Cin7) Then                 {*Icon*}
   Begin
   IMG[Pos].IType:=0;
   Sx:=31; Sy:=31;
   Str(IMG[Pos].X1+Sx,Cin3);
   Str(IMG[Pos].Y1+Sy,Cin4);
   End
   Else Begin                           {*BMP*}
   BMP_GetInfo(Cin7,NSx,NSy,Co);
   IMG[Pos].IType:=1;
   Str(IMG[Pos].X1+NSx,Cin3);           {*Save Max Size of Image...*}
   Str(IMG[Pos].Y1+NSy,Cin4);
   If NSx>LaF*36-4 Then NSx:=LaF*36-4;
   If NSy>HaF*12+3 Then NSy:=HaF*12+3;
   Sx:=NSx; Sy:=NSy;
   End;
End;

{******************************* DISPLAY IMAGE ******************************}

Procedure REDRAW_SIMAGE;                {*Affiche Image*}
Begin
Px:=LaF*42+2; Py:=HaF*3+2;
Val(Cin1,Vx1,Code); Val(Cin2,Vy1,Code); {*Size X et Y*}
Val(Cin3,Vx2,Code); Val(Cin4,Vy2,Code);
Val(Cin5,Ox,Code);  Val(Cin6,Oy,Code);
Sx:=Vx2-Vx1; Sy:=Vy2-Vy1;

Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*42, HaF*3+1, LaF*78, HaF*15+6, CLLightGrey,BLLoweredLine,BLRaisedLine,Yes);
If Test_Icon(Cin7) Then Begin Show_Icon(Px+LaF*15,Py+HaF*5, Cin7); IMG[Pos].IType:=0; End;
If BMP_TestFile (Cin7) Then Begin
   If Sx>LaF*36-4 Then Sx:=LaF*36-4;
   If Sy>HaF*12+3 Then Sy:=HaF*12+3;
   If Sys.GfxMode>=10 Then BMP_Show (Px, Py, Px+Sx, Py+Sy, Ox,Oy, Cin7,$80);
   IMG[Pos].IType:=1;
   End;
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

{************************** DISPLAY InputText FNAME ***************************}

Procedure REDRAW_COMMAND_FNAME;         {*Define CoInputTextName*}
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
InputText( LaF*28, HaF*16+6,LaF*50,255, CLLightBlue,CLWhite,1,$0027,Com7,Cin7);
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

{***************************** DISPLAY COMMANDS *****************************}

Procedure REDRAW_COMMANDS;              {*Define Commands*}
Var Id:Word;
Begin
Cin7:=DirSel+FilSel;

REDRAW_SIMAGE;                          {*Affiche Image*}

If Rad2.Status Then Id:=$326 Else Id:=$126;
Win_Clip(Yes,W1);                     {*Clipping Window*}
InputText( LaF*24, HaF*6+7,LaF*6,4, CLSky,CLLightBlue,1,Id,Com3,Cin3);
InputText( LaF*24, HaF*8+7,LaF*6,4, CLSky,CLLightBlue,1,Id,Com4,Cin4);
Win_Clip(No,W1);                    {*Restore Normal Clipping*}
End;

{************************* DISPLAY WINDOW CONTENT ***************************}

Procedure REDRAW_FRAME;                 {*Define Window Content*}
Var Id:Byte;
Begin
Win_Clip(Yes,W1);                     {*Clipping Window*}
Bevel (LaF*4,  HaF*3+1, LaF*40, HaF*15+6,CLMauve,  BLLoweredLine,BLRaisedLine,Yes);
Bevel (LaF*10, HaF*2+1, LaF*34, HaF*3+6, CLFlamand,BLLoweredLine,BLRaisedLine,Yes);
Display( LaF*15,HaF*4+7, CLText, Language.Loc(549));
Display( LaF*6, HaF*6+7, CLText, Language.Loc(604));
Display( LaF*6, HaF*8+7, CLText, Language.Loc(605));
Display( LaF*16,HaF*2+3, CLWhite,Language.Loc(694));

RadioBox( LaF*34+1, HaF*11,1,$10,1,1,Rad1.Status,Rad1,Language.Loc(550));
RadioBox( LaF*34+1, HaF*13,1,$10,1,1,Rad2.Status,Rad2,Language.Loc(551));
Button( LaF*19+1,HaF*19+6, LaF*16,-1, CLTextButton,CLBgButton,$100,But1,'_OK');
Button( LaF*46+2,HaF*19+6, LaF*16,-1, CLTextButton,CLBgButton,$00,But2,Language.Loc(13));
Button( LaF*4,   HaF*16+6, LaF*22,-1, CLTextButton,CLBgButton,$00,But3,Language.Loc(895));

If IMG[Pos].IType=0 Then Id:=$16 Else Id:=$14; {*Icon=Freezed Button*}
Button( LaF*42, HaF*3+1, LaF*36, HaF*12+5, CLTextButton,CLBgButton,Id,But4,'');

InputText( LaF*16, HaF*6+7,LaF*6,4, CLSky,CLLightBlue,1,$0126,Com1,Cin1);
InputText( LaF*16, HaF*8+7,LaF*6,4, CLSky,CLLightBlue,1,$0126,Com2,Cin2);
InputText( LaF*32, HaF*6+7,LaF*6,4, CLBlue,CLLightBlue,1,$0126,Com5,Cin5);
InputText( LaF*32, HaF*8+7,LaF*6,4, CLBlue,CLLightBlue,1,$0126,Com6,Cin6);
Win_Clip(No,W1);                    {*Restore Normal Clipping*}

REDRAW_COMMANDS;                        {*Define Windows Commands*}
REDRAW_COMMAND_FNAME;                   {*Define CoInputTextName*}
End;

{***************************** MAIN PROCEDURE *******************************}

Begin
Str(Pos,Cin1);                          {*For Item Number*}
If Not Win_Init(30,180,30+LaF*82,180+HaF1+HaF*21+6,$51D9,Language.Loc(827)+Cin1,W1) Then Exit;
Win_Sup(100,50,250,200,79,60,639,479,0,CLWinBorder,$0A10,W1);{*Supplement*}
Win_Draw(W1);                        {*Display Window*}

Sys.SetGrid:=My_Grid;                          {*Grille Si elle Existe*}
If Menu_TestCheck(M,2,2)=True Then Begin{*Adjust Position if Pref is Set*}
X:=IMG[Pos].X1; Y:=IMG[Pos].Y1;         {*Calcul New Coordonnes With Steps*}
Mse_GetPosInGrid(X,Y);
IMG[Pos].X1:=X; IMG[Pos].Y1:=Y;
End;
Sys.SetGrid:=No;                              {*Plus de Grille Gnrale*}
Gad_Exist:=True;                        {*Gadgets Existent*}

Str(IMG[Pos].X1,Cin1); Str(IMG[Pos].Y1,Cin2);{*Init Values*}
Str(IMG[Pos].X2,Cin3); Str(IMG[Pos].Y2,Cin4);
Str(IMG[Pos].Ox,Cin5); Str(IMG[Pos].Oy,Cin6);
FSplit(IMG[Pos].FName, FD,FN,FE);
Rad1.Status:=IMG[Pos].Use_Pal;
Rad2.Status:=IMG[Pos].Use_MSize;
DirSel:=FD; FilSel:=FN+FE; Cin7:=DirSel+FilSel;

If Rad2.Status Then SET_INFOS_IMG;      {*Max Size Image*}

REDRAW_FRAME;                           {*Display Window Content*}
Exit_Flg:=No; Cancel:=No;             {*Flags de Sortie*}

Repeat
try
;
If Win_Ready(W1) Then                {*Test if Window Ready*}
   Begin                                {*Test Personnals Gadgets*}
   Win_Clip(Yes,W1);                  {*Clipping Window*}
   If Button_GetMsg(But1,1)=CMSelected Then Exit_Flg:=Yes;
   If Button_GetMsg(But2,1)=CMSelected Then Cancel:=Yes;
   If Button_GetMsg(But4,1)=CMSelected Then Req_DisplayWinBMP(W1.X1+50,W1.Y1-120,Cin7);
   If Button_GetMsg(But3,1)=CMSelected Then Begin
      If IMG[Pos].IType=0 Then Mask:='*.ICO|*.BMP' Else Mask:='*.BMP|*.ICO';
      Req_FileManager(120,110,275,Language.Loc(894),'_OK',Mask,0,DirSel,FilSel,Size);
      If FilSel<>'' Then Cin7:=DirSel+FilSel
         Else Begin DirSel:=''; FilSel:=Cin7; End;
      SET_INFOS_IMG;                    {*Set Infos IMG in Variables*}
      REDRAW_COMMANDS;
      End;

   RadioBox_GetMsg(Rad1,1);
   If RadioBox_GetMsg(Rad2,1)<>CMNone Then If Rad2.Status Then
      Begin                             {*Max Size for Image...*}
      SET_INFOS_IMG;
      REDRAW_COMMANDS;
      End Else REDRAW_COMMANDS;

   InputText_GetMsg(Com1,Cin1);
   InputText_GetMsg(Com2,Cin2);
   If InputText_GetMsg(Com3,Cin3)=CMModified Then REDRAW_SIMAGE; {*Raffiche Image*}
   If InputText_GetMsg(Com4,Cin4)=CMModified Then REDRAW_SIMAGE;
   If InputText_GetMsg(Com5,Cin5)=CMModified Then REDRAW_SIMAGE;
   If InputText_GetMsg(Com6,Cin6)=CMModified Then REDRAW_SIMAGE;
   InputText_GetMsg(Com7,Cin7);
   Win_Clip(No,W1);                 {*Restore Normal Clipping*}
   End;

Even:=Win_Test(W1);                {*Get Windows Evens*}
If Even=CMClosed Then Cancel:=Yes;             {*Window Closed   => Exit*}
If Even=CMMoved Then REDRAW_FRAME;            {*Window Moved    => Display Content*}
except
  on e:Exception do HandleException(e);
end;
Until (Exit_Flg) Or (Cancel);           {*Flag de Sortie*}
Win_Done(W1);                        {*Close Window if Needs*}

If Not Cancel Then Begin
   Val(Cin1,IMG[Pos].X1,Code);          {*Transmet Values*}
   Val(Cin2,IMG[Pos].Y1,Code);
   Val(Cin3,IMG[Pos].X2,Code);
   Val(Cin4,IMG[Pos].Y2,Code);
   Val(Cin5,IMG[Pos].Ox,Code);
   Val(Cin6,IMG[Pos].Oy,Code);
   IMG[Pos].FName:=Cin7;
   IMG[Pos].Use_Pal:=Rad1.Status;
   IMG[Pos].Use_MSize:=Rad2.Status;
   BSET(Has_Changed,Num_Pro);           {*Une Modification a t Faite*}
   DEFINE_IMAGE:=True;
   End
   Else DEFINE_IMAGE:=False;
End;

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

{ͻ
                                GERE_ITEMS                                  
 ͹
  IN.......: I (BYTE) = Numro (1  8) Correspondant au type de Gadget.     
 ͼ}

Procedure GERE_ITEMS(Var M:TMenu; I:Byte);
Var //Ac,Sc:Byte;
    NUM,A:Integer;
    Lb:TLightBox;                                {*Pour Move Light Box*}
    OffX,OffY:Integer;                           {*Dcalage for Sliders Buttons*}
    Ga,Mi,Dr:Boolean;                            {*Param Souris*}
    Xm,Ym:Word;                                  {*Position actuelle souris*}
    Exit_Box:Boolean;                            {*Sortie du GetMsg_MoveBox*}
    Vx1,Vy1,Vx2,Vy2:Integer;                     {*Value pour Mse_TestBox et Light Box*}
    CreaItem:Boolean;                            {*Cration ou Cancel Item*}
    Max_VAL:Byte;                                {*Se dbrouiller pour virer ca !*}
    Ok         :Boolean;                         {*Coord Box "Select by Mouse"*}
    I2,I3      :Integer;                         {*Counter Type Item*}

{*********************** CALCULE COORDONNEES SELON ITEM *********************}

Procedure CALC_COORD;                            {*Mode ou Type...*}
Begin
Case NType of
   1: With TBU[Pos_ITM[1]] do Begin              {*Button*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X1+Sx;
      Vy2:=Y1+Sy;
      End;
   2: With TCY[Pos_ITM[2]] do Begin              {*Cycler*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X1+Sx+18;
      Vy2:=Y1+Sy;
      End;
   3: With TRB[Pos_ITM[3]] do Begin              {*Radio Box*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X1+19;
      Vy2:=Y1+4+HaF;
      End;
   4: With TSL[Pos_ITM[4]] do Begin              {*Slider Item*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X2+OffX;
      Vy2:=Y2+OffY;
      End;
   5: With TCO[Pos_ITM[5]] do Begin              {*InputText*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X1+T.Siz;
      Vy2:=Y1+4+HaF;
      End;
   6: With TBB[Pos_ITM[6]] do Begin              {*Bevel Item*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X2;
      Vy2:=Y2;
      End;
   7: With TSB[Pos_ITM[7]] do Begin              {*String Box Item*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X2;
      Vy2:=Y2;
      End;
   8: With TXT[Pos_ITM[8]] do Begin              {*Text Item*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X1+2+VESA_TextWidth(Cin);
      Vy2:=Y1+2+HaF;
      End;
   9: With IMG[Pos_ITM[9]] do Begin              {*Icon Item*}
      Vx1:=X1;
      Vy1:=Y1;
      Vx2:=X2;
      Vy2:=Y2;
      End;
   End;
End;

{************************ CODE DE D'EDITION D'UN ITEM ***********************}

Procedure EDIT_ITEM(Var M:TMenu);
Begin
CREATE_UNDO(M);                            {*Cr un Fichier UNDO*}
TOGGLE_ITEM(NType);                        {*Entoure  Nouveau Item*}
Case NType of
   1: DEFINE_BUTTONS(M,Pos_ITM[1]);        {*Demande Modification Paramtres*}
   2: DEFINE_CYCLERS(M,Pos_ITM[2]);
   3: DEFINE_RADIOS (M,Pos_ITM[3]);
   4: DEFINE_SLIDERS(M,Pos_ITM[4]);
   5: DEFINE_COMMANDS(M,Pos_ITM[5]);
   6: DEFINE_BEVEL_BOX(M,Pos_ITM[6]);
   7: DEFINE_STRING_BOX(M,Pos_ITM[7]);
   8: DEFINE_TEXT(M,Pos_ITM[8]);
   9: DEFINE_IMAGE(M,Pos_ITM[9]);
   End;
REDRAW_WINDOW(M);                          {*Raffiche All Gadgets in Window*}
TOGGLE_ITEM(NType);                        {*Entoure  Nouveau Item*}
End;

{*********************** CODE DE SUPPRESSION D'UN ITEM **********************}

Procedure DEL_ITEM(Var M:TMenu);
Var A,B:Integer;
Begin
For A:=Pos_ITM[NType]+1 to Qtt_ITM[NType] do Begin
   B:=A-1;
   Case NType of                        {*Transfre Structure*}
      1: TBU[B]:=TBU[A];
      2: TCY[B]:=TCY[A];
      3: TRB[B]:=TRB[A];
      4: TSL[B]:=TSL[A];
      5: TCO[B]:=TCO[A];
      6: TBB[B]:=TBB[A];
      7: TSB[B]:=TSB[A];
      8: TXT[B]:=TXT[A];
      9: IMG[B]:=IMG[A];
      End;
   End;

Dec(Qtt_ITM[NType]);                    {*Dcrmente Compteurs*}
Dec(Pos_ITM[NType]);
If (Qtt_ITM[NType]>0) And (Pos_ITM[NType]<1) Then Pos_ITM[NType]:=1;
REDRAW_WINDOW(M);                       {*Raffiche All Gadgets in Window*}
TOGGLE_ITEM(NType);                     {*Entoure  Nouveau Item*}
End;

{********************************* MAIN CODE ********************************}

Begin
If{ (Kbd_GetChar(Ac,Sc)=True) And }(Qtt_ITM[NType]>0) Then {*Rotate Selected Gadget*}
   Begin
   If Kbd_GetKeyDown(VK_DOWN) or Kbd_GetKeyDown(VK_RIGHT) or Kbd_GetKeyDown(VK_ADD) {*Touche '+' = Bas/Droite*}
   Then Begin
   If Pos_ITM[NType]<>0 Then TOGGLE_ITEM(NType); {*Desentoure l'Item*}
   Inc(Pos_ITM[NType]);                          {*Next Item vers le Haut*}
   If Pos_ITM[NType]>Qtt_ITM[NType] Then Pos_ITM[NType]:=1;  {*Last Item Atteint => ROT*}
   TOGGLE_ITEM(NType);                           {*Entoure  Nouveau Item*}
   TIC;                                          {*Petit Bip !*}
   End;

   If Kbd_GetKeyDown(VK_UP) or Kbd_GetKeyDown(VK_LEFT) or Kbd_GetKeyDown(VK_SUBTRACT) {*Touche '-' = Haut/Gauche*}
   Then Begin
   If Pos_ITM[NType]<>0 Then TOGGLE_ITEM(NType); {*Desentoure l'Item*}
   Dec(Pos_ITM[NType]);                          {*Next Item vers le Bas*}
   If Pos_ITM[NType]<1 Then Pos_ITM[NType]:=Qtt_ITM[NType];  {*Last Item Atteint => ROT*}
   TOGGLE_ITEM(NType);                           {*Entoure  Nouveau Item*}
   TIC;                                          {*Petit Bip !*}
   End;

{gotoxy(1,2); writeln(Ac,'    ');
gotoxy(1,3); writeln(Ntype,' ',NPos,'     ');}

   If (Kbd_GetKeyDown(VK_RETURN)) And (NType>0) And (NPos>0) Then    {*Touche ENTER Presse*}
      EDIT_ITEM(M);                              {*Edition de l'item Correspondant*}

   If (Kbd_GetKeyDown(VK_DELETE)) And (NType>0) And (NPos>0) Then    {*Delete Item - Touche Suppr*}
      Begin
      Num:=3;                                    {*Icne Question*}
      If Conf_Del Then Req_Dialog(Language.Loc(461),Language.Loc(613),Language.Loc(614),NUM)
          Else Num:=1;                           {*Pas de Confirmation*}
      If NUM=1 Then Begin                        {*Go to Delete*}
         TOGGLE_ITEM(I);                         {*Entoure  Nouveau Item*}
         DEL_ITEM(M);                            {*Delete Item*}
         BSET(Has_Changed,Num_Pro);              {*Une Modification a t Faite*}
         End;
      End;
   End;

If I=4 Then                                      {==== Spcial Slider ====}
   Begin
   OffX:=0; OffY:=0;                             {*Init Offsets to 0 de Base*}
(*   If TSL[Pos_ITM[4]].S.GDep=Yes Then             {*Size+40 car Size des Boutons Move*}
      If TSL[Pos_ITM[4]].S.Typ=0 Then OffX:=41 Else OffY:=30;*)
   End;

                           { MOVE ITEM }
If (Pos_ITM[I]>0) And
   (Kbd_GetKeyDown(VK_SHIFT)) Then               {*SHIFT to Actionner*}
   Begin
   CALC_COORD;
   Lb.X1:=Vx1+W.X1;                              {*Add Coordonnes Window Project*}
   Lb.Y1:=Vy1+W.Y1;
   Lb.X2:=Vx2+W.X1;
   Lb.Y2:=Vy2+W.Y1;

   Sys.SetGrid:=My_Grid;                                {*Grille Si elle Existe*}
      Repeat
      Exit_Box:=False;
      If MoveBox_GetMsg(Lb,1)=CMMoved Then Begin {*Move Box*}
         TOGGLE_ITEM(NType);                     {*Entoure  Nouveau Item*}
         CREATE_UNDO(M);                         {*Cr un Fichier UNDO*}
         A:=Pos_ITM[NType];                      {*Optimisations*}
         Case NType of                           {*Modif Parameters*}
            1: With TBU[A] do Begin
               X1:=Lb.X1-W.X1;                   {*Button*}
               Y1:=Lb.Y1-W.Y1;
{               SX:=Lb.X2-W.X1-X1;    Useless ?
               SY:=Lb.Y2-W.Y1-Y1;}
               End;
            2: With TCY[A] do Begin              {*Cycler*}
               X1:=Lb.X1-W.X1;
               Y1:=Lb.Y1-W.Y1;
{               SX:=Lb.X2-W.X1-X1-18; Useless ?
               SY:=Lb.Y2-W.Y1-Y1;}
               End;
            3: Begin                             {*Radio Box*}
               TRB[A].X1:=Lb.X1-W.X1;
               TRB[A].Y1:=Lb.Y1-W.Y1;
               End;
            4: Begin                             {*Slider Item*}
               TSL[A].X1:=Lb.X1-W.X1;
               TSL[A].Y1:=Lb.Y1-W.Y1;
               TSL[A].X2:=Lb.X2-W.X1-OffX;
               TSL[A].Y2:=Lb.Y2-W.Y1-OffY;
               End;
            5: Begin                             {*InputText*}
               TCO[A].X1:=Lb.X1-W.X1;
               TCO[A].Y1:=Lb.Y1-W.Y1;
               TCO[A].T.Siz:=Lb.X2-W.X1-TCO[A].X1;
               End;
            6: Begin                             {*Bevel Item*}
               TBB[A].X1:=Lb.X1-W.X1;
               TBB[A].Y1:=Lb.Y1-W.Y1;
               TBB[A].X2:=Lb.X2-W.X1;
               TBB[A].Y2:=Lb.Y2-W.Y1;
               End;
            7: Begin                             {*String Box Item*}
               TSB[A].X1:=Lb.X1-W.X1;
               TSB[A].Y1:=Lb.Y1-W.Y1;
               TSB[A].X2:=Lb.X2-W.X1;
               TSB[A].Y2:=Lb.Y2-W.Y1;
               End;
            8: Begin                             {*Text Item*}
               TXT[A].X1:=Lb.X1-W.X1+4;
               TXT[A].Y1:=Lb.Y1-W.Y1+1;
               End;
            9: Begin                             {*Icon Item*}
               IMG[A].X1:=Lb.X1-W.X1;
               IMG[A].Y1:=Lb.Y1-W.Y1;
               IMG[A].X2:=Lb.X2-W.X1;
               IMG[A].Y2:=Lb.Y2-W.Y1;
               End;
            End;
         REDRAW_WINDOW(M);                       {*Raffiche All Gadgets in Window*}
         TOGGLE_ITEM(NType);                     {*Entoure  Nouveau Item*}
         Exit_Box:=True;
         End;
      Until (Exit_Box=True) Or (Sys.LightBoxActivated=False);
   Sys.SetGrid:=No;                                    {*Sucre Grille*}
   End;
                     { SELECT ITEM BY MOUSE }
Mse_Get(Xm,Ym,Ga,Mi,Dr);                         {*Rcupre Coord Souris*}
I2:=1;                                           {*Tous les 8 Types*}
Ok:=False;                                       {*De base pas Slectionn*}

If ((Xold<>Xm) Or (Yold<>Ym)) And (Sys.LightBoxActivated=False) Then
   Begin
   Repeat
      I3:=I2;
      Case I2 of
{T}      6: I3:=6;                               {*Patch TEXT &... Before Boxes*}
{B}      7: I3:=8;
{S}      8: I3:=9;
{I}      9: I3:=7;
         End;
      A:=Qtt_ITM[I3];                            {*Qtt d'items pour 1 Type*}
      While (Not Ok) And (A>=1) do               {*Fin dans 1 type d'Item*}
         Begin
         Case I3 of
            1: With TBU[A] do Begin              {*Button*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X1+Sx;
               Vy2:=Y1+Sy;
               End;
            2: With TCY[A] do Begin              {*Cycler*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X1+Sx+18;
               Vy2:=Y1+Sy;
               End;
            3: With TRB[A] do Begin              {*Radio Box*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X1+19;
               Vy2:=Y1+4+HaF;
               End;
            4: With TSL[A] do Begin              {*Slider Item*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X2;
               Vy2:=Y2;
               End;
            5: With TCO[A] do Begin              {*InputText*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X1+T.Siz;
               Vy2:=Y1+4+HaF;
               End;
            6: With TBB[A] do Begin              {*Bevel Item*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X2;
               Vy2:=Y2;
               End;
            7: With TSB[A] do Begin              {*String Box Item*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X2;
               Vy2:=Y2;
               End;
            8: With TXT[A] do Begin              {*Text Item*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X1+VESA_TextWidth(Cin)+2;
               Vy2:=Y1+2+HaF;
               End;
            9: With IMG[A] do Begin              {*Image Item*}
               Vx1:=X1;
               Vy1:=Y1;
               Vx2:=X2;
               Vy2:=Y2;
               End;
            End;

         Vx1:=Vx1+W.X1;                          {*Add Coordonnes Window Project*}
         Vy1:=Vy1+W.Y1;
         Vx2:=Vx2+W.X1;
         Vy2:=Vy2+W.Y1;

         If (Mse_TestBox(Vx1,Vy1,Vx2,Vy2,10)=True) Then
            Begin                                {*On est dans un Item*}
            NType:=I3;
            NPos:=A;
            Ok:=True;                            {*Item peut tre Slectionn*}
            End;
         Dec(A);                                 {*Next Item dans Type...*}
         End;                                    {*Fin dans 1 type d'Item*}

   Inc(I2);                                      {*Type d'Item Suivant...*}
   Until (Ok=True) Or (I2>Max_ITM);              {*Fin des Types d'Items*}

   If Not Kbd_GetKeyDown(VK_SHIFT) Then
      If Ok Then
        Begin
{/        Mse_SetPointerMode(P_UserMode);}
        Mse_SetPointer(MPHand)          {*Affiche une Main Devant Item*}
        End
      Else
        Begin
{/        Mse_SetPointerMode(P_AutoMode);}
        Mse_SetPointer(P_Current);
        End;

   If ((NPos<>OPos) Or (NType<>OType)) And (Ok) Then
      Begin
      TOGGLE_ITEM(OType);                        {*Dsentoure l'Item*}
      Pos_ITM[NType]:=NPos;
      TOGGLE_ITEM(NType);                        {*Entoure  Nouveau Item*}
      Xold:=Xm; Yold:=Ym; TIC;
      OPos:=NPos;                                {*Save Id Item Selected*}
      OType:=NType;
      End;
   End;                                          {*End Select Item by Mouse*}

If (Kbd_GetKeyDown(VK_SHIFT)) Then
  Begin
{/  Mse_SetPointerMode(P_UserMode);}
  Mse_SetPointer(MPMove);  {*Pointer Move*}
  End;
                 { EDIT ITEM BY DOUBLE CLICK }
CALC_COORD;                                      {*Calcule Coord for Item*}
Vx1:=Vx1+W.X1;
Vy1:=Vy1+W.Y1;                                   {*Add Coordonnes Window Project*}
Vx2:=Vx2+W.X1;
Vy2:=Vy2+W.Y1;

If (Mse_TestBox(Vx1,Vy1,Vx2,Vy2,10)=True) And (Mse_TestDoubleClick) Then
   EDIT_ITEM(M);                                 {*Edition de l'item Correspondant*}

                 { CREATE NEW ITEM }
Case I of                                        {*Get Qtt Max for Item...*}
   1: Max_VAL:=Max_TBU;
   2: Max_VAL:=Max_TCY;
   3: Max_VAL:=Max_TRB;
   4: Max_VAL:=Max_TSL;
   5: Max_VAL:=Max_TCO;
   6: Max_VAL:=Max_TBB;
   7: Max_VAL:=Max_TSB;
   8: Max_VAL:=Max_TXT;
   9: Max_VAL:=Max_IMG;
   End;
Sys.SetGrid:=My_Grid;                                   {*Utilise Grille si Existe*}
If (LightBox_GetMsg(Lb1,1,0)=CMModified) And
   (Lb1.X2-Lb1.X1<>0) Then                       {*Gestion GetMsg_LightBox*}
   If Qtt_ITM[I]=Max_VAL Then ERROR_01           {*Tableau is Full !!!*}
   Else Begin
   CREATE_UNDO(M);                               {*Crer un Fichier UNDO*}
   Inc(Qtt_ITM[I]);                              {*1 Item de plus*}
   TOGGLE_ITEM(I);                               {*Entoure  Nouveau Item*}
   Pos_ITM[I]:=Qtt_ITM[I];                       {*Edition du Dernier*}
   Vx1:=Lb1.X1-W.X1;                             {*Calcule True Coord Light Box*}
   Vy1:=Lb1.Y1-W.Y1;
   Vx2:=Lb1.X2-W.X1;
   Vy2:=Lb1.Y2-W.Y1;
   A:=Qtt_ITM[I];                                {*Optimisations*}
   Case I of
      1: Begin                                   {*Button*}
         TBU[A].X1:=Vx1;
         TBU[A].Y1:=Vy1;
         TBU[A].SX:=Lb1.X2-Lb1.X1;
         TBU[A].SY:=Lb1.Y2-Lb1.Y1;
         If (TBU[A].SY>=Syb-2) And (TBU[A].SY<=Syb+2) Then TBU[A].SY:=Syb; {*Boutons de Taille Standard*}
         End;
      2: Begin                                   {*Cycler*}
         TCY[A].X1:=Vx1;
         TCY[A].Y1:=Vy1;
         TCY[A].SX:=Lb1.X2-Lb1.X1-18;            {*Size Less 18 for Image "Cycle"*}
         End;
      3: Begin                                   {*Radio Box*}
         TRB[A].X1:=Vx1;
         TRB[A].Y1:=Vy1;
         End;
      4: With TSL[A] do Begin                    {*Slider Item*}
         X1:=Vx1;
         Y1:=Vy1;
         X2:=Vx2-1;
         Y2:=Vy2-1;
{         If Lb1.X2-Lb1.X1>Lb1.Y2-Lb1.Y1 Then S.Typ:=0
                                        Else S.Typ:=1;}
         End;
      5: Begin                                   {*InputText*}
         TCO[A].X1:=Vx1;
         TCO[A].Y1:=Vy1+1;
         TCO[A].T.Siz:=Lb1.X2-Lb1.X1;
         End;
      6: Begin                                   {*Bevel Item*}
         TBB[A].X1:=Vx1;
         TBB[A].Y1:=Vy1;
         TBB[A].X2:=Vx2;
         TBB[A].Y2:=Vy2;
         End;
      7: Begin                                   {*String Box Item*}
         TSB[A].X1:=Vx1+1;
         TSB[A].Y1:=Vy1+1;
         TSB[A].X2:=Vx2-1;
         TSB[A].Y2:=Vy2-1;
         End;
      8: Begin                                   {*Text Item*}
         TXT[A].X1:=Vx1;
         TXT[A].Y1:=Vy1+1;
         End;
      9: Begin                                   {*Icon Item*}
         IMG[A].X1:=Vx1;
         IMG[A].Y1:=Vy1;
         IMG[A].X2:=Vx2{Vx1+31};
         IMG[A].Y2:=Vy2{Vy1+31};
         End;
      End;
                {=== CLONE GADGETS ===}
   If (Menu_TestCheck(M,2,1)=True) And (Qtt_ITM[I]>1)
      Then Begin
      A:=Pos_ITM[I]-1;                           {*Optimisations*}
      Case I of
         1: With TBU[Pos_ITM[1]] do Begin        {*Button*}
               B.Font.BgColor:=TBU[A].B.Font.BgColor;
               B.Font.PenColor:=TBU[A].B.Font.PenColor;
               MoA:=TBU[A].MoA;
               B.Id:=TBU[A].B.Id;
{SR}{          B.TCT[1]:=TBU[A].B.TCT[1];}
               B.TCT:=Str_Put(B.TCT,Str_Get(TBU[A].B.TCT,1,'|'),1,'|');
               VanillaKey:=TBU[A].VanillaKey;
               End;
         2: With TCY[Pos_ITM[2]] do Begin        {*Cycler*}
               SY:=TCY[A].SY;
               B.B.Font.BgColor:=TCY[A].B.B.Font.BgColor;
               B.B.Font.PenColor:=TCY[A].B.B.Font.PenColor;
               MoA:=TCY[A].MoA;
               B.Id:=TCY[A].B.Id;
{               B.CyclVal:=TCY[A].B.CyclVal;}
               Cin:=TCY[A].Cin;
               End;
         3: With TRB[Pos_ITM[3]] do Begin        {*Radio Box*}
               R.Style:=TRB[A].R.Style;
               R.Status:=TRB[A].R.Status;
               R.IDCMP:=TRB[A].R.IDCMP;
               R.Cin:=TRB[A].R.Cin;
               R.PLab:=TRB[A].R.PLab;
               R.Group:=TRB[A].R.Group;
               MoA:=TRB[A].MoA;
               End;
         4: With TSL[Pos_ITM[4]] do Begin        {*Slider Item*}
               S.Quantity:=TSL[A].S.Quantity;
{               S.Aff:=TSL[A].S.Aff;}
               S.Value:=TSL[A].S.Value;
{               S.GDep:=TSL[A].S.GDep;}
               MoA:=TSL[A].MoA;
               End;
         5: With TCO[Pos_ITM[5]] do Begin        {*InputText*}
               T.Len:=TCO[A].T.Len;
               T.CoB:=TCO[A].T.CoB;
               T.Co2:=TCO[A].T.Co2;
               T.Sty:=TCO[A].T.Sty;
               T.Id:=TCO[A].T.Id;
               Cin:=TCO[A].Cin;
               End;
         6: With TBB[Pos_ITM[6]] do Begin        {*Bevel Item*}
               Style:=TBB[A].Style;
               Co:=TBB[A].Co;
               Fill:=TBB[A].Fill;
               Cave:=TBB[A].Cave;
               End;
         7: With TSB[Pos_ITM[7]] do Begin        {*String Box Item*}
               Style:=TSB[A].Style;
               Co:=TSB[A].Co;
               Cave:=TSB[A].Cave;
               End;
         8: With TXT[Pos_ITM[8]] do Begin        {*Text Item*}
               CB:=TXT[A].CB;
               CP:=TXT[A].CP;
               Cin:=TXT[A].Cin;
               End;
         9: With IMG[Pos_ITM[9]] do Begin        {*Icon Item*}
               Ox:=IMG[A].Ox;
               Oy:=IMG[A].Oy;
               IType:=IMG[A].IType;
               Use_MSize:=IMG[A].Use_MSize;
               Use_Pal:=IMG[A].Use_Pal;
               FName:=IMG[A].FName;
               End;
         End;
      End
   Else Begin   {=== DEFINITION DE BASE ===}
      Case I of
         1: With TBU[Qtt_ITM[1]] do Begin        {*Button*}
               B.Font.BgColor:=CLLightGrey;
               B.Font.PenColor:=CLBlack;
               B.Id:=$0;
{SR}{           B.TCT[1]:=Language.Loc(615);}
               B.TCT:=Str_Put(B.TCT,Language.Loc(615),1,'|');
               Action:=0;
               VanillaKey:=1;
               MoA:=1;
               End;
         2: With TCY[Qtt_ITM[2]] do Begin        {*Cycler*}
               SY:=HaF+4;
               B.B.Font.BgColor:=CLLightGrey;
               B.B.Font.PenColor:=CLBlack;
               B.Id:=$0;
{               B.CyclVal:=1;}
               Cin:='LABEL 1|LABEL 2';
               MoA:=1;
               End;
         3: With TRB[Pos_ITM[3]] do Begin        {*Radio Box*}
               R.Style:=1;
               R.Status:=Yes;
               R.IDCMP:=$10;
               R.Cin:='TEXT';
               R.PLab:=0;
               R.Group:=1;
               MoA:=1;
               End;
         4: With TSL[Pos_ITM[4]] do Begin        {*Slider Item*}
               S.Quantity:=100;
{               S.Aff:=10;}
               S.Value:=0;
{               S.GDep:=Yes;}
               MoA:=1;
               End;
         5: With TCO[Pos_ITM[5]] do Begin        {*InputText*}
               T.Len:=255;
               T.CoB:=CLSky;
               T.Co2:=CLLightBlue;
               T.Sty:=0;
               T.Id:=$26;
               Cin:=Language.Loc(642);
               End;
         6: With TBB[Pos_ITM[6]] do Begin        {*Bevel Item*}
               Style:=Bev_Style;
               Co:=Bev_Coul;
               Fill:=Yes;
               Cave:=No;
               End;
         7: With TSB[Pos_ITM[7]] do Begin        {*String Box Item*}
               Style:=Bev_Style;
               Co:=Bev_Coul;
               Cave:=No;
               End;
         8: With TXT[Pos_ITM[8]] do Begin        {*Text Item*}
               CB:=-1;
               CP:=CLText;
               Cin:=Language.Loc(642);
               End;
         9: With IMG[Pos_ITM[9]] do Begin        {*Icon Item*}
               Ox:=0;
               Oy:=0;
               IType:=1;
               Use_MSize:=No;
               Use_Pal:=Yes;
               FName:=Sys.DesktopImage;
               End;
         End;
      End;

   Case I of
      1: CreaItem:=DEFINE_BUTTONS(M,Pos_ITM[1]);
      2: CreaItem:=DEFINE_CYCLERS(M,Pos_ITM[2]);
      3: CreaItem:=DEFINE_RADIOS (M,Pos_ITM[3]);
      4: CreaItem:=DEFINE_SLIDERS(M,Pos_ITM[4]);
      5: CreaItem:=DEFINE_COMMANDS(M,Pos_ITM[5]);
      6: CreaItem:=DEFINE_BEVEL_BOX(M,Pos_ITM[6]);
      7: CreaItem:=DEFINE_STRING_BOX(M,Pos_ITM[7]);
      8: CreaItem:=DEFINE_TEXT(M,Pos_ITM[8]);
      9: CreaItem:=DEFINE_IMAGE(M,Pos_ITM[9]);
      End;

   If CreaItem=False Then Begin                  {*Delete Item*}
      NType:=I; DEL_ITEM(M);                     {*NType = Type de Cration*}
      End
      Else Begin
      REDRAW_WINDOW(M);                          {*Raffiche All Gadgets in Window*}
      TOGGLE_ITEM(I);                            {*Entoure  Nouveau Item*}
      End;
   OType:=I;
   OPos:=Pos_ITM[I];
   NType:=I;                                     {*Dclare New Item as Selected*}
   NPos:=Pos_ITM[I];
   End;
Sys.SetGrid:=No;                                       {*Plus de Grille Gnrale*}
End;

{ Ordre : String, Bevel, Image }

{****************************************************************************}
{****************************************************************************}
{****************************************************************************}

Begin
End.
