{ͻ
                                UNIT MosSound                               
 ͹
  CREATOR....: PLANAS Jean-Pierre                                           
  UPDATED BY.: PLANAS Jean-Pierre                                           
  CREATED THE: 24.01.1996                                                   
  COUNTRY....: Perpignan (FRANCE)                                           
  DESCRIPTION: Management of SOUND BLASTERS Cards.                          
  AUTONOMOUS.: No                                                           
  UNIT SIZE..: 818 Lines and (15.296 Bytes compiled)                        
  LAST UPDATE: 12.12.2001 at 23:25                                          
 ͹
                                 DISCLAIMER                                 
 ͹
    This file is a part of the MOS (Master Operating System) library        
    Copyright (C) 1994-2001 Frdric Cheveau and Jean-Pierre Planas         
                                                                            
    This library is Free software since the 4.00 version. You can           
    redistribute it and / or modify it under the terms of the GNU           
    General Public License as published by the Free Software Foundation.    
                                                                            
    This library is distributed in the hope that it will be useful,         
    but WITHOUT ANY WARRANTY; without even the implied warranty of          
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        
    General Public License for more details. This file should be in         
    the MOS package, if not, write to the Free Software Foundation,         
    Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA           
 ͼ}

UNIT MosSound;
{$MODE objfpc}

INTERFACE

Procedure Play_WAV(FName:String);        {*Play a WAV file on current sound output*}
{*TO IMPLEMENT*}
Procedure Play_WAVSb(FileName:String);   {*Play a WAV file on Sound Blaster*}
{*TO IMPLEMENT*}
Procedure Play_WAVSpeaker(Name:String);  {*Play a WAV file on Speaker*}
Function  Test_WAV(Name:String):Boolean; {*Test if a file is a WAV file*}

Procedure Beep;                          {*Make a sound on speaker*}

{****************************************************************************}

IMPLEMENTATION

Uses
     MosConfig,
     MosCrt,
     MosFiles;

{ͻ
                             FUNCTION TEST_WAV                              
 ͹
  IN.....: Name : (STRING) = Path + Name of the file to test                
  OUT....: (BOOLEAN) = Return TRUE if it's a WAV file.                      
  EXPLAIN: Tet if the file is a wav file.                                   
 ͼ}

Function TEST_WAV(Name:String):Boolean;
begin
TEST_WAV:=File_TestHeader(Name,'RIFF',0);
end;

{ͻ
                        WAV MANAGEMENT ON SPEAKER                           
 ͼ}

{ͻ
                         PROCEDURE Play_WAVSpeaker                          
 ͹
  IN.....: Name : (STRING) = File name                                      
  OUT....: /                                                                
  EXPLAIN: Play a wav file on the PC speaker                                
           If an error is found then Nerror:=805.                           
           805 : Error reading wav                                          
 ͼ}

Procedure Play_WAVSpeaker(Name:String);
Begin
{*TO IMPLEMENT*}
   Name := Name; // To avoid warnings !
End;

{ͻ
                            PROCEDURE Play_WAVSb                            
 ͹
  IN......: Name_File (STRING) = Path + Name of the file to play            
  OUT.....: /                                                               
  EXPLAIN . Play a wav sound file on the sound blaster.                     
  NB......: You must test if the file is a WAV before playing it.           
 ͼ}

Procedure Play_WAVSb(FileName:String);
Begin
{*TO IMPLEMENT*}
   FileName := FileName; // To avoid warnings !
End;

{ͻ
                             PROCEDURE PLAY_WAV                             
 ͹
  IN......: FName (STRING) = Path and File Name of the file to play         
  OUT.....: /                                                               
  EXPLAIN.: Play a wav sound file on the selected output.                   
            Sb or Speaker (Bit 11 of Id_Msg1).                              
  NB......: You must test if the file is a WAV before playing it.           
 ͼ}

Procedure PLAY_WAV(FName:String);
Begin
If Test_WAV(FName) Then
   Begin
   If Id_Msg1 And $800=$800 Then Play_WAVSb(FName) {*Play Sound on SB*}
     Else Play_WAVSpeaker(FName)                   {*Play Sound on Speaker*}
   End;
End;

{ͻ
                               PROCEDURE Beep                               
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Produce a sound modulation.                                      
  EXAMPLE: Beep;                                                            
 ͼ}

Procedure Beep;                        {*Produit sound of PVL Sound BB/AG*}
Begin
   Sound(950);  Delay(45); Nosound; Delay(30);
   Sound(1265); Delay(45); Nosound; Delay(30);
   Sound(970);  Delay(45); Nosound; Delay(30);
   Sound(1270); Delay(45); Nosound; Delay(30);
   Sound(980);  Delay(45); Nosound;
End;

{--------------------------- NO MAIN PROGRAM --------------------------------}

Begin
End.
