unit gditypes;

interface

//uses mwindefs;
(*
CONST
 CF_TEXT             = 1;

 DIB_PAL_COLORS      = 1;
 DIB_RGB_COLORS      = 0;

 GMEM_FIXED          = 0;
 GMEM_MOVEABLE       = 2;
 GPTR = 64;
 GHND = 66;
 GMEM_DDESHARE       = 8192;
 GMEM_DISCARDABLE    = 256;
 GMEM_LOWER          = 4096;
 GMEM_NOCOMPACT      = 16;
 GMEM_NODISCARD      = 32;
 GMEM_NOT_BANKED     = 4096;
 GMEM_NOTIFY         = 16384;
 GMEM_SHARE          = 8192;
 GMEM_ZEROINIT       = 64;
 GMEM_DISCARDED      = 16384;
 GMEM_INVALID_HANDLE = 32768;
 GMEM_LOCKCOUNT      = 255;

 MWMAX_CURSOR_SIZE 	 = 32;
 MWREGION_ERROR	     =  0;
 MWREGION_NULL	     =  1;
 MWREGION_SIMPLE	 =  2;
 MWREGION_COMPLEX    =  3;
 ERRORREGION         = MWREGION_ERROR;
 NULLREGION          = MWREGION_NULL;
 SIMPLEREGION        = MWREGION_SIMPLE;
 COMPLEXREGION       = MWREGION_COMPLEX;
 ERROR			     = ERRORREGION;
 RGN_ERROR		     = ERRORREGION; 

 MWBUTTON_L          = $04;
 MWBUTTON_M          = $02;
 MWBUTTON_R          = $01;

 MK_LBUTTON	         = MWBUTTON_L;
 MK_RBUTTON	         = MWBUTTON_R;
 MK_MBUTTON 	     = MWBUTTON_M;
 
 //* GdRectInRegion return codes*/
 MWRECT_OUT	         =  0;	//* rectangle not in region*/
 MWRECT_ALLIN        =  1;	//* rectangle all in region*/
 MWRECT_PARTIN       =  2;	//* rectangle partly in region*/

 //* GdAllocPolyRegion types*/
 MWPOLY_EVENODD	     =  1;
 MWPOLY_WINDING	     =  2;

 CW_USEDEFAULT       = longint($80000000);
 WS_BORDER           = $800000;
 WS_CAPTION          = $c00000;
 WS_CHILD            = $40000000;
 WS_CHILDWINDOW      = $40000000;
 WS_CLIPCHILDREN     = $2000000;
 WS_CLIPSIBLINGS     = $4000000;
 WS_DISABLED         = $8000000;
 WS_DLGFRAME         = $400000;
 WS_GROUP            = $20000;
 WS_HSCROLL          = $100000;
 WS_ICONIC           = $20000000;
 WS_MAXIMIZE         = $1000000;
 WS_MAXIMIZEBOX      = $10000;
 WS_MINIMIZE         = $20000000;
 WS_MINIMIZEBOX      = $20000;
 WS_OVERLAPPED       = 0;
 WS_OVERLAPPEDWINDOW = $cf0000;
 WS_POPUP            = dword($80000000);
 WS_POPUPWINDOW      = dword($80880000);
 WS_SIZEBOX          = $40000;
 WS_SYSMENU          = $80000;
 WS_TABSTOP          = $10000;
 WS_THICKFRAME       = $40000;
 WS_TILED            = 0;
 WS_TILEDWINDOW      = $cf0000;
 WS_VISIBLE          = $10000000;
 WS_VSCROLL          = $200000;

 WM_RENDERALLFORMATS = 774;
 WM_RENDERFORMAT     = 773;

 CCHDEVICENAME       = 32; 
 CCHFORMNAME         = 32;
 LF_FULLFACESIZE     = 64;
 LF_FACESIZE         = 32;
 
 ELF_VENDOR_SIZE     = 4;
 
 MAX_DEFAULTCHAR     = 2;
 MAX_LEADBYTES       = 12;
 MAX_PATH            = 260;
*) 
const 
 ROP4_MASKBLT        = $AACC0020; //MAKEROP4(SRCCOPY, DSTCOPY) // 0xAACC0020
 
 ROP3Table: array[0..255] of DWORD = 
    (
        $00000042, $00010289,
        $00020C89, $000300AA,
        $00040C88, $000500A9,
        $00060865, $000702C5,
        $00080F08, $00090245,
        $000A0329, $000B0B2A,
        $000C0324, $000D0B25,
        $000E08A5, $000F0001,
        $00100C85, $001100A6,
        $00120868, $001302C8,
        $00140869, $001502C9,
        $00165CCA, $00171D54,
        $00180D59, $00191CC8,
        $001A06C5, $001B0768,
        $001C06CA, $001D0766,
        $001E01A5, $001F0385,
        $00200F09, $00210248,
        $00220326, $00230B24,
        $00240D55, $00251CC5,
        $002606C8, $00271868,
        $00280369, $002916CA,
        $002A0CC9, $002B1D58,
        $002C0784, $002D060A,
        $002E064A, $002F0E2A,
        $0030032A, $00310B28,
        $00320688, $00330008,
        $003406C4, $00351864,
        $003601A8, $00370388,
        $0038078A, $00390604,
        $003A0644, $003B0E24,
        $003C004A, $003D18A4,
        $003E1B24, $003F00EA,
        $00400F0A, $00410249,
        $00420D5D, $00431CC4,
        $00440328, $00450B29,
        $004606C6, $0047076A,
        $00480368, $004916C5,
        $004A0789, $004B0605,
        $004C0CC8, $004D1954,
        $004E0645, $004F0E25,
        $00500325, $00510B26,
        $005206C9, $00530764,
        $005408A9, $00550009,
        $005601A9, $00570389,
        $00580785, $00590609,
        $005A0049, $005B18A9,
        $005C0649, $005D0E29,
        $005E1B29, $005F00E9,
        $00600365, $006116C6,
        $00620786, $00630608,
        $00640788, $00650606,
        $00660046, $006718A8,
        $006858A6, $00690145,
        $006A01E9, $006B178A,
        $006C01E8, $006D1785,
        $006E1E28, $006F0C65,
        $00700CC5, $00711D5C,
        $00720648, $00730E28,
        $00740646, $00750E26,
        $00761B28, $007700E6,
        $007801E5, $00791786,
        $007A1E29, $007B0C68,
        $007C1E24, $007D0C69,
        $007E0955, $007F03C9,
        $008003E9, $00810975,
        $00820C49, $00831E04,
        $00840C48, $00851E05,
        $008617A6, $008701C5,
        $008800C6, $00891B08,
        $008A0E06, $008B0666,
        $008C0E08, $008D0668,
        $008E1D7C, $008F0CE5,
        $00900C45, $00911E08,
        $009217A9, $009301C4,
        $009417AA, $009501C9,
        $00960169, $0097588A,
        $00981888, $00990066,
        $009A0709, $009B07A8,
        $009C0704, $009D07A6,
        $009E16E6, $009F0345,
        $00A000C9, $00A11B05,
        $00A20E09, $00A30669,
        $00A41885, $00A50065,
        $00A60706, $00A707A5,
        $00A803A9, $00A90189,
        $00AA0029, $00AB0889,
        $00AC0744, $00AD06E9,
        $00AE0B06, $00AF0229,
        $00B00E05, $00B10665,
        $00B21974, $00B30CE8,
        $00B4070A, $00B507A9,
        $00B616E9, $00B70348,
        $00B8074A, $00B906E6,
        $00BA0B09, $00BB0226,
        $00BC1CE4, $00BD0D7D,
        $00BE0269, $00BF08C9,
        $00C000CA, $00C11B04,
        $00C21884, $00C3006A,
        $00C40E04, $00C50664,
        $00C60708, $00C707AA,
        $00C803A8, $00C90184,
        $00CA0749, $00CB06E4,
        $00CC0020, $00CD0888,
        $00CE0B08, $00CF0224,
        $00D00E0A, $00D1066A,
        $00D20705, $00D307A4,
        $00D41D78, $00D50CE9,
        $00D616EA, $00D70349,
        $00D80745, $00D906E8,
        $00DA1CE9, $00DB0D75,
        $00DC0B04, $00DD0228,
        $00DE0268, $00DF08C8,
        $00E003A5, $00E10185,
        $00E20746, $00E306EA,
        $00E40748, $00E506E5,
        $00E61CE8, $00E70D79,
        $00E81D74, $00E95CE6,
        $00EA02E9, $00EB0849,
        $00EC02E8, $00ED0848,
        $00EE0086, $00EF0A08,
        $00F00021, $00F10885,
        $00F20B05, $00F3022A,
        $00F40B0A, $00F50225,
        $00F60265, $00F708C5,
        $00F802E5, $00F90845,
        $00FA0089, $00FB0A09,
        $00FC008A, $00FD0A0A,
        $00FE02A9, $00FF0062
    );

 
 
(*
type PVOID = Pointer;
     LPVOID = PVOID;

type UShort = byte;
type short = SmallInt;
type LONG = LONGINT;
type INT = LONG;
type int32_t = Longint;
type uint32_t = Cardinal;
type PSHORT = ^short;  
type PLONG = ^long;    
type UCHAR = Byte;
//type USHORT = Word;
type ULONG = LongWord;
type SIZE_T = ULONG;
type UINT = Cardinal;
type DWORD = LongWord;
type PDWORD = ^DWORD;
type LPWORD = PDWORD;
type BOOL = LONGBOOL;
type WINBOOL = LONGBOOL;
type PULONG  = ^ULONG;
type ULONG_PTR = PULONG;
type PUSHORT = ^USHORT;
type PUCHAR = ^UCHAR;
type PWChar = ^WideChar;
type PSZ = ^PChar;
type PUINT = ^UINT;
type float = Double;
type PFLOAT  = ^float;
type PBOOL   = ^BOOL;
type LPBOOL  = PBOOL;
type PBYTE   = ^Byte;
type LPBYTE  = PBYTE;
type PINT    = ^Integer;
type LPINT   = PINT;
type PWORD   = ^Word;
{
type LPWORD  = PWORD;
type LPLONG  = ^LONG;
type PDWORD  = ^DWORD;
}
type LPDWORD = PDWORD;
type LPCVOID = Pointer;

type WCHAR  = USHORT;
type BCHAR  = Byte;
//type PWCHAR = ^WCHAR;
type LPWCH  = PWCHAR; 
type PWCH = PWCHAR;
type LPCWCH = PWCHAR; 
type PCWCH = PWCHAR;
type NWPSTR = PWCHAR;
type LPWSTR = PWCHAR;
type PWSTR = PWCHAR;
type LPCWSTR = PWCHAR;
type PCWSTR = PWCHAR;


type LPCH = PChar;
type PCH = PChar;
type LPCCH = PChar; 
type PCCH = LPCCH;
type NPSTR = PChar;
type LPSTR = NPSTR;
type PSTR = LPSTR;
type LPCSTR = PSTR;

type TCHAR = Char;
type PTCHAR = ^TChar;

type TBYTE = UCHAR; 
type PTBYTE = ^TByte;

type 
  LPTCH = LPSTR;
  PTCH  = LPSTR;
  
type 
  PTSTR = LPSTR; 
  LPTSTR = LPSTR;
  
type LPCTSTR = LPCSTR;
type WPARAM  = UINT;
type LPARAM  = LONG;
type LRESULT = LONG;
type HRESULT = LONG;

type COLORREF = DWORD;
type LPCOLORREF = ^COLORREF;
type HANDLE = Cardinal;
type THANDLE = Longint;
type PHANDLE = ^HANDLE;
type LPHANDLE = PHANDLE;
type SPHANDLE = PHANDLE;
type HGLOBAL = HANDLE;
type HLOCAL = HANDLE;
type GLOBALHANDLE = HANDLE;
type LOCALHANDLE = HANDLE;
type GDICOORD = Long;
type HFONT = HANDLE;
type HBITMAP = HANDLE;
type HPEN = HANDLE;
type HRGN = HANDLE;
*)
(*
type 
  ATOM         = Word;
  HICON     = HANDLE;
  HINSTANCE = HANDLE;
  HMODULE   = HANDLE;
  HMENU     = HANDLE;
  HBRUSH    = HANDLE;
  SIZE = record
          cx : LONG;
          cy : LONG;
       end;
  LPSIZE = ^SIZE;
  tagSIZE = SIZE;
  TSIZE = SIZE;
  PSIZE = ^SIZE;

  PHGDIOBJ  = ^HGDIOBJ;
  PHBRUSH   = PHGDIOBJ{^HBRUSH};
  PHPEN     = PHGDIOBJ{^HPEN};  
  PHFONT    = PHGDIOBJ{^HFONT};
  PHBITMAP  = PHGDIOBJ{^HBITMAP};
  PHRGN     = PHGDIOBJ{^HRGN};
  PHPALETTE = PHGDIOBJ{^HPALETTE}; 
 *)


{$define read_interface}
{$i gdi_base.inc}
{$i gdi_defines.inc}
{$i gdi_struct.inc}
{$i gdi_msg.inc}
{$i gdi_errors.inc}


implementation

{$undef read_interface}
{$define read_implementation}
{$i gdi_base.inc}
{$i gdi_defines.inc}
{$i gdi_struct.inc}
{$i gdi_msg.inc}

end.
